--[[ ==

  Title: Insert Groups & Tracks per Colors
 Author: Raul [ulneiz]
Version: 2.0 "floating window" (Renoise 3.1 compatible)
   Menu: Pattern Editor \ Insert Groups & Tracks per Colors ... 

 Colors: Aqua aq , Black bk , Blue bl , Brown br , Gold gl , Gray gy , Green gr , Orange or , Pale Pink pl , Pink pn , Pistachio ps , Red rd , Sky Blue sk , Violet vl , White wh , Yellow yl

== ]]--



  --[[ == Tracks AQUA Color aq == ]]--
local aqua = {}
  aqua.zero = { 0x2A,0xAA,0x9D }
  aqua.one  = { 0x1A,0x9A,0x8D }
  aqua.two  = { 0x00,0x5A,0x4D }

local taq = {}
  taq.one   = { color = aqua.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Aqua Track' }
  taq.two   = { color = aqua.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Aqua Track' }
  taq.three = { color = aqua.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Aqua Track' }
  taq.four  = { color = aqua.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Aqua Track' }
  taq.five  = { color = aqua.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Aqua Track' }
  taq.six   = { color = aqua.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Aqua Track' }
  taq.seven = { color = aqua.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Aqua Track' }
  taq.eight = { color = aqua.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Aqua Track' }
  taq.a1    = { color = aqua.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Aqua Track' }
  taq.a2    = { color = aqua.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Aqua Track' }

local track_aqua = {}
  track_aqua.one   = { taq.one }
  track_aqua.two   = { taq.one , taq.two }
  track_aqua.three = { taq.one , taq.two , taq.a1 }
  track_aqua.four  = { taq.one , taq.two , taq.three , taq.a2 }
  track_aqua.five  = { taq.one , taq.two , taq.three , taq.four , taq.a1 }
  track_aqua.six   = { taq.one , taq.two , taq.three , taq.four , taq.five , taq.a2 }
  track_aqua.seven = { taq.one , taq.two , taq.three , taq.four , taq.five , taq.six , taq.a1 }
  track_aqua.eight = { taq.one , taq.two , taq.three , taq.four , taq.five , taq.six , taq.seven , taq.a2 }
 track_aqua.eight2 = { taq.one , taq.two , taq.three , taq.four , taq.five , taq.six , taq.seven , taq.eight }


  --[[ == Tracks BLACK Color bk == ]]--
local black = {}
  black.zero = { 0x00,0x00,0x00 }
  black.one  = { 0x54,0x54,0x54 }
  black.two  = { 0x20,0x20,0x20 }

local tbk = {}
  tbk.one   = { color = black.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Black Track' }
  tbk.two   = { color = black.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Black Track' }
  tbk.three = { color = black.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Black Track' }
  tbk.four  = { color = black.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Black Track' }
  tbk.five  = { color = black.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Black Track' }
  tbk.six   = { color = black.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Black Track' }
  tbk.seven = { color = black.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Black Track' }
  tbk.eight = { color = black.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Black Track' }
  tbk.a1    = { color = black.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Black Track' }
  tbk.a2    = { color = black.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Black Track' }

local track_black = {}
  track_black.one   = { tbk.one }
  track_black.two   = { tbk.one , tbk.two }
  track_black.three = { tbk.one , tbk.two , tbk.a1 }
  track_black.four  = { tbk.one , tbk.two , tbk.three , tbk.a2 }
  track_black.five  = { tbk.one , tbk.two , tbk.three , tbk.four , tbk.a1 }
  track_black.six   = { tbk.one , tbk.two , tbk.three , tbk.four , tbk.five , tbk.a2 }
  track_black.seven = { tbk.one , tbk.two , tbk.three , tbk.four , tbk.five , tbk.six , tbk.a1 }
  track_black.eight = { tbk.one , tbk.two , tbk.three , tbk.four , tbk.five , tbk.six , tbk.seven , tbk.a2 }
 track_black.eight2 = { tbk.one , tbk.two , tbk.three , tbk.four , tbk.five , tbk.six , tbk.seven , tbk.eight }


  --[[ == Tracks BLUE Color bl == ]]--
local blue = {}
  blue.zero = { 0x00,0x60,0xFF }
  blue.one  = { 0x00,0x44,0xFF }
  blue.two  = { 0x2A,0x3C,0xAA }

local tbl = {}
  tbl.one   = { color = blue.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Blue Track' }
  tbl.two   = { color = blue.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Blue Track' }
  tbl.three = { color = blue.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Blue Track' }
  tbl.four  = { color = blue.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Blue Track' }
  tbl.five  = { color = blue.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Blue Track' }
  tbl.six   = { color = blue.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Blue Track' }
  tbl.seven = { color = blue.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Blue Track' }
  tbl.eight = { color = blue.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Blue Track' }
  tbl.a1    = { color = blue.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Blue Track' }
  tbl.a2    = { color = blue.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Blue Track' }

local track_blue = {}
  track_blue.one   = { tbl.one }
  track_blue.two   = { tbl.one , tbl.two }
  track_blue.three = { tbl.one , tbl.two , tbl.a1 }
  track_blue.four  = { tbl.one , tbl.two , tbl.three , tbl.a2 }
  track_blue.five  = { tbl.one , tbl.two , tbl.three , tbl.four , tbl.a1 }
  track_blue.six   = { tbl.one , tbl.two , tbl.three , tbl.four , tbl.five , tbl.a2 }
  track_blue.seven = { tbl.one , tbl.two , tbl.three , tbl.four , tbl.five , tbl.six , tbl.a1 }
  track_blue.eight = { tbl.one , tbl.two , tbl.three , tbl.four , tbl.five , tbl.six , tbl.seven , tbl.a2 }
 track_blue.eight2 = { tbl.one , tbl.two , tbl.three , tbl.four , tbl.five , tbl.six , tbl.seven , tbl.eight }


  --[[ == Tracks BROWN Color br == ]]--
local brown = {}
  brown.zero = { 0xA9,0x5D,0x10 }
  brown.one  = { 0x99,0x4D,0x00 }
  brown.two  = { 0x40,0x00,0x00 }

local tbr = {}
  tbr.one   = { color = brown.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Brown Track' }
  tbr.two   = { color = brown.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Brown Track' }
  tbr.three = { color = brown.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Brown Track' }
  tbr.four  = { color = brown.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Brown Track' }
  tbr.five  = { color = brown.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Brown Track' }
  tbr.six   = { color = brown.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Brown Track' }
  tbr.seven = { color = brown.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Brown Track' }
  tbr.eight = { color = brown.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Brown Track' }
  tbr.a1    = { color = brown.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Brown Track' }
  tbr.a2    = { color = brown.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Brown Track' }

local track_brown = {}
  track_brown.one   = { tbr.one }
  track_brown.two   = { tbr.one , tbr.two }
  track_brown.three = { tbr.one , tbr.two , tbr.a1 }
  track_brown.four  = { tbr.one , tbr.two , tbr.three , tbr.a2 }
  track_brown.five  = { tbr.one , tbr.two , tbr.three , tbr.four , tbr.a1 }
  track_brown.six   = { tbr.one , tbr.two , tbr.three , tbr.four , tbr.five , tbr.a2 }
  track_brown.seven = { tbr.one , tbr.two , tbr.three , tbr.four , tbr.five , tbr.six , tbr.a1 }
  track_brown.eight = { tbr.one , tbr.two , tbr.three , tbr.four , tbr.five , tbr.six , tbr.seven , tbr.a2 }
 track_brown.eight2 = { tbr.one , tbr.two , tbr.three , tbr.four , tbr.five , tbr.six , tbr.seven , tbr.eight }


  --[[ == Tracks GOLD Color gl == ]]--
local gold = {}
  gold.zero = { 0xFF,0xB5,0x23 }
  gold.one  = { 0xEF,0xA5,0x13 }
  gold.two  = { 0xAF,0x5B,0x00 }

local tgl = {}
  tgl.one    = { color = gold.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Gold Track' }
  tgl.two    = { color = gold.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Gold Track' }
  tgl.three  = { color = gold.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Gold Track' }
  tgl.four   = { color = gold.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Gold Track' }
  tgl.five   = { color = gold.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Gold Track' }
  tgl.six    = { color = gold.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Gold Track' }
  tgl.seven  = { color = gold.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Gold Track' }
  tgl.eight  = { color = gold.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Gold Track' }
  tgl.a1     = { color = gold.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Gold Track' }
  tgl.a2     = { color = gold.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Gold Track' }

local track_gold = {}
  track_gold.one   = { tgl.one }
  track_gold.two   = { tgl.one , tgl.two }
  track_gold.three = { tgl.one , tgl.two , tgl.a1 }
  track_gold.four  = { tgl.one , tgl.two , tgl.three , tgl.a2 }
  track_gold.five  = { tgl.one , tgl.two , tgl.three , tgl.four , tgl.a1 }
  track_gold.six   = { tgl.one , tgl.two , tgl.three , tgl.four , tgl.five , tgl.a2 }
  track_gold.seven = { tgl.one , tgl.two , tgl.three , tgl.four , tgl.five , tgl.six , tgl.a1 }
  track_gold.eight = { tgl.one , tgl.two , tgl.three , tgl.four , tgl.five , tgl.six , tgl.seven , tgl.a2 }
 track_gold.eight2 = { tgl.one , tgl.two , tgl.three , tgl.four , tgl.five , tgl.six , tgl.seven , tgl.eight }


  --[[ == Tracks GRAY Color gy ==]]--
local gray = {}
  gray.zero = { 0x80,0x80,0x80 }
  gray.one  = { 0x70,0x70,0x70 }
  gray.two  = { 0x40,0x40,0x40 }

local tgy = {}
  tgy.one   = { color = gray.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Gray Track' }
  tgy.two   = { color = gray.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Gray Track' }
  tgy.three = { color = gray.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Gray Track' }
  tgy.four  = { color = gray.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Gray Track' }
  tgy.five  = { color = gray.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Gray Track' }
  tgy.six   = { color = gray.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Gray Track' }
  tgy.seven = { color = gray.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Gray Track' }
  tgy.eight = { color = gray.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Gray Track' }
  tgy.a1    = { color = gray.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Gray Track' }
  tgy.a2    = { color = gray.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Gray Track' }

local track_gray = {}
  track_gray.one   = { tgy.one }
  track_gray.two   = { tgy.one , tgy.two }
  track_gray.three = { tgy.one , tgy.two , tgy.a1 }
  track_gray.four  = { tgy.one , tgy.two , tgy.three , tgy.a2 }
  track_gray.five  = { tgy.one , tgy.two , tgy.three , tgy.four , tgy.a1 }
  track_gray.six   = { tgy.one , tgy.two , tgy.three , tgy.four , tgy.five , tgy.a2 }
  track_gray.seven = { tgy.one , tgy.two , tgy.three , tgy.four , tgy.five , tgy.six , tgy.a1 }
  track_gray.eight = { tgy.one , tgy.two , tgy.three , tgy.four , tgy.five , tgy.six , tgy.seven , tgy.a2 }
 track_gray.eight2 = { tgy.one , tgy.two , tgy.three , tgy.four , tgy.five , tgy.six , tgy.seven , tgy.eight }


  --[[ == Tracks GREEN Color gr == ]]--
local green = {}
  green.zero = { 0x00,0xFF,0x2A }
  green.one  = { 0x00,0x99,0x19 }
  green.two  = { 0x00,0x40,0x19 }

local tgr = {}
  tgr.one   = { color = green.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Green Track' }
  tgr.two   = { color = green.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Green Track' }
  tgr.three = { color = green.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Green Track' }
  tgr.four  = { color = green.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Green Track' }
  tgr.five  = { color = green.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Green Track' }
  tgr.six   = { color = green.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Green Track' }
  tgr.seven = { color = green.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Green Track' }
  tgr.eight = { color = green.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Green Track' }
  tgr.a1    = { color = green.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Green Track' }
  tgr.a2    = { color = green.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Green Track' }

local track_green = {}
  track_green.one   = { tgr.one }
  track_green.two   = { tgr.one , tgr.two }
  track_green.three = { tgr.one , tgr.two , tgr.a1 }
  track_green.four  = { tgr.one , tgr.two , tgr.three , tgr.a2 }
  track_green.five  = { tgr.one , tgr.two , tgr.three , tgr.four , tgr.a1 }
  track_green.six   = { tgr.one , tgr.two , tgr.three , tgr.four , tgr.five , tgr.a2 }
  track_green.seven = { tgr.one , tgr.two , tgr.three , tgr.four , tgr.five , tgr.six , tgr.a1 }
  track_green.eight = { tgr.one , tgr.two , tgr.three , tgr.four , tgr.five , tgr.six , tgr.seven , tgr.a2 }
 track_green.eight2 = { tgr.one , tgr.two , tgr.three , tgr.four , tgr.five , tgr.six , tgr.seven , tgr.eight }


  --[[ == Tracks ORANGE Color or == ]]--
local orange = {}
  orange.zero = { 0xFF,0x80,0x00 }
  orange.one  = { 0xEE,0x70,0x00 }
  orange.two  = { 0x90,0x45,0x00 }

local tor = {}
  tor.one   = { color = orange.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Orange Track' }
  tor.two   = { color = orange.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Orange Track' }
  tor.three = { color = orange.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Orange Track' }
  tor.four  = { color = orange.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Orange Track' }
  tor.five  = { color = orange.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Orange Track' }
  tor.six   = { color = orange.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Orange Track' }
  tor.seven = { color = orange.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Orange Track' }
  tor.eight = { color = orange.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Orange Track' }
  tor.a1    = { color = orange.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Orange Track' }
  tor.a2    = { color = orange.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Orange Track' }

local track_orange = {}
  track_orange.one   = { tor.one }
  track_orange.two   = { tor.one , tor.two }
  track_orange.three = { tor.one , tor.two , tor.a1 }
  track_orange.four  = { tor.one , tor.two , tor.three , tor.a2 }
  track_orange.five  = { tor.one , tor.two , tor.three , tor.four , tor.a1 }
  track_orange.six   = { tor.one , tor.two , tor.three , tor.four , tor.five , tor.a2 }
  track_orange.seven = { tor.one , tor.two , tor.three , tor.four , tor.five , tor.six , tor.a1 }
  track_orange.eight = { tor.one , tor.two , tor.three , tor.four , tor.five , tor.six , tor.seven , tor.a2 }
 track_orange.eight2 = { tor.one , tor.two , tor.three , tor.four , tor.five , tor.six , tor.seven , tor.eight }


  --[[ == Tracks PALE PINK Color pl == ]]--
local pale = {}
  pale.zero = { 0xF4,0xA1,0xD9 }
  pale.one  = { 0xE4,0xB1,0xC9 }
  pale.two  = { 0xA4,0x61,0x79 }

local tpl = {}
  tpl.one   = { color = pale.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Pale Pink Track' }
  tpl.two   = { color = pale.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Pale Pink Track' }
  tpl.three = { color = pale.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Pale Pink Track' }
  tpl.four  = { color = pale.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Pale Pink Track' }
  tpl.five  = { color = pale.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Pale Pink Track' }
  tpl. six  = { color = pale.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Pale Pink Track' }
  tpl.seven = { color = pale.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Pale Pink Track' }
  tpl.eight = { color = pale.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Pale Pink Track' }
  tpl.a1    = { color = pale.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Pale Pink Track' }
  tpl.a2    = { color = pale.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Pale Pink Track' }

local track_pale = {}
  track_pale.one   = { tpl.one }
  track_pale.two   = { tpl.one , tpl.two }
  track_pale.three = { tpl.one , tpl.two , tpl.a1 }
  track_pale.four  = { tpl.one , tpl.two , tpl.three , tpl.a2 }
  track_pale.five  = { tpl.one , tpl.two , tpl.three , tpl.four , tpl.a1 }
  track_pale.six   = { tpl.one , tpl.two , tpl.three , tpl.four , tpl.five , tpl.a2 }
  track_pale.seven = { tpl.one , tpl.two , tpl.three , tpl.four , tpl.five , tpl.six , tpl.a1 }
  track_pale.eight = { tpl.one , tpl.two , tpl.three , tpl.four , tpl.five , tpl.six , tpl.seven , tpl.a2 }
 track_pale.eight2 = { tpl.one , tpl.two , tpl.three , tpl.four , tpl.five , tpl.six , tpl.seven , tpl.eight }


  --[[ == Tracks PINK Color pn == ]]--
local pink = {}
  pink.zero = { 0xFF,0x00,0xAA }
  pink.one  = { 0xE0,0x00,0x90 }
  pink.two  = { 0x5D,0x00,0x27 }

local tpn = {}
  tpn.one   = { color = pink.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Pink Track' }
  tpn.two   = { color = pink.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Pink Track' }
  tpn.three = { color = pink.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Pink Track' }
  tpn.four  = { color = pink.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Pink Track' }
  tpn.five  = { color = pink.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Pink Track' }
  tpn. six  = { color = pink.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Pink Track' }
  tpn.seven = { color = pink.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Pink Track' }
  tpn.eight = { color = pink.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Pink Track' }
  tpn.a1    = { color = pink.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Pink Track' }
  tpn.a2    = { color = pink.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Pink Track' }

local track_pink = {}
  track_pink.one   = { tpn.one }
  track_pink.two   = { tpn.one , tpn.two }
  track_pink.three = { tpn.one , tpn.two , tpn.a1 }
  track_pink.four  = { tpn.one , tpn.two , tpn.three , tpn.a2 }
  track_pink.five  = { tpn.one , tpn.two , tpn.three , tpn.four , tpn.a1 }
  track_pink.six   = { tpn.one , tpn.two , tpn.three , tpn.four , tpn.five , tpn.a2 }
  track_pink.seven = { tpn.one , tpn.two , tpn.three , tpn.four , tpn.five , tpn.six , tpn.a1 }
  track_pink.eight = { tpn.one , tpn.two , tpn.three , tpn.four , tpn.five , tpn.six , tpn.seven , tpn.a2 }
 track_pink.eight2 = { tpn.one , tpn.two , tpn.three , tpn.four , tpn.five , tpn.six , tpn.seven , tpn.eight }


  --[[ == Tracks PISTACHIO Color ps == ]]--
local pistachio = {}
  pistachio.zero = { 0x80,0xFF,0x95 }
  pistachio.one  = { 0x70,0xEF,0x85 }
  pistachio.two  = { 0x20,0x9F,0x35 }

local tps = {}
  tps.one   = { color = pistachio.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Pistachio Track' }
  tps.two   = { color = pistachio.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Pistachio Track' }
  tps.three = { color = pistachio.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Pistachio Track' }
  tps.four  = { color = pistachio.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Pistachio Track' }
  tps.five  = { color = pistachio.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Pistachio Track' }
  tps.six   = { color = pistachio.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Pistachio Track' }
  tps.seven = { color = pistachio.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Pistachio Track' }
  tps.eight = { color = pistachio.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Pistachio Track' }
  tps.a1    = { color = pistachio.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Pistachio Track' }
  tps.a2    = { color = pistachio.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Pistachio Track' }

local track_pistachio = {}
  track_pistachio.one   = { tps.one }
  track_pistachio.two   = { tps.one , tps.two }
  track_pistachio.three = { tps.one , tps.two , tps.a1 }
  track_pistachio.four  = { tps.one , tps.two , tps.three , tps.a2 }
  track_pistachio.five  = { tps.one , tps.two , tps.three , tps.four , tps.a1 }
  track_pistachio.six   = { tps.one , tps.two , tps.three , tps.four , tps.five , tps.a2 }
  track_pistachio.seven = { tps.one , tps.two , tps.three , tps.four , tps.five , tps.six , tps.a1 }
  track_pistachio.eight = { tps.one , tps.two , tps.three , tps.four , tps.five , tps.six , tps.seven , tps.a2 }
 track_pistachio.eight2 = { tps.one , tps.two , tps.three , tps.four , tps.five , tps.six , tps.seven , tps.eight }


  --[[ == Tracks RED Color rd == ]]--
local red = {}
  red.zero = { 0xFF,0x00,0x00 }
  red.one  = { 0xCC,0x00,0x00 }
  red.two  = { 0x60,0x00,0x00 }

local trd = {}
  -- panning_column_visible , delay_column_visible , sample_effects_column_visible (true / false)
  trd.one   = { color = red.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Red Track' }
  trd.two   = { color = red.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Red Track' }
  trd.three = { color = red.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Red Track' }
  trd.four  = { color = red.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Red Track' }
  trd.five  = { color = red.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Red Track' }
  trd.six   = { color = red.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Red Track' }
  trd.seven = { color = red.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Red Track' }
  trd.eight = { color = red.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Red Track' }
  trd.a1    = { color = red.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Red Track' }
  trd.a2    = { color = red.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Red Track' }

local track_red = {}
  track_red.one   = { trd.one }
  track_red.two   = { trd.one , trd.two }
  track_red.three = { trd.one , trd.two , trd.a1 }
  track_red.four  = { trd.one , trd.two , trd.three , trd.a2 }
  track_red.five  = { trd.one , trd.two , trd.three , trd.four , trd.a1 }
  track_red.six   = { trd.one , trd.two , trd.three , trd.four , trd.five , trd.a2 }
  track_red.seven = { trd.one , trd.two , trd.three , trd.four , trd.five , trd.six , trd.a1 }
  track_red.eight = { trd.one , trd.two , trd.three , trd.four , trd.five , trd.six , trd.seven , trd.a2 }
 track_red.eight2 = { trd.one , trd.two , trd.three , trd.four , trd.five , trd.six , trd.seven , trd.eight }


  --[[ == Tracks SKY BLUE Color sk == ]]--
local sky = {}
  sky.zero = { 0x00,0xCC,0xFF }
  sky.one  = { 0x00,0xDD,0xEE }
  sky.two  = { 0x00,0x89,0x9A }

local tsk = {}
  -- panning_column_visible , delay_column_visible , sample_effects_column_visible (true / false)
  tsk.one   = { color = sky.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Sky Blue Track' }
  tsk.two   = { color = sky.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Sky Blue Track' }
  tsk.three = { color = sky.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Sky Blue Track' }
  tsk.four  = { color = sky.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Sky Blue Track' }
  tsk.five  = { color = sky.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Sky Blue Track' }
  tsk.six   = { color = sky.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Sky Blue Track' }
  tsk.seven = { color = sky.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Sky Blue Track' }
  tsk.eight = { color = sky.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Sky Blue Track' }
  tsk.a1    = { color = sky.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Sky Blue Track' }
  tsk.a2    = { color = sky.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Sky Blue Track' }

local track_sky = {}
  track_sky.one   = { tsk.one }
  track_sky.two   = { tsk.one , tsk.two }
  track_sky.three = { tsk.one , tsk.two , tsk.a1 }
  track_sky.four  = { tsk.one , tsk.two , tsk.three , tsk.a2 }
  track_sky.five  = { tsk.one , tsk.two , tsk.three , tsk.four , tsk.a1 }
  track_sky.six   = { tsk.one , tsk.two , tsk.three , tsk.four , tsk.five , tsk.a2 }
  track_sky.seven = { tsk.one , tsk.two , tsk.three , tsk.four , tsk.five , tsk.six , tsk.a1 }
  track_sky.eight = { tsk.one , tsk.two , tsk.three , tsk.four , tsk.five , tsk.six , tsk.seven , tsk.a2 }
 track_sky.eight2 = { tsk.one , tsk.two , tsk.three , tsk.four , tsk.five , tsk.six , tsk.seven , tsk.eight }



  --[[ == Tracks VIOLET Color vl == ]]--
local violet = {}
  violet.zero = { 0x8C,0x00,0xFF }
  violet.one  = { 0x81,0x00,0xEB }
  violet.two  = { 0x4C,0x00,0x90 }

local tvl = {}
  tvl.one   = { color = violet.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Violet Track' }
  tvl.two   = { color = violet.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Violet Track' }
  tvl.three = { color = violet.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Violet Track' }
  tvl.four  = { color = violet.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Violet Track' }
  tvl.five  = { color = violet.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Violet Track' }
  tvl.six   = { color = violet.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Violet Track' }
  tvl.seven = { color = violet.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Violet Track' }
  tvl.eight = { color = violet.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Violet Track' }
  tvl.a1    = { color = violet.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Violet Track' }
  tvl.a2    = { color = violet.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Violet Track' }

local track_violet = {}
  track_violet.one   = { tvl.one }
  track_violet.two   = { tvl.one , tvl.two }
  track_violet.three = { tvl.one , tvl.two , tvl.a1 }
  track_violet.four  = { tvl.one , tvl.two , tvl.three , tvl.a2 }
  track_violet.five  = { tvl.one , tvl.two , tvl.three , tvl.four , tvl.a1 }
  track_violet.six   = { tvl.one , tvl.two , tvl.three , tvl.four , tvl.five , tvl.a2 }
  track_violet.seven = { tvl.one , tvl.two , tvl.three , tvl.four , tvl.five , tvl.six , tvl.a1 }
  track_violet.eight = { tvl.one , tvl.two , tvl.three , tvl.four , tvl.five , tvl.six , tvl.seven , tvl.a2 }
 track_violet.eight2 = { tvl.one , tvl.two , tvl.three , tvl.four , tvl.five , tvl.six , tvl.seven , tvl.eight }


  --[[ == Tracks WHITE Color wh == ]]--
local white = {}
  white.zero = { 0xFF,0xFF,0xFF }
  white.one  = { 0xF1,0xF1,0xF1 }
  white.two  = { 0x60,0x60,0x60 }

local twh = {}
  twh.one   = { color = white.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 White Track' }
  twh.two   = { color = white.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 White Track' }
  twh.three = { color = white.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 White Track' }
  twh.four  = { color = white.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 White Track' }
  twh.five  = { color = white.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 White Track' }
  twh.six   = { color = white.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 White Track' }
  twh.seven = { color = white.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 White Track' }
  twh.eight = { color = white.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 White Track' }
  twh.a1    = { color = white.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux White Track' }
  twh.a2    = { color = white.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux White Track' }

local track_white = {}
  track_white.one   = { twh.one }
  track_white.two   = { twh.one , twh.two }
  track_white.three = { twh.one , twh.two , twh.a1 }
  track_white.four  = { twh.one , twh.two , twh.three , twh.a2 }
  track_white.five  = { twh.one , twh.two , twh.three , twh.four , twh.a1 }
  track_white.six   = { twh.one , twh.two , twh.three , twh.four , twh.five , twh.a2 }
  track_white.seven = { twh.one , twh.two , twh.three , twh.four , twh.five , twh.six , twh.a1 }
  track_white.eight = { twh.one , twh.two , twh.three , twh.four , twh.five , twh.six , twh.seven , twh.a2 }
 track_white.eight2 = { twh.one , twh.two , twh.three , twh.four , twh.five , twh.six , twh.seven , twh.eight }


  --[[ == Tracks YELLOW Color yl == ]]--
local yellow = {}
  yellow.zero = { 0xFF,0xFF,0x00 }
  yellow.one  = { 0xD1,0xD1,0x00 }
  yellow.two  = { 0x61,0x61,0x00 }

local tyl = {}
  tyl.one   = { color = yellow.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '01 Yellow Track' }
  tyl.two   = { color = yellow.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '02 Yellow Track' }
  tyl.three = { color = yellow.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '03 Yellow Track' }
  tyl.four  = { color = yellow.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '04 Yellow Track' }
  tyl.five  = { color = yellow.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '05 Yellow Track' }
  tyl.six   = { color = yellow.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '06 Yellow Track' }
  tyl.seven = { color = yellow.one , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '07 Yellow Track' }
  tyl.eight = { color = yellow.two , color_blend = 10 , volume_column_visible = true , collapsed = false , name = '08 Yellow Track' }
  tyl.a1    = { color = yellow.one , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Yellow Track' }
  tyl.a2    = { color = yellow.two , color_blend = 10 , volume_column_visible = true , collapsed = true ,  name = 'Aux Yellow Track' }

local track_yellow = {}
  track_yellow.one   = { tyl.one }
  track_yellow.two   = { tyl.one , tyl.two }
  track_yellow.three = { tyl.one , tyl.two , tyl.a1 }
  track_yellow.four  = { tyl.one , tyl.two , tyl.three , tyl.a2 }
  track_yellow.five  = { tyl.one , tyl.two , tyl.three , tyl.four , tyl.a1 }
  track_yellow.six   = { tyl.one , tyl.two , tyl.three , tyl.four , tyl.five , tyl.a2 }
  track_yellow.seven = { tyl.one , tyl.two , tyl.three , tyl.four , tyl.five , tyl.six , tyl.a1 }
  track_yellow.eight = { tyl.one , tyl.two , tyl.three , tyl.four , tyl.five , tyl.six , tyl.seven , tyl.a2 }
 track_yellow.eight2 = { tyl.one , tyl.two , tyl.three , tyl.four , tyl.five , tyl.six , tyl.seven , tyl.eight }




--[[ ============================== SUBGROUPS COLOLRS ======================================= ]]--

local sgroup_settings = {

  --[[ == SubGroups AQUA Color aq == ]]--
    sgroup_one_aqua = { color = aqua.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Aqua Track' ,  tracks = track_aqua.one } ,
    sgroup_two_aqua = { color = aqua.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Aqua Tracks' , tracks = track_aqua.two } ,
  sgroup_three_aqua = { color = aqua.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Aqua Tracks' , tracks = track_aqua.three } ,
   sgroup_four_aqua = { color = aqua.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Aqua Tracks' , tracks = track_aqua.four } ,
   sgroup_five_aqua = { color = aqua.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Aqua Tracks' , tracks = track_aqua.five } ,
    sgroup_six_aqua = { color = aqua.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Aqua Tracks' , tracks = track_aqua.six } ,
  sgroup_seven_aqua = { color = aqua.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Aqua Tracks' , tracks = track_aqua.seven } ,
  sgroup_eight_aqua = { color = aqua.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Aqua Tracks' , tracks = track_aqua.eight } ,
 sgroup_eight2_aqua = { color = aqua.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Aqua Tracks' , tracks = track_aqua.eight2 } ,

  --[[ == SubGroups BLACK Color bk == ]]--
    sgroup_one_black = { color = black.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Black Track' ,  tracks = track_black.one } ,
    sgroup_two_black = { color = black.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Black Tracks' , tracks = track_black.two } ,
  sgroup_three_black = { color = black.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Black Tracks' , tracks = track_black.three } ,
   sgroup_four_black = { color = black.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Black Tracks' , tracks = track_black.four } ,
   sgroup_five_black = { color = black.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Black Tracks' , tracks = track_black.five } ,
    sgroup_six_black = { color = black.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Black Tracks' , tracks = track_black.six } ,
  sgroup_seven_black = { color = black.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Black Tracks' , tracks = track_black.seven } ,
  sgroup_eight_black = { color = black.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Black Tracks' , tracks = track_black.eight } ,
 sgroup_eight2_black = { color = black.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Black Tracks' , tracks = track_black.eight2 } ,

  --[[ == SubGroups BLUE Color bl == ]]--
    sgroup_one_blue = { color = blue.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Blue Track' ,  tracks = track_blue.one } ,
    sgroup_two_blue = { color = blue.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Blue Tracks' , tracks = track_blue.two } ,
  sgroup_three_blue = { color = blue.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Blue Tracks' , tracks = track_blue.three } ,
   sgroup_four_blue = { color = blue.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Blue Tracks' , tracks = track_blue.four } ,
   sgroup_five_blue = { color = blue.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Blue Tracks' , tracks = track_blue.five } ,
    sgroup_six_blue = { color = blue.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Blue Tracks' , tracks = track_blue.six } ,
  sgroup_seven_blue = { color = blue.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Blue Tracks' , tracks = track_blue.seven } ,
  sgroup_eight_blue = { color = blue.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Blue Tracks' , tracks = track_blue.eight } ,
 sgroup_eight2_blue = { color = blue.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Blue Tracks' , tracks = track_blue.eight2 } ,

  --[[ == SubGroups BROWN Color br == ]]--
    sgroup_one_brown = { color = brown.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Brown Track' ,  tracks = track_brown.one } ,
    sgroup_two_brown = { color = brown.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Brown Tracks' , tracks = track_brown.two } ,
  sgroup_three_brown = { color = brown.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Brown Tracks' , tracks = track_brown.three } ,
   sgroup_four_brown = { color = brown.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Brown Tracks' , tracks = track_brown.four } ,
   sgroup_five_brown = { color = brown.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Brown Tracks' , tracks = track_brown.five } ,
    sgroup_six_brown = { color = brown.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Brown Tracks' , tracks = track_brown.six } ,
  sgroup_seven_brown = { color = brown.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Brown Tracks' , tracks = track_brown.seven } ,
  sgroup_eight_brown = { color = brown.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Brown Tracks' , tracks = track_brown.eight } ,
 sgroup_eight2_brown = { color = brown.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Brown Tracks' , tracks = track_brown.eight2 } ,

  --[[ == SubGroups GOLD Color gl == ]]--
    sgroup_one_gold = { color = gold.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Gold Track' ,  tracks = track_gold.one } ,
    sgroup_two_gold = { color = gold.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Gold Tracks' , tracks = track_gold.two } ,
  sgroup_three_gold = { color = gold.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Gold Tracks' , tracks = track_gold.three } ,
   sgroup_four_gold = { color = gold.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Gold Tracks' , tracks = track_gold.four } ,
   sgroup_five_gold = { color = gold.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Gold Tracks' , tracks = track_gold.five } ,
    sgroup_six_gold = { color = gold.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Gold Tracks' , tracks = track_gold.six } ,
  sgroup_seven_gold = { color = gold.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Gold Tracks' , tracks = track_gold.seven } ,
  sgroup_eight_gold = { color = gold.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Gold Tracks' , tracks = track_gold.eight } ,
 sgroup_eight2_gold = { color = gold.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Gold Tracks' , tracks = track_gold.eight2 } ,

  --[[ == SubGroups GRAY Color gy ==]]--
    sgroup_one_gray = { color = gray.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Gray Track' ,  tracks = track_gray.one } ,
    sgroup_two_gray = { color = gray.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Gray Tracks' , tracks = track_gray.two } ,
  sgroup_three_gray = { color = gray.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Gray Tracks' , tracks = track_gray.three } ,
   sgroup_four_gray = { color = gray.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Gray Tracks' , tracks = track_gray.four } ,
   sgroup_five_gray = { color = gray.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Gray Tracks' , tracks = track_gray.five } ,
    sgroup_six_gray = { color = gray.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Gray Tracks' , tracks = track_gray.six } ,
  sgroup_seven_gray = { color = gray.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Gray Tracks' , tracks = track_gray.seven } ,
  sgroup_eight_gray = { color = gray.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Gray Tracks' , tracks = track_gray.eight } ,
 sgroup_eight2_gray = { color = gray.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Gray Tracks' , tracks = track_gray.eight2 } ,

  --[[ == SubGroups GREEN Color gr == ]]--
    sgroup_one_green = { color = green.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Green Track' ,  tracks = track_green.one } ,
    sgroup_two_green = { color = green.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Green Tracks' , tracks = track_green.two } ,
  sgroup_three_green = { color = green.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Green Tracks' , tracks = track_green.three } ,
   sgroup_four_green = { color = green.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Green Tracks' , tracks = track_green.four } ,
   sgroup_five_green = { color = green.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Green Tracks' , tracks = track_green.five } ,
    sgroup_six_green = { color = green.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Green Tracks' , tracks = track_green.six } ,
  sgroup_seven_green = { color = green.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Green Tracks' , tracks = track_green.seven } ,
  sgroup_eight_green = { color = green.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Green Tracks' , tracks = track_green.eight } ,
 sgroup_eight2_green = { color = green.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Green Tracks' , tracks = track_green.eight2 } ,

  --[[ == SubGroups ORANGE Color or == ]]--
    sgroup_one_orange = { color = orange.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Orange Track' ,  tracks = track_orange.one } ,
    sgroup_two_orange = { color = orange.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Orange Tracks' , tracks = track_orange.two } ,
  sgroup_three_orange = { color = orange.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Orange Tracks' , tracks = track_orange.three } ,
   sgroup_four_orange = { color = orange.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Orange Tracks' , tracks = track_orange.four } ,
   sgroup_five_orange = { color = orange.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Orange Tracks' , tracks = track_orange.five } ,
    sgroup_six_orange = { color = orange.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Orange Tracks' , tracks = track_orange.six } ,
  sgroup_seven_orange = { color = orange.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Orange Tracks' , tracks = track_orange.seven } ,
  sgroup_eight_orange = { color = orange.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Orange Tracks' , tracks = track_orange.eight } ,
 sgroup_eight2_orange = { color = orange.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Orange Tracks' , tracks = track_orange.eight2 } ,

  --[[ == SubGroups PALE PINK Color pl == ]]--
    sgroup_one_pale = { color = pale.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Pale Pink Track' ,  tracks = track_pale.one } ,
    sgroup_two_pale = { color = pale.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Pale Pink Tracks' , tracks = track_pale.two } ,
  sgroup_three_pale = { color = pale.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Pale Pink Tracks' , tracks = track_pale.three } ,
   sgroup_four_pale = { color = pale.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Pale Pink Tracks' , tracks = track_pale.four } ,
   sgroup_five_pale = { color = pale.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Pale Pink Tracks' , tracks = track_pale.five } ,
    sgroup_six_pale = { color = pale.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Pale Pink Tracks' , tracks = track_pale.six } ,
  sgroup_seven_pale = { color = pale.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Pale Pink Tracks' , tracks = track_pale.seven } ,
  sgroup_eight_pale = { color = pale.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Pale Pink Tracks' , tracks = track_pale.eight } ,
 sgroup_eight2_pale = { color = pale.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Pale Pink Tracks' , tracks = track_pale.eight2 } ,

  --[[ == SubGroups PINK Color pn == ]]--
    sgroup_one_pink = { color = pink.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Pink Track' ,  tracks = track_pink.one } ,
    sgroup_two_pink = { color = pink.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Pink Tracks' , tracks = track_pink.two } ,
  sgroup_three_pink = { color = pink.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Pink Tracks' , tracks = track_pink.three } ,
   sgroup_four_pink = { color = pink.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Pink Tracks' , tracks = track_pink.four } ,
   sgroup_five_pink = { color = pink.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Pink Tracks' , tracks = track_pink.five } ,
    sgroup_six_pink = { color = pink.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Pink Tracks' , tracks = track_pink.six } ,
  sgroup_seven_pink = { color = pink.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Pink Tracks' , tracks = track_pink.seven } ,
  sgroup_eight_pink = { color = pink.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Pink Tracks' , tracks = track_pink.eight } ,
 sgroup_eight2_pink = { color = pink.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Pink Tracks' , tracks = track_pink.eight2 } ,

  --[[ == SubGroups PISTACHIO Color ps == ]]--
    sgroup_one_pistachio = { color = pistachio.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Pistachio Track' ,  tracks = track_pistachio.one } ,
    sgroup_two_pistachio = { color = pistachio.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Pistachio Tracks' , tracks = track_pistachio.two } ,
  sgroup_three_pistachio = { color = pistachio.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Pistachio Tracks' , tracks = track_pistachio.three } ,
   sgroup_four_pistachio = { color = pistachio.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Pistachio Tracks' , tracks = track_pistachio.four } ,
   sgroup_five_pistachio = { color = pistachio.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Pistachio Tracks' , tracks = track_pistachio.five } ,
    sgroup_six_pistachio = { color = pistachio.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Pistachio Tracks' , tracks = track_pistachio.six } ,
  sgroup_seven_pistachio = { color = pistachio.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Pistachio Tracks' , tracks = track_pistachio.seven } ,
  sgroup_eight_pistachio = { color = pistachio.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Pistachio Tracks' , tracks = track_pistachio.eight } ,
 sgroup_eight2_pistachio = { color = pistachio.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Pistachio Tracks' , tracks = track_pistachio.eight2 } ,

  --[[ == SubGroups RED Color rd == ]]--
    sgroup_one_red = { color = red.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Red Track' ,  tracks = track_red.one } ,
    sgroup_two_red = { color = red.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Red Tracks' , tracks = track_red.two } ,
  sgroup_three_red = { color = red.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Red Tracks' , tracks = track_red.three } ,
   sgroup_four_red = { color = red.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Red Tracks' , tracks = track_red.four } ,
   sgroup_five_red = { color = red.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Red Tracks' , tracks = track_red.five } ,
    sgroup_six_red = { color = red.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Red Tracks' , tracks = track_red.six } ,
  sgroup_seven_red = { color = red.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Red Tracks' , tracks = track_red.seven } ,
  sgroup_eight_red = { color = red.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Red Tracks' , tracks = track_red.eight } ,
 sgroup_eight2_red = { color = red.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Red Tracks' , tracks = track_red.eight2 } ,

  --[[ == SubGroups SKY BLUE Color sk == ]]--
    sgroup_one_sky = { color = sky.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Sky Blue Track' ,  tracks = track_sky.one } ,
    sgroup_two_sky = { color = sky.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Sky Blue Tracks' , tracks = track_sky.two } ,
  sgroup_three_sky = { color = sky.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Sky Blue Tracks' , tracks = track_sky.three } ,
   sgroup_four_sky = { color = sky.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Sky Blue Tracks' , tracks = track_sky.four } ,
   sgroup_five_sky = { color = sky.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Sky Blue Tracks' , tracks = track_sky.five } ,
    sgroup_six_sky = { color = sky.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Sky Blue Tracks' , tracks = track_sky.six } ,
  sgroup_seven_sky = { color = sky.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Sky Blue Tracks' , tracks = track_sky.seven } ,
  sgroup_eight_sky = { color = sky.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Sky Blue Tracks' , tracks = track_sky.eight } ,
 sgroup_eight2_sky = { color = sky.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Sky Blue Tracks' , tracks = track_red.eight2 } ,

  --[[ == SubGroups VIOLET Color vl == ]]--
    sgroup_one_violet = { color = violet.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Violet Track' ,  tracks = track_violet.one } ,
    sgroup_two_violet = { color = violet.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Violet Tracks' , tracks = track_violet.two } ,
  sgroup_three_violet = { color = violet.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Violet Tracks' , tracks = track_violet.three } ,
   sgroup_four_violet = { color = violet.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Violet Tracks' , tracks = track_violet.four } ,
   sgroup_five_violet = { color = violet.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Violet Tracks' , tracks = track_violet.five } ,
    sgroup_six_violet = { color = violet.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Violet Tracks' , tracks = track_violet.six } ,
  sgroup_seven_violet = { color = violet.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Violet Tracks' , tracks = track_violet.seven } ,
  sgroup_eight_violet = { color = violet.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Violet Tracks' , tracks = track_violet.eight } ,
 sgroup_eight2_violet = { color = violet.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Violet Tracks' , tracks = track_violet.eight2 } ,

  --[[ == SubGroups WHITE Color wh == ]]--
    sgroup_one_white = { color = white.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 White Track' ,  tracks = track_white.one } ,
    sgroup_two_white = { color = white.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 White Tracks' , tracks = track_white.two } ,
  sgroup_three_white = { color = white.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 White Tracks' , tracks = track_white.three } ,
   sgroup_four_white = { color = white.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 White Tracks' , tracks = track_white.four } ,
   sgroup_five_white = { color = white.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 White Tracks' , tracks = track_white.five } ,
    sgroup_six_white = { color = white.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 White Tracks' , tracks = track_white.six } ,
  sgroup_seven_white = { color = white.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 White Tracks' , tracks = track_white.seven } ,
  sgroup_eight_white = { color = white.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 White Tracks' , tracks = track_white.eight } ,
 sgroup_eight2_white = { color = white.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 White Tracks' , tracks = track_white.eight2 } ,

  --[[ == SubGroups YELLOW Color yl == ]]--
    sgroup_one_yellow = { color = yellow.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x1 Yellow Track' ,  tracks = track_yellow.one } ,
    sgroup_two_yellow = { color = yellow.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x2 Yellow Tracks' , tracks = track_yellow.two } ,
  sgroup_three_yellow = { color = yellow.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x3 Yellow Tracks' , tracks = track_yellow.three } ,
   sgroup_four_yellow = { color = yellow.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x4 Yellow Tracks' , tracks = track_yellow.four } ,
   sgroup_five_yellow = { color = yellow.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x5 Yellow Tracks' , tracks = track_yellow.five } ,
    sgroup_six_yellow = { color = yellow.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x6 Yellow Tracks' , tracks = track_yellow.six } ,
  sgroup_seven_yellow = { color = yellow.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x7 Yellow Tracks' , tracks = track_yellow.seven } ,
  sgroup_eight_yellow = { color = yellow.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Yellow Tracks' , tracks = track_yellow.eight } ,
 sgroup_eight2_yellow = { color = yellow.zero , color_blend = 23 , collapsed = false , name = 'SubGroup x8 Yellow Tracks' , tracks = track_yellow.eight2 } ,

}




--[[ ============================== GROUPS & MAIN GROUP ======================================= ]]--

local group_settings = {

  --[[ == Group & Main Group AQUA Color aq == ]]--
    group_one_aqua = { color = aqua.zero , color_blend = 32 , collapsed = false , name = 'GROUP AQUA 01' } ,
    group_two_aqua = { color = aqua.zero , color_blend = 32 , collapsed = false , name = 'GROUP AQUA 02' } ,
  group_three_aqua = { color = aqua.zero , color_blend = 32 , collapsed = false , name = 'GROUP AQUA 03' } ,
   group_four_aqua = { color = aqua.zero , color_blend = 32 , collapsed = false , name = 'GROUP AQUA 04' } ,
   group_five_aqua = { color = aqua.zero , color_blend = 32 , collapsed = false , name = 'GROUP AQUA 05' } ,
   main_group_aqua = { color = aqua.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP AQUA' } ,

  --[[ == Group & Main Group BLACK Color bk == ]]--
    group_one_black = { color = black.zero , color_blend = 32 , collapsed = false , name = 'GROUP BLACK 01' } ,
    group_two_black = { color = black.zero , color_blend = 32 , collapsed = false , name = 'GROUP BLACK 02' } ,
  group_three_black = { color = black.zero , color_blend = 32 , collapsed = false , name = 'GROUP BLACK 03' } ,
   group_four_black = { color = black.zero , color_blend = 32 , collapsed = false , name = 'GROUP BLACK 04' } ,
   group_five_black = { color = black.zero , color_blend = 32 , collapsed = false , name = 'GROUP BLACK 05' } ,
   main_group_black = { color = black.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP BLACK' } ,

  --[[ == Group & Main Group BLUE Color bl == ]]--
    group_one_blue = { color = blue.zero , color_blend = 32 , collapsed = false , name = 'GROUP BLUE 01' } ,
    group_two_blue = { color = blue.zero , color_blend = 32 , collapsed = false , name = 'GROUP BLUE 02' } ,
  group_three_blue = { color = blue.zero , color_blend = 32 , collapsed = false , name = 'GROUP BLUE 03' } ,
   group_four_blue = { color = blue.zero , color_blend = 32 , collapsed = false , name = 'GROUP BLUE 04' } ,
   group_five_blue = { color = blue.zero , color_blend = 32 , collapsed = false , name = 'GROUP BLUE 05' } ,
   main_group_blue = { color = blue.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP BLUE' } ,

  --[[ == Group & Main Group BROWN Color br == ]]--
    group_one_brown = { color = brown.zero , color_blend = 32 , collapsed = false , name = 'GROUP BROWN 01' } ,
    group_two_brown = { color = brown.zero , color_blend = 32 , collapsed = false , name = 'GROUP BROWN 02' } ,
  group_three_brown = { color = brown.zero , color_blend = 32 , collapsed = false , name = 'GROUP BROWN 03' } ,
   group_four_brown = { color = brown.zero , color_blend = 32 , collapsed = false , name = 'GROUP BROWN 04' } ,
   group_five_brown = { color = brown.zero , color_blend = 32 , collapsed = false , name = 'GROUP BROWN 05' } ,
   main_group_brown = { color = brown.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP BROWN' } ,

  --[[ == Group & Main Group GOLD Color gl == ]]--
    group_one_gold = { color = gold.zero , color_blend = 32 , collapsed = false , name = 'GROUP GOLD 01' } ,
    group_two_gold = { color = gold.zero , color_blend = 32 , collapsed = false , name = 'GROUP GOLD 02' } ,
  group_three_gold = { color = gold.zero , color_blend = 32 , collapsed = false , name = 'GROUP GOLD 03' } ,
   group_four_gold = { color = gold.zero , color_blend = 32 , collapsed = false , name = 'GROUP GOLD 04' } ,
   group_five_gold = { color = gold.zero , color_blend = 32 , collapsed = false , name = 'GROUP GOLD 05' } ,
   main_group_gold = { color = gold.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP GOLD' } ,

  --[[ == Group & Main Group GRAY Color gy ==]]--
    group_one_gray = { color = gray.zero , color_blend = 32 , collapsed = false , name = 'GROUP GRAY 01' } ,
    group_two_gray = { color = gray.zero , color_blend = 32 , collapsed = false , name = 'GROUP GRAY 02' } ,
  group_three_gray = { color = gray.zero , color_blend = 32 , collapsed = false , name = 'GROUP GRAY 03' } ,
   group_four_gray = { color = gray.zero , color_blend = 32 , collapsed = false , name = 'GROUP GRAY 04' } ,
   group_five_gray = { color = gray.zero , color_blend = 32 , collapsed = false , name = 'GROUP GRAY 05' } ,
   main_group_gray = { color = gray.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP GRAY' } ,

  --[[ == Group & Main Group GREEN Color gr == ]]--
    group_one_green = { color = green.zero , color_blend = 32 , collapsed = false , name = 'GROUP GREEN 01' } ,
    group_two_green = { color = green.zero , color_blend = 32 , collapsed = false , name = 'GROUP GREEN 02' } ,
  group_three_green = { color = green.zero , color_blend = 32 , collapsed = false , name = 'GROUP GREEN 03' } ,
   group_four_green = { color = green.zero , color_blend = 32 , collapsed = false , name = 'GROUP GREEN 04' } ,
   group_five_green = { color = green.zero , color_blend = 32 , collapsed = false , name = 'GROUP GREEN 05' } ,
   main_group_green = { color = green.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP GREEN' } ,

  --[[ == Group & Main Group ORANGE Color or == ]]--
    group_one_orange = { color = orange.zero , color_blend = 32 , collapsed = false , name = 'GROUP ORANGE 01' } ,
    group_two_orange = { color = orange.zero , color_blend = 32 , collapsed = false , name = 'GROUP ORANGE 02' } ,
  group_three_orange = { color = orange.zero , color_blend = 32 , collapsed = false , name = 'GROUP ORANGE 03' } ,
   group_four_orange = { color = orange.zero , color_blend = 32 , collapsed = false , name = 'GROUP ORANGE 04' } ,
   group_five_orange = { color = orange.zero , color_blend = 32 , collapsed = false , name = 'GROUP ORANGE 05' } ,
   main_group_orange = { color = orange.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP ORANGE' } ,

  --[[ == Group & Main Group PALE PINK Color pl == ]]--
    group_one_pale = { color = pale.zero , color_blend = 32 , collapsed = false , name = 'GROUP PALE PINK 01' } ,
    group_two_pale = { color = pale.zero , color_blend = 32 , collapsed = false , name = 'GROUP PALE PINK 02' } ,
  group_three_pale = { color = pale.zero , color_blend = 32 , collapsed = false , name = 'GROUP PALE PINK 03' } ,
   group_four_pale = { color = pale.zero , color_blend = 32 , collapsed = false , name = 'GROUP PALE PINK 04' } ,
   group_five_pale = { color = pale.zero , color_blend = 32 , collapsed = false , name = 'GROUP PALE PINK 05' } ,
   main_group_pale = { color = pale.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP PALE PINK' } ,

  --[[ == Group & Main Group PINK Color pn == ]]--
    group_one_pink = { color = pink.zero , color_blend = 32 , collapsed = false , name = 'GROUP PINK 01' } ,
    group_two_pink = { color = pink.zero , color_blend = 32 , collapsed = false , name = 'GROUP PINK 02' } ,
  group_three_pink = { color = pink.zero , color_blend = 32 , collapsed = false , name = 'GROUP PINK 03' } ,
   group_four_pink = { color = pink.zero , color_blend = 32 , collapsed = false , name = 'GROUP PINK 04' } ,
   group_five_pink = { color = pink.zero , color_blend = 32 , collapsed = false , name = 'GROUP PINK 05' } ,
   main_group_pink = { color = pink.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP PINK' } ,

  --[[ == Group & Main Group PISTACHIO Color ps == ]]--
    group_one_pistachio = { color = pistachio.zero , color_blend = 32 , collapsed = false , name = 'GROUP PISTACHIO 01' } ,
    group_two_pistachio = { color = pistachio.zero , color_blend = 32 , collapsed = false , name = 'GROUP PISTACHIO 02' } ,
  group_three_pistachio = { color = pistachio.zero , color_blend = 32 , collapsed = false , name = 'GROUP PISTACHIO 03' } ,
   group_four_pistachio = { color = pistachio.zero , color_blend = 32 , collapsed = false , name = 'GROUP PISTACHIO 04' } ,
   group_five_pistachio = { color = pistachio.zero , color_blend = 32 , collapsed = false , name = 'GROUP PISTACHIO 05' } ,
   main_group_pistachio = { color = pistachio.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP PISTACHIO' } ,

  --[[ == Group & Main Group RED Color rd == ]]--
    group_one_red = { color = red.zero , color_blend = 32 , collapsed = false , name = 'GROUP RED 01' } ,
    group_two_red = { color = red.zero , color_blend = 32 , collapsed = false , name = 'GROUP RED 02' } ,
  group_three_red = { color = red.zero , color_blend = 32 , collapsed = false , name = 'GROUP RED 03' } ,
   group_four_red = { color = red.zero , color_blend = 32 , collapsed = false , name = 'GROUP RED 04' } ,
   group_five_red = { color = red.zero , color_blend = 32 , collapsed = false , name = 'GROUP RED 05' } ,
   main_group_red = { color = red.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP RED' } ,

  --[[ == Group & Main Group SKY BLUE Color sk == ]]--
    group_one_sky = { color = sky.zero , color_blend = 32 , collapsed = false , name = 'GROUP SKY BLUE 01' } ,
    group_two_sky = { color = sky.zero , color_blend = 32 , collapsed = false , name = 'GROUP SKY BLUE 02' } ,
  group_three_sky = { color = sky.zero , color_blend = 32 , collapsed = false , name = 'GROUP SKY BLUE 03' } ,
   group_four_sky = { color = sky.zero , color_blend = 32 , collapsed = false , name = 'GROUP SKY BLUE 04' } ,
   group_five_sky = { color = sky.zero , color_blend = 32 , collapsed = false , name = 'GROUP SKY BLUE 05' } ,
   main_group_sky = { color = sky.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP SKY BLUE' } ,

  --[[ == Group & Main Group VIOLET Color vl == ]]--
    group_one_violet = { color = violet.zero , color_blend = 32 , collapsed = false , name = 'GROUP VIOLET 01' } ,
    group_two_violet = { color = violet.zero , color_blend = 32 , collapsed = false , name = 'GROUP VIOLET 02' } ,
  group_three_violet = { color = violet.zero , color_blend = 32 , collapsed = false , name = 'GROUP VIOLET 03' } ,
   group_four_violet = { color = violet.zero , color_blend = 32 , collapsed = false , name = 'GROUP VIOLET 04' } ,
   group_five_violet = { color = violet.zero , color_blend = 32 , collapsed = false , name = 'GROUP VIOLET 05' } ,
   main_group_violet = { color = violet.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP VIOLET' } ,

  --[[ == Group & Main Group WHITE Color wh == ]]--
    group_one_white = { color = white.zero , color_blend = 32 , collapsed = false , name = 'GROUP WHITE 01' } ,
    group_two_white = { color = white.zero , color_blend = 32 , collapsed = false , name = 'GROUP WHITE 02' } ,
  group_three_white = { color = white.zero , color_blend = 32 , collapsed = false , name = 'GROUP WHITE 03' } ,
   group_four_white = { color = white.zero , color_blend = 32 , collapsed = false , name = 'GROUP WHITE 04' } ,
   group_five_white = { color = white.zero , color_blend = 32 , collapsed = false , name = 'GROUP WHITE 05' } ,
   main_group_white = { color = white.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP WHITE' } ,

  --[[ == Group & Main Group YELLOW Color yl == ]]--
    group_one_yellow = { color = yellow.zero , color_blend = 32 , collapsed = false , name = 'GROUP YELLOW 01' } ,
    group_two_yellow = { color = yellow.zero , color_blend = 32 , collapsed = false , name = 'GROUP YELLOW 02' } ,
  group_three_yellow = { color = yellow.zero , color_blend = 32 , collapsed = false , name = 'GROUP YELLOW 03' } ,
   group_four_yellow = { color = yellow.zero , color_blend = 32 , collapsed = false , name = 'GROUP YELLOW 04' } ,
   group_five_yellow = { color = yellow.zero , color_blend = 32 , collapsed = false , name = 'GROUP YELLOW 05' } ,
   main_group_yellow = { color = yellow.zero , color_blend = 42 , collapsed = false , name = 'MAIN GROUP YELLOW' } ,

}




--[[ ============================== INSERT TRACKS ONLY ======================================= ]]--

function insert_track_only(track_index , track_setting)
  renoise.song():insert_track_at(track_index)
  local track = renoise.song():track(track_index)
  track.visible_effect_columns = 0 , 1 , false
  for parameter_name , parameter_value in pairs(track_setting) do
   track[parameter_name] = parameter_value
  end
  --local column_names = { 'C  do' , 'C#' , 'D  re' , 'D#' , 'E  mi' , 'F  fa' , 'F#' , 'G  sol' , 'G#' , 'A  la' , 'A#' , 'B  si' }
  local column_names = { 'Note 01' , 'Note 02' , 'Note 03' , 'Note 04' , 'Note 05' , 'Note 06' , 'Note 07' , 'Note 08' , 'Note 09' , 'Note 10' , 'Note 11' , 'Note 12' }
  for note_column = 1 , 12 do
    track:set_column_name(note_column , column_names[note_column])
  end
end




--[[ ============================== INSERT TRACKS & SUBGROUP ======================================= ]]--

function insert_track(track_index , group_index , track_setting)
  renoise.song():insert_track_at(track_index)
  local track = renoise.song():track(track_index)
  track.visible_effect_columns = 0 , 1 , false  -- track.visible_note_columns, track.volume_column_visible
  for parameter_name , parameter_value in pairs(track_setting) do
   track[parameter_name] = parameter_value
  end
  --local column_names = { 'C  do' , 'C#' , 'D  re' , 'D#' , 'E  mi' , 'F  fa' , 'F#' , 'G  sol' , 'G#' , 'A  la' , 'A#' , 'B  si' }
  local column_names = { 'Note 01' , 'Note 02' , 'Note 03' , 'Note 04' , 'Note 05' , 'Note 06' , 'Note 07' , 'Note 08' , 'Note 09' , 'Note 10' , 'Note 11' , 'Note 12' }
  for note_column = 1 , 12 do
    track:set_column_name(note_column , column_names[note_column])
  end
  renoise.song():add_track_to_group(track_index , group_index)
end

function insert_sgroup(group_setting)
  local song = renoise.song()
  local i , group_index , group_setting = 1 , song.selected_track_index + 1 , sgroup_settings[group_setting]
  song:insert_group_at(group_index)
  for parameter_name , parameter_value in pairs(group_setting) do
    if not (parameter_name == 'tracks') then
      song:track(group_index)[parameter_name] = parameter_value
    end
  end
  for _ , track_setting in ipairs(group_setting.tracks) do
    local group_index = group_index + i
    i = i + 1
    insert_track(song.selected_track_index , group_index , track_setting)
  end
  song.tracks[song.selected_track_index + 1].group_parent.collapsed = true  -- collapse FX in Group
end




--[[ ============================== INSTERT GROUP ======================================= ]]--

function insert_group(group_setting)
  local song = renoise.song()
  local i , group_index , group_setting = 1 , song.selected_track_index + 1 , group_settings[group_setting]
  song:insert_group_at(group_index)
  for parameter_name , parameter_value in pairs(group_setting) do
    if not (parameter_name == 'tracks') then
      song:track(group_index)[parameter_name] = parameter_value
    end
  end
end




--[[ ============================== INSERT SUBGROUPS TO GROUP ======================================= ]]--

function instert_sgroups_to_group_2Gx2T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  4 ,  song.selected_track_index + 1) --  2 + 2     = 4
  song:add_track_to_group(song.selected_track_index +  7 ,  song.selected_track_index + 4) --  4 + 2 + 1 = 7
  song.tracks[song.selected_track_index + 6].group_parent.collapsed = true
end

function instert_sgroups_to_group_2Gx3T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  5 ,  song.selected_track_index + 1) --  3 + 2     = 5
  song:add_track_to_group(song.selected_track_index +  9 ,  song.selected_track_index + 5) --  5 + 3 + 1 = 9
  song.tracks[song.selected_track_index + 8].group_parent.collapsed = true
end

function instert_sgroups_to_group_2Gx4T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  6 ,  song.selected_track_index + 1) --  4 + 2     = 6
  song:add_track_to_group(song.selected_track_index + 11 ,  song.selected_track_index + 6) --  6 + 4 + 1 = 11
  song.tracks[song.selected_track_index + 10].group_parent.collapsed = true
end

function instert_sgroups_to_group_2Gx5T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  7 ,  song.selected_track_index + 1) --  5 + 2     = 7
  song:add_track_to_group(song.selected_track_index + 13 ,  song.selected_track_index + 7) --  7 + 5 + 1 = 13
  song.tracks[song.selected_track_index + 12].group_parent.collapsed = true
end

function instert_sgroups_to_group_2Gx6T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  8 ,  song.selected_track_index + 1) --  6 + 2     = 8
  song:add_track_to_group(song.selected_track_index + 15 ,  song.selected_track_index + 8) --  8 + 6 + 1 = 15
  song.tracks[song.selected_track_index + 14].group_parent.collapsed = true
end

function instert_sgroups_to_group_2Gx7T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  9 ,  song.selected_track_index + 1) --  7 + 2     = 9
  song:add_track_to_group(song.selected_track_index + 17 ,  song.selected_track_index + 9) --  9 + 7 + 1 = 17
  song.tracks[song.selected_track_index + 16].group_parent.collapsed = true
end

function instert_sgroups_to_group_2Gx8T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index + 10 ,  song.selected_track_index + 1) --  8 + 2     = 10
  song:add_track_to_group(song.selected_track_index + 19 , song.selected_track_index + 10) -- 10 + 8 + 1 = 19
  song.tracks[song.selected_track_index + 18].group_parent.collapsed = true
end




--[[ ============================== INSTERT MAIN GROUP ======================================= ]]--

function insert_main_group(group_setting)
  local song = renoise.song()
  local i , group_index , group_setting = 1 , song.selected_track_index + 1 , group_settings[group_setting]
  song:insert_group_at(group_index)
  for parameter_name , parameter_value in pairs(group_setting) do
    if not (parameter_name == 'tracks') then
      song:track(group_index)[parameter_name] = parameter_value
    end
  end
end




--[[ ============================== INSERT GROUPS TO MAIN GROUP ======================================= ]]--

function instert_groups_to_main_group_2Gx2T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +   8 ,  song.selected_track_index + 1) --  6 + 2     = 8
  song:add_track_to_group(song.selected_track_index +  15 ,  song.selected_track_index + 8) --  8 + 6 + 1 = 15
  song.tracks[song.selected_track_index + 14].group_parent.collapsed = true
end

function instert_groups_to_main_group_2Gx3T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  10 ,  song.selected_track_index +  1) --  8 + 2     = 10
  song:add_track_to_group(song.selected_track_index +  19 ,  song.selected_track_index + 10) -- 10 + 8 + 1 = 19
  song.tracks[song.selected_track_index + 18].group_parent.collapsed = true
end

function instert_groups_to_main_group_2Gx4T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  12 ,  song.selected_track_index +  1) --  10 +  2     = 12
  song:add_track_to_group(song.selected_track_index +  23 ,  song.selected_track_index + 12) --  12 + 10 + 1 = 23
  song.tracks[song.selected_track_index + 22].group_parent.collapsed = true
end

function instert_groups_to_main_group_2Gx5T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  14 ,  song.selected_track_index +  1) --  12 + 2      = 14
  song:add_track_to_group(song.selected_track_index +  27 ,  song.selected_track_index + 14) --  14 + 12 + 1 = 27
  song.tracks[song.selected_track_index + 26].group_parent.collapsed = true
end

function instert_groups_to_main_group_2Gx6T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  16 ,  song.selected_track_index +  1) --  14 +  2     = 16
  song:add_track_to_group(song.selected_track_index +  31 ,  song.selected_track_index + 16) --  16 + 14 + 1 = 31
  song.tracks[song.selected_track_index + 30].group_parent.collapsed = true
end

function instert_groups_to_main_group_2Gx7T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  18 ,  song.selected_track_index +  1) --  16 +  2     = 18
  song:add_track_to_group(song.selected_track_index +  35 ,  song.selected_track_index + 18) --  18 + 16 + 1 = 35
  song.tracks[song.selected_track_index + 34].group_parent.collapsed = true
end

function instert_groups_to_main_group_2Gx8T()
  local song = renoise.song()
  song:add_track_to_group(song.selected_track_index +  20 ,  song.selected_track_index +  1) --  18 +  2     = 20
  song:add_track_to_group(song.selected_track_index +  39 ,  song.selected_track_index + 20) --  20 + 18 + 1 = 39
  song.tracks[song.selected_track_index + 38].group_parent.collapsed = true
end




--[[ ============================== FUNCTIONS COLORS ====================================== ]]--

    --[[ == AQUA == ]]--
  
    -- Main Group ----
  
    -- Aqua 1 Main Group
function mgr_aq01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, taq.a2)
                    insert_main_group('main_group_aqua')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Aqua 1MGr x 2Gr [2SGr x 2Tr]
function mgr_aq02() insert_sgroup('sgroup_two_aqua') insert_sgroup('sgroup_two_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_aqua') insert_sgroup('sgroup_two_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_aqua') instert_groups_to_main_group_2Gx2T()
end
  
    -- Aqua 1MGr x 2Gr [2SGr x 3Tr]
function mgr_aq03() insert_sgroup('sgroup_three_aqua') insert_sgroup('sgroup_three_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_aqua') insert_sgroup('sgroup_three_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_aqua') instert_groups_to_main_group_2Gx3T()
end
  
    -- Aqua 1MGr x 2Gr [2SGr x 4Tr]
function mgr_aq04() insert_sgroup('sgroup_four_aqua') insert_sgroup('sgroup_four_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_aqua') insert_sgroup('sgroup_four_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_aqua') instert_groups_to_main_group_2Gx4T()
end
  
    -- Aqua 1MGr x 2Gr [2SGr x 5Tr]
function mgr_aq05() insert_sgroup('sgroup_five_aqua') insert_sgroup('sgroup_five_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_aqua') insert_sgroup('sgroup_five_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_aqua') instert_groups_to_main_group_2Gx5T()
end
  
    -- Aqua 1MGr x 2Gr [2SGr x 6Tr]
function mgr_aq06() insert_sgroup('sgroup_six_aqua') insert_sgroup('sgroup_six_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_aqua') insert_sgroup('sgroup_six_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_aqua') instert_groups_to_main_group_2Gx6T()
end
  
    -- Aqua 1MGr x 2Gr [2SGr x 7Tr]
function mgr_aq07() insert_sgroup('sgroup_seven_aqua') insert_sgroup('sgroup_seven_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_aqua') insert_sgroup('sgroup_seven_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_aqua') instert_groups_to_main_group_2Gx7T()
end
  
    -- Aqua 1MGr x 2Gr [2SGr x 8Tr]
function mgr_aq08() insert_sgroup('sgroup_eight_aqua') insert_sgroup('sgroup_eight_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_aqua') insert_sgroup('sgroup_eight_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_aqua') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Aqua 1 Group
function gr_aq01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, taq.a2)
                   insert_group('group_one_aqua')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Aqua 2Gr [2SGr x 2Tr]
function gr_aq02() insert_sgroup('sgroup_two_aqua') insert_sgroup('sgroup_two_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_aqua') insert_sgroup('sgroup_two_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx2T()
end
    -- Aqua 2Gr [2SGr x 3Tr]
function gr_aq03() insert_sgroup('sgroup_three_aqua') insert_sgroup('sgroup_three_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_aqua') insert_sgroup('sgroup_three_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx3T()
end
    -- Aqua 2Gr [2SGr x 4Tr]
function gr_aq04() insert_sgroup('sgroup_four_aqua') insert_sgroup('sgroup_four_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_aqua') insert_sgroup('sgroup_four_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx4T()
end
    -- Aqua 2Gr [2SGr x 5Tr]
function gr_aq05() insert_sgroup('sgroup_five_aqua') insert_sgroup('sgroup_five_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_aqua') insert_sgroup('sgroup_five_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx5T()
end
    -- Aqua 2Gr [2SGr x 6Tr]
function gr_aq06() insert_sgroup('sgroup_six_aqua') insert_sgroup('sgroup_six_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_aqua') insert_sgroup('sgroup_six_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx6T()
end
    -- Aqua 2Gr [2SGr x 7Tr]
function gr_aq07() insert_sgroup('sgroup_seven_aqua') insert_sgroup('sgroup_seven_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_aqua') insert_sgroup('sgroup_seven_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx7T()
end
    -- Aqua 2Gr [2SGr x 8Tr]
function gr_aq08() insert_sgroup('sgroup_eight_aqua') insert_sgroup('sgroup_eight_aqua') insert_group('group_two_aqua') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_aqua') insert_sgroup('sgroup_eight_aqua') insert_group('group_one_aqua') instert_sgroups_to_group_2Gx8T()
end
    -- Aqua 4Gr [2SGr x 2Tr]
function gr_aq09() insert_sgroup('sgroup_two_aqua') insert_sgroup('sgroup_two_aqua') insert_group('group_four_aqua')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_aqua') insert_sgroup('sgroup_two_aqua') insert_group('group_three_aqua') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_aqua') insert_sgroup('sgroup_two_aqua') insert_group('group_two_aqua')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_aqua') insert_sgroup('sgroup_two_aqua') insert_group('group_one_aqua')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Aqua 4SGr x 2Tr
function sgr_aq01() insert_sgroup('sgroup_two_aqua') insert_sgroup('sgroup_two_aqua')
                    insert_sgroup('sgroup_two_aqua') insert_sgroup('sgroup_two_aqua')
end
    -- Aqua 4SGr x 3Tr
function sgr_aq02() insert_sgroup('sgroup_three_aqua') insert_sgroup('sgroup_three_aqua')
                    insert_sgroup('sgroup_three_aqua') insert_sgroup('sgroup_three_aqua')
end
    -- Aqua 4SGr x 4Tr
function sgr_aq03() insert_sgroup('sgroup_four_aqua') insert_sgroup('sgroup_four_aqua')
                    insert_sgroup('sgroup_four_aqua') insert_sgroup('sgroup_four_aqua')
end
    -- Aqua 4SGr x 5Tr
function sgr_aq04() insert_sgroup('sgroup_five_aqua') insert_sgroup('sgroup_five_aqua')
                    insert_sgroup('sgroup_five_aqua') insert_sgroup('sgroup_five_aqua')
end
    -- Aqua 4SGr x 6Tr
function sgr_aq05() insert_sgroup('sgroup_six_aqua') insert_sgroup('sgroup_six_aqua')
                    insert_sgroup('sgroup_six_aqua') insert_sgroup('sgroup_six_aqua')
end
    -- Aqua 4SGr x 7Tr
function sgr_aq06() insert_sgroup('sgroup_seven_aqua') insert_sgroup('sgroup_seven_aqua')
                    insert_sgroup('sgroup_seven_aqua') insert_sgroup('sgroup_seven_aqua')
end
    -- Aqua 4SGr x 8Tr
function sgr_aq07() insert_sgroup('sgroup_eight_aqua') insert_sgroup('sgroup_eight_aqua')
                    insert_sgroup('sgroup_eight_aqua') insert_sgroup('sgroup_eight_aqua')
end
    -- Aqua 2SGr x 6Tr
function sgr_aq08() insert_sgroup('sgroup_six_aqua') insert_sgroup('sgroup_six_aqua')
end
    -- Aqua 2SGr x 8Tr
function sgr_aq09() insert_sgroup('sgroup_eight_aqua') insert_sgroup('sgroup_eight_aqua')
end
    -- Aqua 1SGr x 8Tr
function sgr_aq10() insert_sgroup('sgroup_eight_aqua')
end  

  
    -- Tracks (Not SubGroups) ----

    -- Aqua 1AuxTr
function tr_aqa1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , taq.a1)
end

function tr_aqb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , taq.a2)
end
    -- Aqua 2Tr
function tr_aq02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , taq.two) insert_track_only(rnst , taq.one)
end
    -- Aqua 4Tr
function tr_aq03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , taq.four)  insert_track_only(rnst , taq.three) insert_track_only(rnst , taq.two) insert_track_only(rnst , taq.one)
end
    -- Aqua 6Tr
function tr_aq04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , taq.six)   insert_track_only(rnst , taq.five) insert_track_only(rnst , taq.four)
                   insert_track_only(rnst , taq.three) insert_track_only(rnst , taq.two)  insert_track_only(rnst , taq.one)
end
    -- Aqua 8Tr
function tr_aq05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , taq.eight) insert_track_only(rnst , taq.seven) insert_track_only(rnst , taq.six) insert_track_only(rnst , taq.five)
                   insert_track_only(rnst , taq.four)  insert_track_only(rnst , taq.three) insert_track_only(rnst , taq.two) insert_track_only(rnst , taq.one)
end
    -- Aqua 4Tr + 2AuxTr
function tr_aq06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , taq.a2) insert_track_only(rnst , taq.a1)
                   insert_track_only(rnst , taq.four)  insert_track_only(rnst , taq.three) insert_track_only(rnst , taq.two) insert_track_only(rnst , taq.one)
end
    -- Aqua 8Tr + 2AuxTr
function tr_aq07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , taq.a2) insert_track_only(rnst , taq.a1)
                   insert_track_only(rnst , taq.eight) insert_track_only(rnst , taq.seven) insert_track_only(rnst , taq.six) insert_track_only(rnst , taq.five)
                   insert_track_only(rnst , taq.four)  insert_track_only(rnst , taq.three) insert_track_only(rnst , taq.two) insert_track_only(rnst , taq.one)
end
  


    --[[ == BLACK == ]]--
  
    -- Main Group ----
  
    -- Black 1 Main Group
function mgr_bk01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tbk.a2)
                    insert_main_group('main_group_black')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Black 1MGr x 2Gr [2SGr x 2Tr]
function mgr_bk02() insert_sgroup('sgroup_two_black') insert_sgroup('sgroup_two_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_black') insert_sgroup('sgroup_two_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_black') instert_groups_to_main_group_2Gx2T()
end
  
    -- Black 1MGr x 2Gr [2SGr x 3Tr]
function mgr_bk03() insert_sgroup('sgroup_three_black') insert_sgroup('sgroup_three_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_black') insert_sgroup('sgroup_three_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_black') instert_groups_to_main_group_2Gx3T()
end
  
    -- Black 1MGr x 2Gr [2SGr x 4Tr]
function mgr_bk04() insert_sgroup('sgroup_four_black') insert_sgroup('sgroup_four_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_black') insert_sgroup('sgroup_four_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_black') instert_groups_to_main_group_2Gx4T()
end
  
    -- Black 1MGr x 2Gr [2SGr x 5Tr]
function mgr_bk05() insert_sgroup('sgroup_five_black') insert_sgroup('sgroup_five_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_black') insert_sgroup('sgroup_five_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_black') instert_groups_to_main_group_2Gx5T()
end
  
    -- Black 1MGr x 2Gr [2SGr x 6Tr]
function mgr_bk06() insert_sgroup('sgroup_six_black') insert_sgroup('sgroup_six_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_black') insert_sgroup('sgroup_six_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_black') instert_groups_to_main_group_2Gx6T()
end
  
    -- Black 1MGr x 2Gr [2SGr x 7Tr]
function mgr_bk07() insert_sgroup('sgroup_seven_black') insert_sgroup('sgroup_seven_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_black') insert_sgroup('sgroup_seven_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_black') instert_groups_to_main_group_2Gx7T()
end
  
    -- Black 1MGr x 2Gr [2SGr x 8Tr]
function mgr_bk08() insert_sgroup('sgroup_eight_black') insert_sgroup('sgroup_eight_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_black') insert_sgroup('sgroup_eight_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_black') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Black 1 Group
function gr_bk01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tbk.a2)
                   insert_group('group_one_black')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Black 2Gr [2SGr x 2Tr]
function gr_bk02() insert_sgroup('sgroup_two_black') insert_sgroup('sgroup_two_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_black') insert_sgroup('sgroup_two_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx2T()
end
    -- Black 2Gr [2SGr x 3Tr]
function gr_bk03() insert_sgroup('sgroup_three_black') insert_sgroup('sgroup_three_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_black') insert_sgroup('sgroup_three_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx3T()
end
    -- Black 2Gr [2SGr x 4Tr]
function gr_bk04() insert_sgroup('sgroup_four_black') insert_sgroup('sgroup_four_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_black') insert_sgroup('sgroup_four_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx4T()
end
    -- Black 2Gr [2SGr x 5Tr]
function gr_bk05() insert_sgroup('sgroup_five_black') insert_sgroup('sgroup_five_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_black') insert_sgroup('sgroup_five_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx5T()
end
    -- Black 2Gr [2SGr x 6Tr]
function gr_bk06() insert_sgroup('sgroup_six_black') insert_sgroup('sgroup_six_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_black') insert_sgroup('sgroup_six_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx6T()
end
    -- Black 2Gr [2SGr x 7Tr]
function gr_bk07() insert_sgroup('sgroup_seven_black') insert_sgroup('sgroup_seven_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_black') insert_sgroup('sgroup_seven_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx7T()
end
    -- Black 2Gr [2SGr x 8Tr]
function gr_bk08() insert_sgroup('sgroup_eight_black') insert_sgroup('sgroup_eight_black') insert_group('group_two_black') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_black') insert_sgroup('sgroup_eight_black') insert_group('group_one_black') instert_sgroups_to_group_2Gx8T()
end
    -- Black 4Gr [2SGr x 2Tr]
function gr_bk09() insert_sgroup('sgroup_two_black') insert_sgroup('sgroup_two_black') insert_group('group_four_black')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_black') insert_sgroup('sgroup_two_black') insert_group('group_three_black') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_black') insert_sgroup('sgroup_two_black') insert_group('group_two_black')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_black') insert_sgroup('sgroup_two_black') insert_group('group_one_black')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Black 4SGr x 2Tr
function sgr_bk01() insert_sgroup('sgroup_two_black') insert_sgroup('sgroup_two_black')
                    insert_sgroup('sgroup_two_black') insert_sgroup('sgroup_two_black')
end
    -- Black 4SGr x 3Tr
function sgr_bk02() insert_sgroup('sgroup_three_black') insert_sgroup('sgroup_three_black')
                    insert_sgroup('sgroup_three_black') insert_sgroup('sgroup_three_black')
end
    -- Black 4SGr x 4Tr
function sgr_bk03() insert_sgroup('sgroup_four_black') insert_sgroup('sgroup_four_black')
                    insert_sgroup('sgroup_four_black') insert_sgroup('sgroup_four_black')
end
    -- Black 4SGr x 5Tr
function sgr_bk04() insert_sgroup('sgroup_five_black') insert_sgroup('sgroup_five_black')
                    insert_sgroup('sgroup_five_black') insert_sgroup('sgroup_five_black')
end
    -- Black 4SGr x 6Tr
function sgr_bk05() insert_sgroup('sgroup_six_black') insert_sgroup('sgroup_six_black')
                    insert_sgroup('sgroup_six_black') insert_sgroup('sgroup_six_black')
end
    -- Black 4SGr x 7Tr
function sgr_bk06() insert_sgroup('sgroup_seven_black') insert_sgroup('sgroup_seven_black')
                    insert_sgroup('sgroup_seven_black') insert_sgroup('sgroup_seven_black')
end
    -- Black 4SGr x 8Tr
function sgr_bk07() insert_sgroup('sgroup_eight_black') insert_sgroup('sgroup_eight_black')
                    insert_sgroup('sgroup_eight_black') insert_sgroup('sgroup_eight_black')
end
    -- Black 2SGr x 6Tr
function sgr_bk08() insert_sgroup('sgroup_six_black') insert_sgroup('sgroup_six_black')
end
    -- Black 2SGr x 8Tr
function sgr_bk09() insert_sgroup('sgroup_eight_black') insert_sgroup('sgroup_eight_black')
end
    -- Black 1SGr x 8Tr
function sgr_bk10() insert_sgroup('sgroup_eight_black')
end  

  
    -- Tracks (Not SubGroups) ----

    -- Black 1AuxTr
function tr_bka1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbk.a1)
end

function tr_bkb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbk.a2)
end
    -- Black 2Tr
function tr_bk02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbk.two) insert_track_only(rnst , tbk.one)
end
    -- Black 4Tr
function tr_bk03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbk.four)  insert_track_only(rnst , tbk.three) insert_track_only(rnst , tbk.two) insert_track_only(rnst , tbk.one)
end
    -- Black 6Tr
function tr_bk04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbk.six)   insert_track_only(rnst , tbk.five) insert_track_only(rnst , tbk.four)
                   insert_track_only(rnst , tbk.three) insert_track_only(rnst , tbk.two)  insert_track_only(rnst , tbk.one)
end
    -- Black 8Tr
function tr_bk05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbk.eight) insert_track_only(rnst , tbk.seven) insert_track_only(rnst , tbk.six) insert_track_only(rnst , tbk.five)
                   insert_track_only(rnst , tbk.four)  insert_track_only(rnst , tbk.three) insert_track_only(rnst , tbk.two) insert_track_only(rnst , tbk.one)
end
    -- Black 4Tr + 2AuxTr
function tr_bk06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbk.a2) insert_track_only(rnst , tbk.a1)
                   insert_track_only(rnst , tbk.four)  insert_track_only(rnst , tbk.three) insert_track_only(rnst , tbk.two) insert_track_only(rnst , tbk.one)
end
    -- Black 8Tr + 2AuxTr
function tr_bk07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbk.a2) insert_track_only(rnst , tbk.a1)
                   insert_track_only(rnst , tbk.eight) insert_track_only(rnst , tbk.seven) insert_track_only(rnst , tbk.six) insert_track_only(rnst , tbk.five)
                   insert_track_only(rnst , tbk.four)  insert_track_only(rnst , tbk.three) insert_track_only(rnst , tbk.two) insert_track_only(rnst , tbk.one)
end



    --[[ == BLUE == ]]--
  
    -- Main Group ----
  
    -- Blue 1 Main Group
function mgr_bl01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tbl.a2)
                    insert_main_group('main_group_blue')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Blue 1MGr x 2Gr [2SGr x 2Tr]
function mgr_bl02() insert_sgroup('sgroup_two_blue') insert_sgroup('sgroup_two_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_blue') insert_sgroup('sgroup_two_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_blue') instert_groups_to_main_group_2Gx2T()
end
  
    -- Blue 1MGr x 2Gr [2SGr x 3Tr]
function mgr_bl03() insert_sgroup('sgroup_three_blue') insert_sgroup('sgroup_three_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_blue') insert_sgroup('sgroup_three_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_blue') instert_groups_to_main_group_2Gx3T()
end
  
    -- Blue 1MGr x 2Gr [2SGr x 4Tr]
function mgr_bl04() insert_sgroup('sgroup_four_blue') insert_sgroup('sgroup_four_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_blue') insert_sgroup('sgroup_four_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_blue') instert_groups_to_main_group_2Gx4T()
end
  
    -- Blue 1MGr x 2Gr [2SGr x 5Tr]
function mgr_bl05() insert_sgroup('sgroup_five_blue') insert_sgroup('sgroup_five_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_blue') insert_sgroup('sgroup_five_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_blue') instert_groups_to_main_group_2Gx5T()
end
  
    -- Blue 1MGr x 2Gr [2SGr x 6Tr]
function mgr_bl06() insert_sgroup('sgroup_six_blue') insert_sgroup('sgroup_six_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_blue') insert_sgroup('sgroup_six_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_blue') instert_groups_to_main_group_2Gx6T()
end
  
    -- Blue 1MGr x 2Gr [2SGr x 7Tr]
function mgr_bl07() insert_sgroup('sgroup_seven_blue') insert_sgroup('sgroup_seven_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_blue') insert_sgroup('sgroup_seven_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_blue') instert_groups_to_main_group_2Gx7T()
end
  
    -- Blue 1MGr x 2Gr [2SGr x 8Tr]
function mgr_bl08() insert_sgroup('sgroup_eight_blue') insert_sgroup('sgroup_eight_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_blue') insert_sgroup('sgroup_eight_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_blue') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Blue 1 Group
function gr_bl01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tbl.a2)
                   insert_group('group_one_blue')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Blue 2Gr [2SGr x 2Tr]
function gr_bl02() insert_sgroup('sgroup_two_blue') insert_sgroup('sgroup_two_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_blue') insert_sgroup('sgroup_two_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx2T()
end
    -- Blue 2Gr [2SGr x 3Tr]
function gr_bl03() insert_sgroup('sgroup_three_blue') insert_sgroup('sgroup_three_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_blue') insert_sgroup('sgroup_three_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx3T()
end
    -- Blue 2Gr [2SGr x 4Tr]
function gr_bl04() insert_sgroup('sgroup_four_blue') insert_sgroup('sgroup_four_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_blue') insert_sgroup('sgroup_four_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx4T()
end
    -- Blue 2Gr [2SGr x 5Tr]
function gr_bl05() insert_sgroup('sgroup_five_blue') insert_sgroup('sgroup_five_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_blue') insert_sgroup('sgroup_five_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx5T()
end
    -- Blue 2Gr [2SGr x 6Tr]
function gr_bl06() insert_sgroup('sgroup_six_blue') insert_sgroup('sgroup_six_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_blue') insert_sgroup('sgroup_six_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx6T()
end
    -- Blue 2Gr [2SGr x 7Tr]
function gr_bl07() insert_sgroup('sgroup_seven_blue') insert_sgroup('sgroup_seven_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_blue') insert_sgroup('sgroup_seven_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx7T()
end
    -- Blue 2Gr [2SGr x 8Tr]
function gr_bl08() insert_sgroup('sgroup_eight_blue') insert_sgroup('sgroup_eight_blue') insert_group('group_two_blue') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_blue') insert_sgroup('sgroup_eight_blue') insert_group('group_one_blue') instert_sgroups_to_group_2Gx8T()
end
    -- Blue 4Gr [2SGr x 2Tr]
function gr_bl09() insert_sgroup('sgroup_two_blue') insert_sgroup('sgroup_two_blue') insert_group('group_four_blue')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_blue') insert_sgroup('sgroup_two_blue') insert_group('group_three_blue') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_blue') insert_sgroup('sgroup_two_blue') insert_group('group_two_blue')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_blue') insert_sgroup('sgroup_two_blue') insert_group('group_one_blue')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Blue 4SGr x 2Tr
function sgr_bl01() insert_sgroup('sgroup_two_blue') insert_sgroup('sgroup_two_blue')
                    insert_sgroup('sgroup_two_blue') insert_sgroup('sgroup_two_blue')
end
    -- Blue 4SGr x 3Tr
function sgr_bl02() insert_sgroup('sgroup_three_blue') insert_sgroup('sgroup_three_blue')
                    insert_sgroup('sgroup_three_blue') insert_sgroup('sgroup_three_blue')
end
    -- Blue 4SGr x 4Tr
function sgr_bl03() insert_sgroup('sgroup_four_blue') insert_sgroup('sgroup_four_blue')
                    insert_sgroup('sgroup_four_blue') insert_sgroup('sgroup_four_blue')
end
    -- Blue 4SGr x 5Tr
function sgr_bl04() insert_sgroup('sgroup_five_blue') insert_sgroup('sgroup_five_blue')
                    insert_sgroup('sgroup_five_blue') insert_sgroup('sgroup_five_blue')
end
    -- Blue 4SGr x 6Tr
function sgr_bl05() insert_sgroup('sgroup_six_blue') insert_sgroup('sgroup_six_blue')
                    insert_sgroup('sgroup_six_blue') insert_sgroup('sgroup_six_blue')
end
    -- Blue 4SGr x 7Tr
function sgr_bl06() insert_sgroup('sgroup_seven_blue') insert_sgroup('sgroup_seven_blue')
                    insert_sgroup('sgroup_seven_blue') insert_sgroup('sgroup_seven_blue')
end
    -- Blue 4SGr x 8Tr
function sgr_bl07() insert_sgroup('sgroup_eight_blue') insert_sgroup('sgroup_eight_blue')
                    insert_sgroup('sgroup_eight_blue') insert_sgroup('sgroup_eight_blue')
end
    -- Blue 2SGr x 6Tr
function sgr_bl08() insert_sgroup('sgroup_six_blue') insert_sgroup('sgroup_six_blue')
end
    -- Blue 2SGr x 8Tr
function sgr_bl09() insert_sgroup('sgroup_eight_blue') insert_sgroup('sgroup_eight_blue')
end
    -- Blue 1SGr x 8Tr
function sgr_bl10() insert_sgroup('sgroup_eight_blue')
end  

  
    -- Tracks (Not SubGroups) ----

    -- Blue 1AuxTr
function tr_bla1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbl.a1)
end

function tr_blb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbl.a2)
end
    -- Blue 2Tr
function tr_bl02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbl.two) insert_track_only(rnst , tbl.one)
end
    -- Blue 4Tr
function tr_bl03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbl.four)  insert_track_only(rnst , tbl.three) insert_track_only(rnst , tbl.two) insert_track_only(rnst , tbl.one)
end
    -- Blue 6Tr
function tr_bl04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbl.six)   insert_track_only(rnst , tbl.five) insert_track_only(rnst , tbl.four)
                   insert_track_only(rnst , tbl.three) insert_track_only(rnst , tbl.two)  insert_track_only(rnst , tbl.one)
end
    -- Blue 8Tr
function tr_bl05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbl.eight) insert_track_only(rnst , tbl.seven) insert_track_only(rnst , tbl.six) insert_track_only(rnst , tbl.five)
                   insert_track_only(rnst , tbl.four)  insert_track_only(rnst , tbl.three) insert_track_only(rnst , tbl.two) insert_track_only(rnst , tbl.one)
end
    -- Blue 4Tr + 2AuxTr
function tr_bl06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbl.a2) insert_track_only(rnst , tbl.a1)
                   insert_track_only(rnst , tbl.four)  insert_track_only(rnst , tbl.three) insert_track_only(rnst , tbl.two) insert_track_only(rnst , tbl.one)
end
    -- Blue 8Tr + 2AuxTr
function tr_bl07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbl.a2) insert_track_only(rnst , tbl.a1)
                   insert_track_only(rnst , tbl.eight) insert_track_only(rnst , tbl.seven) insert_track_only(rnst , tbl.six) insert_track_only(rnst , tbl.five)
                   insert_track_only(rnst , tbl.four)  insert_track_only(rnst , tbl.three) insert_track_only(rnst , tbl.two) insert_track_only(rnst , tbl.one)
end



    --[[ == BROWN == ]]--
  
    -- Main Group ----
  
    -- Brown 1 Main Group
function mgr_br01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tbr.a2)
                    insert_main_group('main_group_brown')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Brown 1MGr x 2Gr [2SGr x 2Tr]
function mgr_br02() insert_sgroup('sgroup_two_brown') insert_sgroup('sgroup_two_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_brown') insert_sgroup('sgroup_two_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_brown') instert_groups_to_main_group_2Gx2T()
end
  
    -- Brown 1MGr x 2Gr [2SGr x 3Tr]
function mgr_br03() insert_sgroup('sgroup_three_brown') insert_sgroup('sgroup_three_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_brown') insert_sgroup('sgroup_three_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_brown') instert_groups_to_main_group_2Gx3T()
end
  
    -- Brown 1MGr x 2Gr [2SGr x 4Tr]
function mgr_br04() insert_sgroup('sgroup_four_brown') insert_sgroup('sgroup_four_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_brown') insert_sgroup('sgroup_four_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_brown') instert_groups_to_main_group_2Gx4T()
end
  
    -- Brown 1MGr x 2Gr [2SGr x 5Tr]
function mgr_br05() insert_sgroup('sgroup_five_brown') insert_sgroup('sgroup_five_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_brown') insert_sgroup('sgroup_five_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_brown') instert_groups_to_main_group_2Gx5T()
end
  
    -- Brown 1MGr x 2Gr [2SGr x 6Tr]
function mgr_br06() insert_sgroup('sgroup_six_brown') insert_sgroup('sgroup_six_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_brown') insert_sgroup('sgroup_six_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_brown') instert_groups_to_main_group_2Gx6T()
end
  
    -- Brown 1MGr x 2Gr [2SGr x 7Tr]
function mgr_br07() insert_sgroup('sgroup_seven_brown') insert_sgroup('sgroup_seven_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_brown') insert_sgroup('sgroup_seven_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_brown') instert_groups_to_main_group_2Gx7T()
end
  
    -- Brown 1MGr x 2Gr [2SGr x 8Tr]
function mgr_br08() insert_sgroup('sgroup_eight_brown') insert_sgroup('sgroup_eight_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_brown') insert_sgroup('sgroup_eight_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_brown') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Brown 1 Group
function gr_br01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tbr.a2)
                   insert_group('group_one_brown')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Brown 2Gr [2SGr x 2Tr]
function gr_br02() insert_sgroup('sgroup_two_brown') insert_sgroup('sgroup_two_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_brown') insert_sgroup('sgroup_two_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx2T()
end
    -- Brown 2Gr [2SGr x 3Tr]
function gr_br03() insert_sgroup('sgroup_three_brown') insert_sgroup('sgroup_three_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_brown') insert_sgroup('sgroup_three_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx3T()
end
    -- Brown 2Gr [2SGr x 4Tr]
function gr_br04() insert_sgroup('sgroup_four_brown') insert_sgroup('sgroup_four_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_brown') insert_sgroup('sgroup_four_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx4T()
end
    -- Brown 2Gr [2SGr x 5Tr]
function gr_br05() insert_sgroup('sgroup_five_brown') insert_sgroup('sgroup_five_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_brown') insert_sgroup('sgroup_five_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx5T()
end
    -- Brown 2Gr [2SGr x 6Tr]
function gr_br06() insert_sgroup('sgroup_six_brown') insert_sgroup('sgroup_six_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_brown') insert_sgroup('sgroup_six_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx6T()
end
    -- Brown 2Gr [2SGr x 7Tr]
function gr_br07() insert_sgroup('sgroup_seven_brown') insert_sgroup('sgroup_seven_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_brown') insert_sgroup('sgroup_seven_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx7T()
end
    -- Brown 2Gr [2SGr x 8Tr]
function gr_br08() insert_sgroup('sgroup_eight_brown') insert_sgroup('sgroup_eight_brown') insert_group('group_two_brown') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_brown') insert_sgroup('sgroup_eight_brown') insert_group('group_one_brown') instert_sgroups_to_group_2Gx8T()
end
    -- Brown 4Gr [2SGr x 2Tr]
function gr_br09() insert_sgroup('sgroup_two_brown') insert_sgroup('sgroup_two_brown') insert_group('group_four_brown')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_brown') insert_sgroup('sgroup_two_brown') insert_group('group_three_brown') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_brown') insert_sgroup('sgroup_two_brown') insert_group('group_two_brown')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_brown') insert_sgroup('sgroup_two_brown') insert_group('group_one_brown')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Brown 4SGr x 2Tr
function sgr_br01() insert_sgroup('sgroup_two_brown') insert_sgroup('sgroup_two_brown')
                    insert_sgroup('sgroup_two_brown') insert_sgroup('sgroup_two_brown')
end
    -- Brown 4SGr x 3Tr
function sgr_br02() insert_sgroup('sgroup_three_brown') insert_sgroup('sgroup_three_brown')
                    insert_sgroup('sgroup_three_brown') insert_sgroup('sgroup_three_brown')
end
    -- Brown 4SGr x 4Tr
function sgr_br03() insert_sgroup('sgroup_four_brown') insert_sgroup('sgroup_four_brown')
                    insert_sgroup('sgroup_four_brown') insert_sgroup('sgroup_four_brown')
end
    -- Brown 4SGr x 5Tr
function sgr_br04() insert_sgroup('sgroup_five_brown') insert_sgroup('sgroup_five_brown')
                    insert_sgroup('sgroup_five_brown') insert_sgroup('sgroup_five_brown')
end
    -- Brown 4SGr x 6Tr
function sgr_br05() insert_sgroup('sgroup_six_brown') insert_sgroup('sgroup_six_brown')
                    insert_sgroup('sgroup_six_brown') insert_sgroup('sgroup_six_brown')
end
    -- Brown 4SGr x 7Tr
function sgr_br06() insert_sgroup('sgroup_seven_brown') insert_sgroup('sgroup_seven_brown')
                    insert_sgroup('sgroup_seven_brown') insert_sgroup('sgroup_seven_brown')
end
    -- Brown 4SGr x 8Tr
function sgr_br07() insert_sgroup('sgroup_eight_brown') insert_sgroup('sgroup_eight_brown')
                    insert_sgroup('sgroup_eight_brown') insert_sgroup('sgroup_eight_brown')
end
    -- Brown 2SGr x 6Tr
function sgr_br08() insert_sgroup('sgroup_six_brown') insert_sgroup('sgroup_six_brown')
end
    -- Brown 2SGr x 8Tr
function sgr_br09() insert_sgroup('sgroup_eight_brown') insert_sgroup('sgroup_eight_brown')
end
    -- Brown 1SGr x 8Tr
function sgr_br10() insert_sgroup('sgroup_eight_brown')
end  

  
    -- Tracks (Not SubGroups) ----

    -- Brown 1AuxTr
function tr_bra1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbr.a1)
end

function tr_brb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbr.a2)
end
    -- Brown 2Tr
function tr_br02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbr.two) insert_track_only(rnst , tbr.one)
end
    -- Brown 4Tr
function tr_br03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbr.four)  insert_track_only(rnst , tbr.three) insert_track_only(rnst , tbr.two) insert_track_only(rnst , tbr.one)
end
    -- Brown 6Tr
function tr_br04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbr.six)   insert_track_only(rnst , tbr.five) insert_track_only(rnst , tbr.four)
                   insert_track_only(rnst , tbr.three) insert_track_only(rnst , tbr.two)  insert_track_only(rnst , tbr.one)
end
    -- Brown 8Tr
function tr_br05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbr.eight) insert_track_only(rnst , tbr.seven) insert_track_only(rnst , tbr.six) insert_track_only(rnst , tbr.five)
                   insert_track_only(rnst , tbr.four)  insert_track_only(rnst , tbr.three) insert_track_only(rnst , tbr.two) insert_track_only(rnst , tbr.one)
end
    -- Brown 4Tr + 2AuxTr
function tr_br06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbr.a2) insert_track_only(rnst , tbr.a1)
                   insert_track_only(rnst , tbr.four)  insert_track_only(rnst , tbr.three) insert_track_only(rnst , tbr.two) insert_track_only(rnst , tbr.one)
end
    -- Brown 8Tr + 2AuxTr
function tr_br07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tbr.a2) insert_track_only(rnst , tbr.a1)
                   insert_track_only(rnst , tbr.eight) insert_track_only(rnst , tbr.seven) insert_track_only(rnst , tbr.six) insert_track_only(rnst , tbr.five)
                   insert_track_only(rnst , tbr.four)  insert_track_only(rnst , tbr.three) insert_track_only(rnst , tbr.two) insert_track_only(rnst , tbr.one)
end



    --[[ == GOLD == ]]--
  
    -- Main Group ----
  
    -- Gold 1 Main Group
function mgr_gl01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tgl.a2)
                    insert_main_group('main_group_gold')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Gold 1MGr x 2Gr [2SGr x 2Tr]
function mgr_gl02() insert_sgroup('sgroup_two_gold') insert_sgroup('sgroup_two_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_gold') insert_sgroup('sgroup_two_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_gold') instert_groups_to_main_group_2Gx2T()
end
  
    -- Gold 1MGr x 2Gr [2SGr x 3Tr]
function mgr_gl03() insert_sgroup('sgroup_three_gold') insert_sgroup('sgroup_three_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_gold') insert_sgroup('sgroup_three_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_gold') instert_groups_to_main_group_2Gx3T()
end
  
    -- Gold 1MGr x 2Gr [2SGr x 4Tr]
function mgr_gl04() insert_sgroup('sgroup_four_gold') insert_sgroup('sgroup_four_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_gold') insert_sgroup('sgroup_four_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_gold') instert_groups_to_main_group_2Gx4T()
end
  
    -- Gold 1MGr x 2Gr [2SGr x 5Tr]
function mgr_gl05() insert_sgroup('sgroup_five_gold') insert_sgroup('sgroup_five_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_gold') insert_sgroup('sgroup_five_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_gold') instert_groups_to_main_group_2Gx5T()
end
  
    -- Gold 1MGr x 2Gr [2SGr x 6Tr]
function mgr_gl06() insert_sgroup('sgroup_six_gold') insert_sgroup('sgroup_six_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_gold') insert_sgroup('sgroup_six_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_gold') instert_groups_to_main_group_2Gx6T()
end
  
    -- Gold 1MGr x 2Gr [2SGr x 7Tr]
function mgr_gl07() insert_sgroup('sgroup_seven_gold') insert_sgroup('sgroup_seven_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_gold') insert_sgroup('sgroup_seven_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_gold') instert_groups_to_main_group_2Gx7T()
end
  
    -- Gold 1MGr x 2Gr [2SGr x 8Tr]
function mgr_gl08() insert_sgroup('sgroup_eight_gold') insert_sgroup('sgroup_eight_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_gold') insert_sgroup('sgroup_eight_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_gold') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Gold 1 Group
function gr_gl01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tgl.a2)
                   insert_group('group_one_gold')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Gold 2Gr [2SGr x 2Tr]
function gr_gl02() insert_sgroup('sgroup_two_gold') insert_sgroup('sgroup_two_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_gold') insert_sgroup('sgroup_two_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx2T()
end
    -- Gold 2Gr [2SGr x 3Tr]
function gr_gl03() insert_sgroup('sgroup_three_gold') insert_sgroup('sgroup_three_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_gold') insert_sgroup('sgroup_three_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx3T()
end
    -- Gold 2Gr [2SGr x 4Tr]
function gr_gl04() insert_sgroup('sgroup_four_gold') insert_sgroup('sgroup_four_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_gold') insert_sgroup('sgroup_four_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx4T()
end
    -- Gold 2Gr [2SGr x 5Tr]
function gr_gl05() insert_sgroup('sgroup_five_gold') insert_sgroup('sgroup_five_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_gold') insert_sgroup('sgroup_five_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx5T()
end
    -- Gold 2Gr [2SGr x 6Tr]
function gr_gl06() insert_sgroup('sgroup_six_gold') insert_sgroup('sgroup_six_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_gold') insert_sgroup('sgroup_six_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx6T()
end
    -- Gold 2Gr [2SGr x 7Tr]
function gr_gl07() insert_sgroup('sgroup_seven_gold') insert_sgroup('sgroup_seven_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_gold') insert_sgroup('sgroup_seven_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx7T()
end
    -- Gold 2Gr [2SGr x 8Tr]
function gr_gl08() insert_sgroup('sgroup_eight_gold') insert_sgroup('sgroup_eight_gold') insert_group('group_two_gold') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_gold') insert_sgroup('sgroup_eight_gold') insert_group('group_one_gold') instert_sgroups_to_group_2Gx8T()
end
    -- Gold 4Gr [2SGr x 2Tr]
function gr_gl09() insert_sgroup('sgroup_two_gold') insert_sgroup('sgroup_two_gold') insert_group('group_four_gold')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_gold') insert_sgroup('sgroup_two_gold') insert_group('group_three_gold') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_gold') insert_sgroup('sgroup_two_gold') insert_group('group_two_gold')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_gold') insert_sgroup('sgroup_two_gold') insert_group('group_one_gold')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Gold 4SGr x 2Tr
function sgr_gl01() insert_sgroup('sgroup_two_gold') insert_sgroup('sgroup_two_gold')
                    insert_sgroup('sgroup_two_gold') insert_sgroup('sgroup_two_gold')
end
    -- Gold 4SGr x 3Tr
function sgr_gl02() insert_sgroup('sgroup_three_gold') insert_sgroup('sgroup_three_gold')
                    insert_sgroup('sgroup_three_gold') insert_sgroup('sgroup_three_gold')
end
    -- Gold 4SGr x 4Tr
function sgr_gl03() insert_sgroup('sgroup_four_gold') insert_sgroup('sgroup_four_gold')
                    insert_sgroup('sgroup_four_gold') insert_sgroup('sgroup_four_gold')
end
    -- Gold 4SGr x 5Tr
function sgr_gl04() insert_sgroup('sgroup_five_gold') insert_sgroup('sgroup_five_gold')
                    insert_sgroup('sgroup_five_gold') insert_sgroup('sgroup_five_gold')
end
    -- Gold 4SGr x 6Tr
function sgr_gl05() insert_sgroup('sgroup_six_gold') insert_sgroup('sgroup_six_gold')
                    insert_sgroup('sgroup_six_gold') insert_sgroup('sgroup_six_gold')
end
    -- Gold 4SGr x 7Tr
function sgr_gl06() insert_sgroup('sgroup_seven_gold') insert_sgroup('sgroup_seven_gold')
                    insert_sgroup('sgroup_seven_gold') insert_sgroup('sgroup_seven_gold')
end
    -- Gold 4SGr x 8Tr
function sgr_gl07() insert_sgroup('sgroup_eight_gold') insert_sgroup('sgroup_eight_gold')
                    insert_sgroup('sgroup_eight_gold') insert_sgroup('sgroup_eight_gold')
end
    -- Gold 2SGr x 6Tr
function sgr_gl08() insert_sgroup('sgroup_six_gold') insert_sgroup('sgroup_six_gold')
end
    -- Gold 2SGr x 8Tr
function sgr_gl09() insert_sgroup('sgroup_eight_gold') insert_sgroup('sgroup_eight_gold')
end
    -- Gold 1SGr x 8Tr
function sgr_gl10() insert_sgroup('sgroup_eight_gold')
end

  
    -- Tracks (Not SubGroups) ----

    -- Gold 1AuxTr
function tr_gla1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgl.a1)
end

function tr_glb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgl.a2)
end
    -- Gold 2Tr
function tr_gl02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgl.two) insert_track_only(rnst , tgl.one)
end
    -- Gold 4Tr
function tr_gl03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgl.four)  insert_track_only(rnst , tgl.three) insert_track_only(rnst , tgl.two) insert_track_only(rnst , tgl.one)
end
    -- Gold 6Tr
function tr_gl04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgl.six)   insert_track_only(rnst , tgl.five) insert_track_only(rnst , tgl.four)
                   insert_track_only(rnst , tgl.three) insert_track_only(rnst , tgl.two)  insert_track_only(rnst , tgl.one)
end
    -- Gold 8Tr
function tr_gl05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgl.eight) insert_track_only(rnst , tgl.seven) insert_track_only(rnst , tgl.six) insert_track_only(rnst , tgl.five)
                   insert_track_only(rnst , tgl.four)  insert_track_only(rnst , tgl.three) insert_track_only(rnst , tgl.two) insert_track_only(rnst , tgl.one)
end
    -- Gold 4Tr + 2AuxTr
function tr_gl06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgl.a2) insert_track_only(rnst , tgl.a1)
                   insert_track_only(rnst , tgl.four)  insert_track_only(rnst , tgl.three) insert_track_only(rnst , tgl.two) insert_track_only(rnst , tgl.one)
end
    -- Gold 8Tr + 2AuxTr
function tr_gl07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgl.a2) insert_track_only(rnst , tgl.a1)
                   insert_track_only(rnst , tgl.eight) insert_track_only(rnst , tgl.seven) insert_track_only(rnst , tgl.six) insert_track_only(rnst , tgl.five)
                   insert_track_only(rnst , tgl.four)  insert_track_only(rnst , tgl.three) insert_track_only(rnst , tgl.two) insert_track_only(rnst , tgl.one)
end
  


    --[[ == GRAY == ]]--
  
    -- Main Group ----
  
    -- Gray 1 Main Group
function mgr_gy01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tgy.a2)
                    insert_main_group('main_group_gray')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Gray 1MGr x 2Gr [2SGr x 2Tr]
function mgr_gy02() insert_sgroup('sgroup_two_gray') insert_sgroup('sgroup_two_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_gray') insert_sgroup('sgroup_two_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_gray') instert_groups_to_main_group_2Gx2T()
end
  
    -- Gray 1MGr x 2Gr [2SGr x 3Tr]
function mgr_gy03() insert_sgroup('sgroup_three_gray') insert_sgroup('sgroup_three_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_gray') insert_sgroup('sgroup_three_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_gray') instert_groups_to_main_group_2Gx3T()
end
  
    -- Gray 1MGr x 2Gr [2SGr x 4Tr]
function mgr_gy04() insert_sgroup('sgroup_four_gray') insert_sgroup('sgroup_four_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_gray') insert_sgroup('sgroup_four_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_gray') instert_groups_to_main_group_2Gx4T()
end
  
    -- Gray 1MGr x 2Gr [2SGr x 5Tr]
function mgr_gy05() insert_sgroup('sgroup_five_gray') insert_sgroup('sgroup_five_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_gray') insert_sgroup('sgroup_five_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_gray') instert_groups_to_main_group_2Gx5T()
end
  
    -- Gray 1MGr x 2Gr [2SGr x 6Tr]
function mgr_gy06() insert_sgroup('sgroup_six_gray') insert_sgroup('sgroup_six_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_gray') insert_sgroup('sgroup_six_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_gray') instert_groups_to_main_group_2Gx6T()
end
  
    -- Gray 1MGr x 2Gr [2SGr x 7Tr]
function mgr_gy07() insert_sgroup('sgroup_seven_gray') insert_sgroup('sgroup_seven_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_gray') insert_sgroup('sgroup_seven_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_gray') instert_groups_to_main_group_2Gx7T()
end
  
    -- Gray 1MGr x 2Gr [2SGr x 8Tr]
function mgr_gy08() insert_sgroup('sgroup_eight_gray') insert_sgroup('sgroup_eight_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_gray') insert_sgroup('sgroup_eight_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_gray') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Gray 1 Group
function gr_gy01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tgy.a2)
                   insert_group('group_one_gray')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Gray 2Gr [2SGr x 2Tr]
function gr_gy02() insert_sgroup('sgroup_two_gray') insert_sgroup('sgroup_two_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_gray') insert_sgroup('sgroup_two_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx2T()
end
    -- Gray 2Gr [2SGr x 3Tr]
function gr_gy03() insert_sgroup('sgroup_three_gray') insert_sgroup('sgroup_three_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_gray') insert_sgroup('sgroup_three_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx3T()
end
    -- Gray 2Gr [2SGr x 4Tr]
function gr_gy04() insert_sgroup('sgroup_four_gray') insert_sgroup('sgroup_four_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_gray') insert_sgroup('sgroup_four_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx4T()
end
    -- Gray 2Gr [2SGr x 5Tr]
function gr_gy05() insert_sgroup('sgroup_five_gray') insert_sgroup('sgroup_five_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_gray') insert_sgroup('sgroup_five_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx5T()
end
    -- Gray 2Gr [2SGr x 6Tr]
function gr_gy06() insert_sgroup('sgroup_six_gray') insert_sgroup('sgroup_six_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_gray') insert_sgroup('sgroup_six_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx6T()
end
    -- Gray 2Gr [2SGr x 7Tr]
function gr_gy07() insert_sgroup('sgroup_seven_gray') insert_sgroup('sgroup_seven_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_gray') insert_sgroup('sgroup_seven_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx7T()
end
    -- Gray 2Gr [2SGr x 8Tr]
function gr_gy08() insert_sgroup('sgroup_eight_gray') insert_sgroup('sgroup_eight_gray') insert_group('group_two_gray') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_gray') insert_sgroup('sgroup_eight_gray') insert_group('group_one_gray') instert_sgroups_to_group_2Gx8T()
end
    -- Gray 4Gr [2SGr x 2Tr]
function gr_gy09() insert_sgroup('sgroup_two_gray') insert_sgroup('sgroup_two_gray') insert_group('group_four_gray')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_gray') insert_sgroup('sgroup_two_gray') insert_group('group_three_gray') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_gray') insert_sgroup('sgroup_two_gray') insert_group('group_two_gray')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_gray') insert_sgroup('sgroup_two_gray') insert_group('group_one_gray')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Gray 4SGr x 2Tr
function sgr_gy01() insert_sgroup('sgroup_two_gray') insert_sgroup('sgroup_two_gray')
                    insert_sgroup('sgroup_two_gray') insert_sgroup('sgroup_two_gray')
end
    -- Gray 4SGr x 3Tr
function sgr_gy02() insert_sgroup('sgroup_three_gray') insert_sgroup('sgroup_three_gray')
                    insert_sgroup('sgroup_three_gray') insert_sgroup('sgroup_three_gray')
end
    -- Gray 4SGr x 4Tr
function sgr_gy03() insert_sgroup('sgroup_four_gray') insert_sgroup('sgroup_four_gray')
                    insert_sgroup('sgroup_four_gray') insert_sgroup('sgroup_four_gray')
end
    -- Gray 4SGr x 5Tr
function sgr_gy04() insert_sgroup('sgroup_five_gray') insert_sgroup('sgroup_five_gray')
                    insert_sgroup('sgroup_five_gray') insert_sgroup('sgroup_five_gray')
end
    -- Gray 4SGr x 6Tr
function sgr_gy05() insert_sgroup('sgroup_six_gray') insert_sgroup('sgroup_six_gray')
                    insert_sgroup('sgroup_six_gray') insert_sgroup('sgroup_six_gray')
end
    -- Gray 4SGr x 7Tr
function sgr_gy06() insert_sgroup('sgroup_seven_gray') insert_sgroup('sgroup_seven_gray')
                    insert_sgroup('sgroup_seven_gray') insert_sgroup('sgroup_seven_gray')
end
    -- Gray 4SGr x 8Tr
function sgr_gy07() insert_sgroup('sgroup_eight_gray') insert_sgroup('sgroup_eight_gray')
                    insert_sgroup('sgroup_eight_gray') insert_sgroup('sgroup_eight_gray')
end
    -- Gray 2SGr x 6Tr
function sgr_gy08() insert_sgroup('sgroup_six_gray') insert_sgroup('sgroup_six_gray')
end
    -- Gray 2SGr x 8Tr
function sgr_gy09() insert_sgroup('sgroup_eight_gray') insert_sgroup('sgroup_eight_gray')
end
    -- Gray 1SGr x 8Tr
function sgr_gy10() insert_sgroup('sgroup_eight_gray')
end

  
    -- Tracks (Not SubGroups) ----

    -- Gray 1AuxTr
function tr_gya1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgy.a1)
end

function tr_gyb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgy.a2)
end
    -- Gray 2Tr
function tr_gy02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgy.two) insert_track_only(rnst , tgy.one)
end
    -- Gray 4Tr
function tr_gy03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgy.four)  insert_track_only(rnst , tgy.three) insert_track_only(rnst , tgy.two) insert_track_only(rnst , tgy.one)
end
    -- Gray 6Tr
function tr_gy04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgy.six)   insert_track_only(rnst , tgy.five) insert_track_only(rnst , tgy.four)
                   insert_track_only(rnst , tgy.three) insert_track_only(rnst , tgy.two)  insert_track_only(rnst , tgy.one)
end
    -- Gray 8Tr
function tr_gy05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgy.eight) insert_track_only(rnst , tgy.seven) insert_track_only(rnst , tgy.six) insert_track_only(rnst , tgy.five)
                   insert_track_only(rnst , tgy.four)  insert_track_only(rnst , tgy.three) insert_track_only(rnst , tgy.two) insert_track_only(rnst , tgy.one)
end
    -- Gray 4Tr + 2AuxTr
function tr_gy06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgy.a2) insert_track_only(rnst , tgy.a1)
                   insert_track_only(rnst , tgy.four)  insert_track_only(rnst , tgy.three) insert_track_only(rnst , tgy.two) insert_track_only(rnst , tgy.one)
end
    -- Gray 8Tr + 2AuxTr
function tr_gy07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgy.a2) insert_track_only(rnst , tgy.a1)
                   insert_track_only(rnst , tgy.eight) insert_track_only(rnst , tgy.seven) insert_track_only(rnst , tgy.six) insert_track_only(rnst , tgy.five)
                   insert_track_only(rnst , tgy.four)  insert_track_only(rnst , tgy.three) insert_track_only(rnst , tgy.two) insert_track_only(rnst , tgy.one)
end
  


    --[[ == GREEN == ]]--
  
    -- Main Group ----
  
    -- Green 1 Main Group
function mgr_gr01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tgr.a2)
                    insert_main_group('main_group_green')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Green 1MGr x 2Gr [2SGr x 2Tr]
function mgr_gr02() insert_sgroup('sgroup_two_green') insert_sgroup('sgroup_two_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_green') insert_sgroup('sgroup_two_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_green') instert_groups_to_main_group_2Gx2T()
end
  
    -- Green 1MGr x 2Gr [2SGr x 3Tr]
function mgr_gr03() insert_sgroup('sgroup_three_green') insert_sgroup('sgroup_three_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_green') insert_sgroup('sgroup_three_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_green') instert_groups_to_main_group_2Gx3T()
end
  
    -- Green 1MGr x 2Gr [2SGr x 4Tr]
function mgr_gr04() insert_sgroup('sgroup_four_green') insert_sgroup('sgroup_four_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_green') insert_sgroup('sgroup_four_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_green') instert_groups_to_main_group_2Gx4T()
end
  
    -- Green 1MGr x 2Gr [2SGr x 5Tr]
function mgr_gr05() insert_sgroup('sgroup_five_green') insert_sgroup('sgroup_five_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_green') insert_sgroup('sgroup_five_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_green') instert_groups_to_main_group_2Gx5T()
end
  
    -- Green 1MGr x 2Gr [2SGr x 6Tr]
function mgr_gr06() insert_sgroup('sgroup_six_green') insert_sgroup('sgroup_six_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_green') insert_sgroup('sgroup_six_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_green') instert_groups_to_main_group_2Gx6T()
end
  
    -- Green 1MGr x 2Gr [2SGr x 7Tr]
function mgr_gr07() insert_sgroup('sgroup_seven_green') insert_sgroup('sgroup_seven_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_green') insert_sgroup('sgroup_seven_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_green') instert_groups_to_main_group_2Gx7T()
end
  
    -- Green 1MGr x 2Gr [2SGr x 8Tr]
function mgr_gr08() insert_sgroup('sgroup_eight_green') insert_sgroup('sgroup_eight_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_green') insert_sgroup('sgroup_eight_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_green') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Green 1 Group
function gr_gr01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tgr.a2)
                   insert_group('group_one_green')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Green 2Gr [2SGr x 2Tr]
function gr_gr02() insert_sgroup('sgroup_two_green') insert_sgroup('sgroup_two_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_green') insert_sgroup('sgroup_two_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx2T()
end
    -- Green 2Gr [2SGr x 3Tr]
function gr_gr03() insert_sgroup('sgroup_three_green') insert_sgroup('sgroup_three_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_green') insert_sgroup('sgroup_three_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx3T()
end
    -- Green 2Gr [2SGr x 4Tr]
function gr_gr04() insert_sgroup('sgroup_four_green') insert_sgroup('sgroup_four_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_green') insert_sgroup('sgroup_four_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx4T()
end
    -- Green 2Gr [2SGr x 5Tr]
function gr_gr05() insert_sgroup('sgroup_five_green') insert_sgroup('sgroup_five_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_green') insert_sgroup('sgroup_five_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx5T()
end
    -- Green 2Gr [2SGr x 6Tr]
function gr_gr06() insert_sgroup('sgroup_six_green') insert_sgroup('sgroup_six_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_green') insert_sgroup('sgroup_six_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx6T()
end
    -- Green 2Gr [2SGr x 7Tr]
function gr_gr07() insert_sgroup('sgroup_seven_green') insert_sgroup('sgroup_seven_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_green') insert_sgroup('sgroup_seven_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx7T()
end
    -- Green 2Gr [2SGr x 8Tr]
function gr_gr08() insert_sgroup('sgroup_eight_green') insert_sgroup('sgroup_eight_green') insert_group('group_two_green') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_green') insert_sgroup('sgroup_eight_green') insert_group('group_one_green') instert_sgroups_to_group_2Gx8T()
end
    -- Green 4Gr [2SGr x 2Tr]
function gr_gr09() insert_sgroup('sgroup_two_green') insert_sgroup('sgroup_two_green') insert_group('group_four_green')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_green') insert_sgroup('sgroup_two_green') insert_group('group_three_green') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_green') insert_sgroup('sgroup_two_green') insert_group('group_two_green')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_green') insert_sgroup('sgroup_two_green') insert_group('group_one_green')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Green 4SGr x 2Tr
function sgr_gr01() insert_sgroup('sgroup_two_green') insert_sgroup('sgroup_two_green')
                    insert_sgroup('sgroup_two_green') insert_sgroup('sgroup_two_green')
end
    -- Green 4SGr x 3Tr
function sgr_gr02() insert_sgroup('sgroup_three_green') insert_sgroup('sgroup_three_green')
                    insert_sgroup('sgroup_three_green') insert_sgroup('sgroup_three_green')
end
    -- Green 4SGr x 4Tr
function sgr_gr03() insert_sgroup('sgroup_four_green') insert_sgroup('sgroup_four_green')
                    insert_sgroup('sgroup_four_green') insert_sgroup('sgroup_four_green')
end
    -- Green 4SGr x 5Tr
function sgr_gr04() insert_sgroup('sgroup_five_green') insert_sgroup('sgroup_five_green')
                    insert_sgroup('sgroup_five_green') insert_sgroup('sgroup_five_green')
end
    -- Green 4SGr x 6Tr
function sgr_gr05() insert_sgroup('sgroup_six_green') insert_sgroup('sgroup_six_green')
                    insert_sgroup('sgroup_six_green') insert_sgroup('sgroup_six_green')
end
    -- Green 4SGr x 7Tr
function sgr_gr06() insert_sgroup('sgroup_seven_green') insert_sgroup('sgroup_seven_green')
                    insert_sgroup('sgroup_seven_green') insert_sgroup('sgroup_seven_green')
end
    -- Green 4SGr x 8Tr
function sgr_gr07() insert_sgroup('sgroup_eight_green') insert_sgroup('sgroup_eight_green')
                    insert_sgroup('sgroup_eight_green') insert_sgroup('sgroup_eight_green')
end
    -- Green 2SGr x 6Tr
function sgr_gr08() insert_sgroup('sgroup_six_green') insert_sgroup('sgroup_six_green')
end
    -- Green 2SGr x 8Tr
function sgr_gr09() insert_sgroup('sgroup_eight_green') insert_sgroup('sgroup_eight_green')
end
    -- Green 1SGr x 8Tr
function sgr_gr10() insert_sgroup('sgroup_eight_green')
end

  
    -- Tracks (Not SubGroups) ----

    -- Green 1AuxTr
function tr_gra1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgr.a1)
end

function tr_grb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgr.a2)
end
    -- Green 2Tr
function tr_gr02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgr.two) insert_track_only(rnst , tgr.one)
end
    -- Green 4Tr
function tr_gr03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgr.four)  insert_track_only(rnst , tgr.three) insert_track_only(rnst , tgr.two) insert_track_only(rnst , tgr.one)
end
    -- Green 6Tr
function tr_gr04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgr.six)   insert_track_only(rnst , tgr.five) insert_track_only(rnst , tgr.four)
                   insert_track_only(rnst , tgr.three) insert_track_only(rnst , tgr.two)  insert_track_only(rnst , tgr.one)
end
    -- Green 8Tr
function tr_gr05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgr.eight) insert_track_only(rnst , tgr.seven) insert_track_only(rnst , tgr.six) insert_track_only(rnst , tgr.five)
                   insert_track_only(rnst , tgr.four)  insert_track_only(rnst , tgr.three) insert_track_only(rnst , tgr.two) insert_track_only(rnst , tgr.one)
end
    -- Green 4Tr + 2AuxTr
function tr_gr06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgr.a2) insert_track_only(rnst , tgr.a1)
                   insert_track_only(rnst , tgr.four)  insert_track_only(rnst , tgr.three) insert_track_only(rnst , tgr.two) insert_track_only(rnst , tgr.one)
end
    -- Green 8Tr + 2AuxTr
function tr_gr07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tgr.a2) insert_track_only(rnst , tgr.a1)
                   insert_track_only(rnst , tgr.eight) insert_track_only(rnst , tgr.seven) insert_track_only(rnst , tgr.six) insert_track_only(rnst , tgr.five)
                   insert_track_only(rnst , tgr.four)  insert_track_only(rnst , tgr.three) insert_track_only(rnst , tgr.two) insert_track_only(rnst , tgr.one)
end



    --[[ == ORANGE == ]]--
  
    -- Main Group ----
  
    -- Orange 1 Main Group
function mgr_or01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tor.a2)
                    insert_main_group('main_group_orange')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Orange 1MGr x 2Gr [2SGr x 2Tr]
function mgr_or02() insert_sgroup('sgroup_two_orange') insert_sgroup('sgroup_two_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_orange') insert_sgroup('sgroup_two_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_orange') instert_groups_to_main_group_2Gx2T()
end
  
    -- Orange 1MGr x 2Gr [2SGr x 3Tr]
function mgr_or03() insert_sgroup('sgroup_three_orange') insert_sgroup('sgroup_three_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_orange') insert_sgroup('sgroup_three_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_orange') instert_groups_to_main_group_2Gx3T()
end
  
    -- Orange 1MGr x 2Gr [2SGr x 4Tr]
function mgr_or04() insert_sgroup('sgroup_four_orange') insert_sgroup('sgroup_four_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_orange') insert_sgroup('sgroup_four_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_orange') instert_groups_to_main_group_2Gx4T()
end
  
    -- Orange 1MGr x 2Gr [2SGr x 5Tr]
function mgr_or05() insert_sgroup('sgroup_five_orange') insert_sgroup('sgroup_five_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_orange') insert_sgroup('sgroup_five_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_orange') instert_groups_to_main_group_2Gx5T()
end
  
    -- Orange 1MGr x 2Gr [2SGr x 6Tr]
function mgr_or06() insert_sgroup('sgroup_six_orange') insert_sgroup('sgroup_six_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_orange') insert_sgroup('sgroup_six_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_orange') instert_groups_to_main_group_2Gx6T()
end
  
    -- Orange 1MGr x 2Gr [2SGr x 7Tr]
function mgr_or07() insert_sgroup('sgroup_seven_orange') insert_sgroup('sgroup_seven_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_orange') insert_sgroup('sgroup_seven_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_orange') instert_groups_to_main_group_2Gx7T()
end
  
    -- Orange 1MGr x 2Gr [2SGr x 8Tr]
function mgr_or08() insert_sgroup('sgroup_eight_orange') insert_sgroup('sgroup_eight_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_orange') insert_sgroup('sgroup_eight_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_orange') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Orange 1 Group
function gr_or01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tor.a2)
                   insert_group('group_one_orange')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Orange 2Gr [2SGr x 2Tr]
function gr_or02() insert_sgroup('sgroup_two_orange') insert_sgroup('sgroup_two_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_orange') insert_sgroup('sgroup_two_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx2T()
end
    -- Orange 2Gr [2SGr x 3Tr]
function gr_or03() insert_sgroup('sgroup_three_orange') insert_sgroup('sgroup_three_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_orange') insert_sgroup('sgroup_three_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx3T()
end
    -- Orange 2Gr [2SGr x 4Tr]
function gr_or04() insert_sgroup('sgroup_four_orange') insert_sgroup('sgroup_four_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_orange') insert_sgroup('sgroup_four_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx4T()
end
    -- Orange 2Gr [2SGr x 5Tr]
function gr_or05() insert_sgroup('sgroup_five_orange') insert_sgroup('sgroup_five_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_orange') insert_sgroup('sgroup_five_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx5T()
end
    -- Orange 2Gr [2SGr x 6Tr]
function gr_or06() insert_sgroup('sgroup_six_orange') insert_sgroup('sgroup_six_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_orange') insert_sgroup('sgroup_six_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx6T()
end
    -- Orange 2Gr [2SGr x 7Tr]
function gr_or07() insert_sgroup('sgroup_seven_orange') insert_sgroup('sgroup_seven_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_orange') insert_sgroup('sgroup_seven_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx7T()
end
    -- Orange 2Gr [2SGr x 8Tr]
function gr_or08() insert_sgroup('sgroup_eight_orange') insert_sgroup('sgroup_eight_orange') insert_group('group_two_orange') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_orange') insert_sgroup('sgroup_eight_orange') insert_group('group_one_orange') instert_sgroups_to_group_2Gx8T()
end
    -- Orange 4Gr [2SGr x 2Tr]
function gr_or09() insert_sgroup('sgroup_two_orange') insert_sgroup('sgroup_two_orange') insert_group('group_four_orange')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_orange') insert_sgroup('sgroup_two_orange') insert_group('group_three_orange') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_orange') insert_sgroup('sgroup_two_orange') insert_group('group_two_orange')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_orange') insert_sgroup('sgroup_two_orange') insert_group('group_one_orange')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Orange 4SGr x 2Tr
function sgr_or01() insert_sgroup('sgroup_two_orange') insert_sgroup('sgroup_two_orange')
                    insert_sgroup('sgroup_two_orange') insert_sgroup('sgroup_two_orange')
end
    -- Orange 4SGr x 3Tr
function sgr_or02() insert_sgroup('sgroup_three_orange') insert_sgroup('sgroup_three_orange')
                    insert_sgroup('sgroup_three_orange') insert_sgroup('sgroup_three_orange')
end
    -- Orange 4SGr x 4Tr
function sgr_or03() insert_sgroup('sgroup_four_orange') insert_sgroup('sgroup_four_orange')
                    insert_sgroup('sgroup_four_orange') insert_sgroup('sgroup_four_orange')
end
    -- Orange 4SGr x 5Tr
function sgr_or04() insert_sgroup('sgroup_five_orange') insert_sgroup('sgroup_five_orange')
                    insert_sgroup('sgroup_five_orange') insert_sgroup('sgroup_five_orange')
end
    -- Orange 4SGr x 6Tr
function sgr_or05() insert_sgroup('sgroup_six_orange') insert_sgroup('sgroup_six_orange')
                    insert_sgroup('sgroup_six_orange') insert_sgroup('sgroup_six_orange')
end
    -- Orange 4SGr x 7Tr
function sgr_or06() insert_sgroup('sgroup_seven_orange') insert_sgroup('sgroup_seven_orange')
                    insert_sgroup('sgroup_seven_orange') insert_sgroup('sgroup_seven_orange')
end
    -- Orange 4SGr x 8Tr
function sgr_or07() insert_sgroup('sgroup_eight_orange') insert_sgroup('sgroup_eight_orange')
                    insert_sgroup('sgroup_eight_orange') insert_sgroup('sgroup_eight_orange')
end
    -- Orange 2SGr x 6Tr
function sgr_or08() insert_sgroup('sgroup_six_orange') insert_sgroup('sgroup_six_orange')
end
    -- Orange 2SGr x 8Tr
function sgr_or09() insert_sgroup('sgroup_eight_orange') insert_sgroup('sgroup_eight_orange')
end
    -- Orange 1SGr x 8Tr
function sgr_or10() insert_sgroup('sgroup_eight_orange')
end

  
    -- Tracks (Not SubGroups) ----

    -- Orange 1AuxTr
function tr_ora1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tor.a1)
end

function tr_orb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tor.a2)
end
    -- Orange 2Tr
function tr_or02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tor.two) insert_track_only(rnst , tor.one)
end
    -- Orange 4Tr
function tr_or03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tor.four)  insert_track_only(rnst , tor.three) insert_track_only(rnst , tor.two) insert_track_only(rnst , tor.one)
end
    -- Orange 6Tr
function tr_or04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tor.six)   insert_track_only(rnst , tor.five) insert_track_only(rnst , tor.four)
                   insert_track_only(rnst , tor.three) insert_track_only(rnst , tor.two)  insert_track_only(rnst , tor.one)
end
    -- Orange 8Tr
function tr_or05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tor.eight) insert_track_only(rnst , tor.seven) insert_track_only(rnst , tor.six) insert_track_only(rnst , tor.five)
                   insert_track_only(rnst , tor.four)  insert_track_only(rnst , tor.three) insert_track_only(rnst , tor.two) insert_track_only(rnst , tor.one)
end
    -- Orange 4Tr + 2AuxTr
function tr_or06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tor.a2) insert_track_only(rnst , tor.a1)
                   insert_track_only(rnst , tor.four)  insert_track_only(rnst , tor.three) insert_track_only(rnst , tor.two) insert_track_only(rnst , tor.one)
end
    -- Orange 8Tr + 2AuxTr
function tr_or07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tor.a2) insert_track_only(rnst , tor.a1)
                   insert_track_only(rnst , tor.eight) insert_track_only(rnst , tor.seven) insert_track_only(rnst , tor.six) insert_track_only(rnst , tor.five)
                   insert_track_only(rnst , tor.four)  insert_track_only(rnst , tor.three) insert_track_only(rnst , tor.two) insert_track_only(rnst , tor.one)
end



    --[[ == PALE PINK == ]]--
  
    -- Main Group ----
  
    -- Pale Pink 1 Main Group
function mgr_pl01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tpl.a2)
                    insert_main_group('main_group_pale')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Pale Pink 1MGr x 2Gr [2SGr x 2Tr]
function mgr_pl02() insert_sgroup('sgroup_two_pale') insert_sgroup('sgroup_two_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_pale') insert_sgroup('sgroup_two_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_pale') instert_groups_to_main_group_2Gx2T()
end
  
    -- Pale Pink 1MGr x 2Gr [2SGr x 3Tr]
function mgr_pl03() insert_sgroup('sgroup_three_pale') insert_sgroup('sgroup_three_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_pale') insert_sgroup('sgroup_three_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_pale') instert_groups_to_main_group_2Gx3T()
end
  
    -- Pale Pink 1MGr x 2Gr [2SGr x 4Tr]
function mgr_pl04() insert_sgroup('sgroup_four_pale') insert_sgroup('sgroup_four_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_pale') insert_sgroup('sgroup_four_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_pale') instert_groups_to_main_group_2Gx4T()
end
  
    -- Pale Pink 1MGr x 2Gr [2SGr x 5Tr]
function mgr_pl05() insert_sgroup('sgroup_five_pale') insert_sgroup('sgroup_five_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_pale') insert_sgroup('sgroup_five_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_pale') instert_groups_to_main_group_2Gx5T()
end
  
    -- Pale Pink 1MGr x 2Gr [2SGr x 6Tr]
function mgr_pl06() insert_sgroup('sgroup_six_pale') insert_sgroup('sgroup_six_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_pale') insert_sgroup('sgroup_six_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_pale') instert_groups_to_main_group_2Gx6T()
end
  
    -- Pale Pink 1MGr x 2Gr [2SGr x 7Tr]
function mgr_pl07() insert_sgroup('sgroup_seven_pale') insert_sgroup('sgroup_seven_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_pale') insert_sgroup('sgroup_seven_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_pale') instert_groups_to_main_group_2Gx7T()
end
  
    -- Pale Pink 1MGr x 2Gr [2SGr x 8Tr]
function mgr_pl08() insert_sgroup('sgroup_eight_pale') insert_sgroup('sgroup_eight_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_pale') insert_sgroup('sgroup_eight_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_pale') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Pale Pink 1 Group
function gr_pl01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tpl.a2)
                   insert_group('group_one_pale')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Pale Pink 2Gr [2SGr x 2Tr]
function gr_pl02() insert_sgroup('sgroup_two_pale') insert_sgroup('sgroup_two_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pale') insert_sgroup('sgroup_two_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx2T()
end
    -- Pale Pink 2Gr [2SGr x 3Tr]
function gr_pl03() insert_sgroup('sgroup_three_pale') insert_sgroup('sgroup_three_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_pale') insert_sgroup('sgroup_three_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx3T()
end
    -- Pale Pink 2Gr [2SGr x 4Tr]
function gr_pl04() insert_sgroup('sgroup_four_pale') insert_sgroup('sgroup_four_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_pale') insert_sgroup('sgroup_four_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx4T()
end
    -- Pale Pink 2Gr [2SGr x 5Tr]
function gr_pl05() insert_sgroup('sgroup_five_pale') insert_sgroup('sgroup_five_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_pale') insert_sgroup('sgroup_five_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx5T()
end
    -- Pale Pink 2Gr [2SGr x 6Tr]
function gr_pl06() insert_sgroup('sgroup_six_pale') insert_sgroup('sgroup_six_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_pale') insert_sgroup('sgroup_six_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx6T()
end
    -- Pale Pink 2Gr [2SGr x 7Tr]
function gr_pl07() insert_sgroup('sgroup_seven_pale') insert_sgroup('sgroup_seven_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_pale') insert_sgroup('sgroup_seven_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx7T()
end
    -- Pale Pink 2Gr [2SGr x 8Tr]
function gr_pl08() insert_sgroup('sgroup_eight_pale') insert_sgroup('sgroup_eight_pale') insert_group('group_two_pale') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_pale') insert_sgroup('sgroup_eight_pale') insert_group('group_one_pale') instert_sgroups_to_group_2Gx8T()
end
    -- Pale Pink 4Gr [2SGr x 2Tr]
function gr_pl09() insert_sgroup('sgroup_two_pale') insert_sgroup('sgroup_two_pale') insert_group('group_four_pale')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pale') insert_sgroup('sgroup_two_pale') insert_group('group_three_pale') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pale') insert_sgroup('sgroup_two_pale') insert_group('group_two_pale')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pale') insert_sgroup('sgroup_two_pale') insert_group('group_one_pale')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Pale Pink 4SGr x 2Tr
function sgr_pl01() insert_sgroup('sgroup_two_pale') insert_sgroup('sgroup_two_pale')
                    insert_sgroup('sgroup_two_pale') insert_sgroup('sgroup_two_pale')
end
    -- Pale Pink 4SGr x 3Tr
function sgr_pl02() insert_sgroup('sgroup_three_pale') insert_sgroup('sgroup_three_pale')
                    insert_sgroup('sgroup_three_pale') insert_sgroup('sgroup_three_pale')
end
    -- Pale Pink 4SGr x 4Tr
function sgr_pl03() insert_sgroup('sgroup_four_pale') insert_sgroup('sgroup_four_pale')
                    insert_sgroup('sgroup_four_pale') insert_sgroup('sgroup_four_pale')
end
    -- Pale Pink 4SGr x 5Tr
function sgr_pl04() insert_sgroup('sgroup_five_pale') insert_sgroup('sgroup_five_pale')
                    insert_sgroup('sgroup_five_pale') insert_sgroup('sgroup_five_pale')
end
    -- Pale Pink 4SGr x 6Tr
function sgr_pl05() insert_sgroup('sgroup_six_pale') insert_sgroup('sgroup_six_pale')
                    insert_sgroup('sgroup_six_pale') insert_sgroup('sgroup_six_pale')
end
    -- Pale Pink 4SGr x 7Tr
function sgr_pl06() insert_sgroup('sgroup_seven_pale') insert_sgroup('sgroup_seven_pale')
                    insert_sgroup('sgroup_seven_pale') insert_sgroup('sgroup_seven_pale')
end
    -- Pale Pink 4SGr x 8Tr
function sgr_pl07() insert_sgroup('sgroup_eight_pale') insert_sgroup('sgroup_eight_pale')
                    insert_sgroup('sgroup_eight_pale') insert_sgroup('sgroup_eight_pale')
end
    -- Pale Pink 2SGr x 6Tr
function sgr_pl08() insert_sgroup('sgroup_six_pale') insert_sgroup('sgroup_six_pale')
end
    -- Pale Pink 2SGr x 8Tr
function sgr_pl09() insert_sgroup('sgroup_eight_pale') insert_sgroup('sgroup_eight_pale')
end
    -- Pale Pink 1SGr x 8Tr
function sgr_pl10() insert_sgroup('sgroup_eight_pale')
end

  
    -- Tracks (Not SubGroups) ----

    -- Pale Pink 1AuxTr
function tr_pla1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpl.a1)
end

function tr_plb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpl.a2)
end
    -- Pale Pink 2Tr
function tr_pl02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpl.two) insert_track_only(rnst , tpl.one)
end
    -- Pale Pink 4Tr
function tr_pl03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpl.four)  insert_track_only(rnst , tpl.three) insert_track_only(rnst , tpl.two) insert_track_only(rnst , tpl.one)
end
    -- Pale Pink 6Tr
function tr_pl04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpl.six)   insert_track_only(rnst , tpl.five) insert_track_only(rnst , tpl.four)
                   insert_track_only(rnst , tpl.three) insert_track_only(rnst , tpl.two)  insert_track_only(rnst , tpl.one)
end
    -- Pale Pink 8Tr
function tr_pl05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpl.eight) insert_track_only(rnst , tpl.seven) insert_track_only(rnst , tpl.six) insert_track_only(rnst , tpl.five)
                   insert_track_only(rnst , tpl.four)  insert_track_only(rnst , tpl.three) insert_track_only(rnst , tpl.two) insert_track_only(rnst , tpl.one)
end
    -- Pale Pink 4Tr + 2AuxTr
function tr_pl06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpl.a2) insert_track_only(rnst , tpl.a1)
                   insert_track_only(rnst , tpl.four)  insert_track_only(rnst , tpl.three) insert_track_only(rnst , tpl.two) insert_track_only(rnst , tpl.one)
end
    -- Pale Pink 8Tr + 2AuxTr
function tr_pl07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpl.a2) insert_track_only(rnst , tpl.a1)
                   insert_track_only(rnst , tpl.eight) insert_track_only(rnst , tpl.seven) insert_track_only(rnst , tpl.six) insert_track_only(rnst , tpl.five)
                   insert_track_only(rnst , tpl.four)  insert_track_only(rnst , tpl.three) insert_track_only(rnst , tpl.two) insert_track_only(rnst , tpl.one)
end



    --[[ == PINK == ]]--
  
    -- Main Group ----
  
    -- Pink 1 Main Group
function mgr_pn01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tpn.a2)
                    insert_main_group('main_group_pink')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Pink 1MGr x 2Gr [2SGr x 2Tr]
function mgr_pn02() insert_sgroup('sgroup_two_pink') insert_sgroup('sgroup_two_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_pink') insert_sgroup('sgroup_two_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_pink') instert_groups_to_main_group_2Gx2T()
end
  
    -- Pink 1MGr x 2Gr [2SGr x 3Tr]
function mgr_pn03() insert_sgroup('sgroup_three_pink') insert_sgroup('sgroup_three_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_pink') insert_sgroup('sgroup_three_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_pink') instert_groups_to_main_group_2Gx3T()
end
  
    -- Pink 1MGr x 2Gr [2SGr x 4Tr]
function mgr_pn04() insert_sgroup('sgroup_four_pink') insert_sgroup('sgroup_four_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_pink') insert_sgroup('sgroup_four_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_pink') instert_groups_to_main_group_2Gx4T()
end
  
    -- Pink 1MGr x 2Gr [2SGr x 5Tr]
function mgr_pn05() insert_sgroup('sgroup_five_pink') insert_sgroup('sgroup_five_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_pink') insert_sgroup('sgroup_five_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_pink') instert_groups_to_main_group_2Gx5T()
end
  
    -- Pink 1MGr x 2Gr [2SGr x 6Tr]
function mgr_pn06() insert_sgroup('sgroup_six_pink') insert_sgroup('sgroup_six_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_pink') insert_sgroup('sgroup_six_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_pink') instert_groups_to_main_group_2Gx6T()
end
  
    -- Pink 1MGr x 2Gr [2SGr x 7Tr]
function mgr_pn07() insert_sgroup('sgroup_seven_pink') insert_sgroup('sgroup_seven_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_pink') insert_sgroup('sgroup_seven_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_pink') instert_groups_to_main_group_2Gx7T()
end
  
    -- Pink 1MGr x 2Gr [2SGr x 8Tr]
function mgr_pn08() insert_sgroup('sgroup_eight_pink') insert_sgroup('sgroup_eight_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_pink') insert_sgroup('sgroup_eight_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_pink') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Pink 1 Group
function gr_pn01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tpn.a2)
                   insert_group('group_one_pink')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Pink 2Gr [2SGr x 2Tr]
function gr_pn02() insert_sgroup('sgroup_two_pink') insert_sgroup('sgroup_two_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pink') insert_sgroup('sgroup_two_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx2T()
end
    -- Pink 2Gr [2SGr x 3Tr]
function gr_pn03() insert_sgroup('sgroup_three_pink') insert_sgroup('sgroup_three_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_pink') insert_sgroup('sgroup_three_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx3T()
end
    -- Pink 2Gr [2SGr x 4Tr]
function gr_pn04() insert_sgroup('sgroup_four_pink') insert_sgroup('sgroup_four_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_pink') insert_sgroup('sgroup_four_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx4T()
end
    -- Pink 2Gr [2SGr x 5Tr]
function gr_pn05() insert_sgroup('sgroup_five_pink') insert_sgroup('sgroup_five_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_pink') insert_sgroup('sgroup_five_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx5T()
end
    -- Pink 2Gr [2SGr x 6Tr]
function gr_pn06() insert_sgroup('sgroup_six_pink') insert_sgroup('sgroup_six_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_pink') insert_sgroup('sgroup_six_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx6T()
end
    -- Pink 2Gr [2SGr x 7Tr]
function gr_pn07() insert_sgroup('sgroup_seven_pink') insert_sgroup('sgroup_seven_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_pink') insert_sgroup('sgroup_seven_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx7T()
end
    -- Pink 2Gr [2SGr x 8Tr]
function gr_pn08() insert_sgroup('sgroup_eight_pink') insert_sgroup('sgroup_eight_pink') insert_group('group_two_pink') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_pink') insert_sgroup('sgroup_eight_pink') insert_group('group_one_pink') instert_sgroups_to_group_2Gx8T()
end
    -- Pink 4Gr [2SGr x 2Tr]
function gr_pn09() insert_sgroup('sgroup_two_pink') insert_sgroup('sgroup_two_pink') insert_group('group_four_pink')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pink') insert_sgroup('sgroup_two_pink') insert_group('group_three_pink') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pink') insert_sgroup('sgroup_two_pink') insert_group('group_two_pink')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pink') insert_sgroup('sgroup_two_pink') insert_group('group_one_pink')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Pink 4SGr x 2Tr
function sgr_pn01() insert_sgroup('sgroup_two_pink') insert_sgroup('sgroup_two_pink')
                    insert_sgroup('sgroup_two_pink') insert_sgroup('sgroup_two_pink')
end
    -- Pink 4SGr x 3Tr
function sgr_pn02() insert_sgroup('sgroup_three_pink') insert_sgroup('sgroup_three_pink')
                    insert_sgroup('sgroup_three_pink') insert_sgroup('sgroup_three_pink')
end
    -- Pink 4SGr x 4Tr
function sgr_pn03() insert_sgroup('sgroup_four_pink') insert_sgroup('sgroup_four_pink')
                    insert_sgroup('sgroup_four_pink') insert_sgroup('sgroup_four_pink')
end
    -- Pink 4SGr x 5Tr
function sgr_pn04() insert_sgroup('sgroup_five_pink') insert_sgroup('sgroup_five_pink')
                    insert_sgroup('sgroup_five_pink') insert_sgroup('sgroup_five_pink')
end
    -- Pink 4SGr x 6Tr
function sgr_pn05() insert_sgroup('sgroup_six_pink') insert_sgroup('sgroup_six_pink')
                    insert_sgroup('sgroup_six_pink') insert_sgroup('sgroup_six_pink')
end
    -- Pink 4SGr x 7Tr
function sgr_pn06() insert_sgroup('sgroup_seven_pink') insert_sgroup('sgroup_seven_pink')
                    insert_sgroup('sgroup_seven_pink') insert_sgroup('sgroup_seven_pink')
end
    -- Pink 4SGr x 8Tr
function sgr_pn07() insert_sgroup('sgroup_eight_pink') insert_sgroup('sgroup_eight_pink')
                    insert_sgroup('sgroup_eight_pink') insert_sgroup('sgroup_eight_pink')
end
    -- Pink 2SGr x 6Tr
function sgr_pn08() insert_sgroup('sgroup_six_pink') insert_sgroup('sgroup_six_pink')
end
    -- Pink 2SGr x 8Tr
function sgr_pn09() insert_sgroup('sgroup_eight_pink') insert_sgroup('sgroup_eight_pink')
end
    -- Pink 1SGr x 8Tr
function sgr_pn10() insert_sgroup('sgroup_eight_pink')
end

  
    -- Tracks (Not SubGroups) ----

    -- Pink 1AuxTr
function tr_pna1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpn.a1)
end

function tr_pnb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpn.a2)
end
    -- Pink 2Tr
function tr_pn02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpn.two) insert_track_only(rnst , tpn.one)
end
    -- Pink 4Tr
function tr_pn03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpn.four)  insert_track_only(rnst , tpn.three) insert_track_only(rnst , tpn.two) insert_track_only(rnst , tpn.one)
end
    -- Pink 6Tr
function tr_pn04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpn.six)   insert_track_only(rnst , tpn.five) insert_track_only(rnst , tpn.four)
                   insert_track_only(rnst , tpn.three) insert_track_only(rnst , tpn.two)  insert_track_only(rnst , tpn.one)
end
    -- Pink 8Tr
function tr_pn05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpn.eight) insert_track_only(rnst , tpn.seven) insert_track_only(rnst , tpn.six) insert_track_only(rnst , tpn.five)
                   insert_track_only(rnst , tpn.four)  insert_track_only(rnst , tpn.three) insert_track_only(rnst , tpn.two) insert_track_only(rnst , tpn.one)
end
    -- Pink 4Tr + 2AuxTr
function tr_pn06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpn.a2) insert_track_only(rnst , tpn.a1)
                   insert_track_only(rnst , tpn.four)  insert_track_only(rnst , tpn.three) insert_track_only(rnst , tpn.two) insert_track_only(rnst , tpn.one)
end
    -- Pink 8Tr + 2AuxTr
function tr_pn07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tpn.a2) insert_track_only(rnst , tpn.a1)
                   insert_track_only(rnst , tpn.eight) insert_track_only(rnst , tpn.seven) insert_track_only(rnst , tpn.six) insert_track_only(rnst , tpn.five)
                   insert_track_only(rnst , tpn.four)  insert_track_only(rnst , tpn.three) insert_track_only(rnst , tpn.two) insert_track_only(rnst , tpn.one)
end



    --[[ == PISTACHIO == ]]--
  
    -- Main Group ----
  
    -- Pistachio 1 Main Group
function mgr_ps01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tps.a2)
                    insert_main_group('main_group_pistachio')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Pistachio 1MGr x 2Gr [2SGr x 2Tr]
function mgr_ps02() insert_sgroup('sgroup_two_pistachio') insert_sgroup('sgroup_two_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_pistachio') insert_sgroup('sgroup_two_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_pistachio') instert_groups_to_main_group_2Gx2T()
end
  
    -- Pistachio 1MGr x 2Gr [2SGr x 3Tr]
function mgr_ps03() insert_sgroup('sgroup_three_pistachio') insert_sgroup('sgroup_three_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_pistachio') insert_sgroup('sgroup_three_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_pistachio') instert_groups_to_main_group_2Gx3T()
end
  
    -- Pistachio 1MGr x 2Gr [2SGr x 4Tr]
function mgr_ps04() insert_sgroup('sgroup_four_pistachio') insert_sgroup('sgroup_four_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_pistachio') insert_sgroup('sgroup_four_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_pistachio') instert_groups_to_main_group_2Gx4T()
end
  
    -- Pistachio 1MGr x 2Gr [2SGr x 5Tr]
function mgr_ps05() insert_sgroup('sgroup_five_pistachio') insert_sgroup('sgroup_five_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_pistachio') insert_sgroup('sgroup_five_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_pistachio') instert_groups_to_main_group_2Gx5T()
end
  
    -- Pistachio 1MGr x 2Gr [2SGr x 6Tr]
function mgr_ps06() insert_sgroup('sgroup_six_pistachio') insert_sgroup('sgroup_six_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_pistachio') insert_sgroup('sgroup_six_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_pistachio') instert_groups_to_main_group_2Gx6T()
end
  
    -- Pistachio 1MGr x 2Gr [2SGr x 7Tr]
function mgr_ps07() insert_sgroup('sgroup_seven_pistachio') insert_sgroup('sgroup_seven_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_pistachio') insert_sgroup('sgroup_seven_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_pistachio') instert_groups_to_main_group_2Gx7T()
end
  
    -- Pistachio 1MGr x 2Gr [2SGr x 8Tr]
function mgr_ps08() insert_sgroup('sgroup_eight_pistachio') insert_sgroup('sgroup_eight_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_pistachio') insert_sgroup('sgroup_eight_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_pistachio') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Pistachio 1 Group
function gr_ps01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tps.a2)
                   insert_group('group_one_pistachio')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Pistachio 2Gr [2SGr x 2Tr]
function gr_ps02() insert_sgroup('sgroup_two_pistachio') insert_sgroup('sgroup_two_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pistachio') insert_sgroup('sgroup_two_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx2T()
end
    -- Pistachio 2Gr [2SGr x 3Tr]
function gr_ps03() insert_sgroup('sgroup_three_pistachio') insert_sgroup('sgroup_three_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_pistachio') insert_sgroup('sgroup_three_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx3T()
end
    -- Pistachio 2Gr [2SGr x 4Tr]
function gr_ps04() insert_sgroup('sgroup_four_pistachio') insert_sgroup('sgroup_four_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_pistachio') insert_sgroup('sgroup_four_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx4T()
end
    -- Pistachio 2Gr [2SGr x 5Tr]
function gr_ps05() insert_sgroup('sgroup_five_pistachio') insert_sgroup('sgroup_five_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_pistachio') insert_sgroup('sgroup_five_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx5T()
end
    -- Pistachio 2Gr [2SGr x 6Tr]
function gr_ps06() insert_sgroup('sgroup_six_pistachio') insert_sgroup('sgroup_six_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_pistachio') insert_sgroup('sgroup_six_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx6T()
end
    -- Pistachio 2Gr [2SGr x 7Tr]
function gr_ps07() insert_sgroup('sgroup_seven_pistachio') insert_sgroup('sgroup_seven_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_pistachio') insert_sgroup('sgroup_seven_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx7T()
end
    -- Pistachio 2Gr [2SGr x 8Tr]
function gr_ps08() insert_sgroup('sgroup_eight_pistachio') insert_sgroup('sgroup_eight_pistachio') insert_group('group_two_pistachio') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_pistachio') insert_sgroup('sgroup_eight_pistachio') insert_group('group_one_pistachio') instert_sgroups_to_group_2Gx8T()
end
    -- Pistachio 4Gr [2SGr x 2Tr]
function gr_ps09() insert_sgroup('sgroup_two_pistachio') insert_sgroup('sgroup_two_pistachio') insert_group('group_four_pistachio')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pistachio') insert_sgroup('sgroup_two_pistachio') insert_group('group_three_pistachio') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pistachio') insert_sgroup('sgroup_two_pistachio') insert_group('group_two_pistachio')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_pistachio') insert_sgroup('sgroup_two_pistachio') insert_group('group_one_pistachio')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Pistachio 4SGr x 2Tr
function sgr_ps01() insert_sgroup('sgroup_two_pistachio') insert_sgroup('sgroup_two_pistachio')
                    insert_sgroup('sgroup_two_pistachio') insert_sgroup('sgroup_two_pistachio')
end
    -- Pistachio 4SGr x 3Tr
function sgr_ps02() insert_sgroup('sgroup_three_pistachio') insert_sgroup('sgroup_three_pistachio')
                    insert_sgroup('sgroup_three_pistachio') insert_sgroup('sgroup_three_pistachio')
end
    -- Pistachio 4SGr x 4Tr
function sgr_ps03() insert_sgroup('sgroup_four_pistachio') insert_sgroup('sgroup_four_pistachio')
                    insert_sgroup('sgroup_four_pistachio') insert_sgroup('sgroup_four_pistachio')
end
    -- Pistachio 4SGr x 5Tr
function sgr_ps04() insert_sgroup('sgroup_five_pistachio') insert_sgroup('sgroup_five_pistachio')
                    insert_sgroup('sgroup_five_pistachio') insert_sgroup('sgroup_five_pistachio')
end
    -- Pistachio 4SGr x 6Tr
function sgr_ps05() insert_sgroup('sgroup_six_pistachio') insert_sgroup('sgroup_six_pistachio')
                    insert_sgroup('sgroup_six_pistachio') insert_sgroup('sgroup_six_pistachio')
end
    -- Pistachio 4SGr x 7Tr
function sgr_ps06() insert_sgroup('sgroup_seven_pistachio') insert_sgroup('sgroup_seven_pistachio')
                    insert_sgroup('sgroup_seven_pistachio') insert_sgroup('sgroup_seven_pistachio')
end
    -- Pistachio 4SGr x 8Tr
function sgr_ps07() insert_sgroup('sgroup_eight_pistachio') insert_sgroup('sgroup_eight_pistachio')
                    insert_sgroup('sgroup_eight_pistachio') insert_sgroup('sgroup_eight_pistachio')
end
    -- Pistachio 2SGr x 6Tr
function sgr_ps08() insert_sgroup('sgroup_six_pistachio') insert_sgroup('sgroup_six_pistachio')
end
    -- Pistachio 2SGr x 8Tr
function sgr_ps09() insert_sgroup('sgroup_eight_pistachio') insert_sgroup('sgroup_eight_pistachio')
end
    -- Pistachio 1SGr x 8Tr
function sgr_ps10() insert_sgroup('sgroup_eight_pistachio')
end

  
    -- Tracks (Not SubGroups) ----

    -- Pistachio 1AuxTr
function tr_psa1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tps.a1)
end

function tr_psb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tps.a2)
end
    -- Pistachio 2Tr
function tr_ps02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tps.two) insert_track_only(rnst , tps.one)
end
    -- Pistachio 4Tr
function tr_ps03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tps.four)  insert_track_only(rnst , tps.three) insert_track_only(rnst , tps.two) insert_track_only(rnst , tps.one)
end
    -- Pistachio 6Tr
function tr_ps04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tps.six)   insert_track_only(rnst , tps.five) insert_track_only(rnst , tps.four)
                   insert_track_only(rnst , tps.three) insert_track_only(rnst , tps.two)  insert_track_only(rnst , tps.one)
end
    -- Pistachio 8Tr
function tr_ps05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tps.eight) insert_track_only(rnst , tps.seven) insert_track_only(rnst , tps.six) insert_track_only(rnst , tps.five)
                   insert_track_only(rnst , tps.four)  insert_track_only(rnst , tps.three) insert_track_only(rnst , tps.two) insert_track_only(rnst , tps.one)
end
    -- Pistachio 4Tr + 2AuxTr
function tr_ps06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tps.a2) insert_track_only(rnst , tps.a1)
                   insert_track_only(rnst , tps.four)  insert_track_only(rnst , tps.three) insert_track_only(rnst , tps.two) insert_track_only(rnst , tps.one)
end
    -- Pistachio 8Tr + 2AuxTr
function tr_ps07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tps.a2) insert_track_only(rnst , tps.a1)
                   insert_track_only(rnst , tps.eight) insert_track_only(rnst , tps.seven) insert_track_only(rnst , tps.six) insert_track_only(rnst , tps.five)
                   insert_track_only(rnst , tps.four)  insert_track_only(rnst , tps.three) insert_track_only(rnst , tps.two) insert_track_only(rnst , tps.one)
end



    --[[ == RED == ]]--
  
    -- Main Group ----
  
    -- Red 1 Main Group
function mgr_rd01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, trd.a2)
                    insert_main_group('main_group_red')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Red 1MGr x 2Gr [2SGr x 2Tr]
function mgr_rd02() insert_sgroup('sgroup_two_red') insert_sgroup('sgroup_two_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_red') insert_sgroup('sgroup_two_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_red') instert_groups_to_main_group_2Gx2T()
end
  
    -- Red 1MGr x 2Gr [2SGr x 3Tr]
function mgr_rd03() insert_sgroup('sgroup_three_red') insert_sgroup('sgroup_three_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_red') insert_sgroup('sgroup_three_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_red') instert_groups_to_main_group_2Gx3T()
end
  
    -- Red 1MGr x 2Gr [2SGr x 4Tr]
function mgr_rd04() insert_sgroup('sgroup_four_red') insert_sgroup('sgroup_four_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_red') insert_sgroup('sgroup_four_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_red') instert_groups_to_main_group_2Gx4T()
end
  
    -- Red 1MGr x 2Gr [2SGr x 5Tr]
function mgr_rd05() insert_sgroup('sgroup_five_red') insert_sgroup('sgroup_five_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_red') insert_sgroup('sgroup_five_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_red') instert_groups_to_main_group_2Gx5T()
end
  
    -- Red 1MGr x 2Gr [2SGr x 6Tr]
function mgr_rd06() insert_sgroup('sgroup_six_red') insert_sgroup('sgroup_six_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_red') insert_sgroup('sgroup_six_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_red') instert_groups_to_main_group_2Gx6T()
end
  
    -- Red 1MGr x 2Gr [2SGr x 7Tr]
function mgr_rd07() insert_sgroup('sgroup_seven_red') insert_sgroup('sgroup_seven_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_red') insert_sgroup('sgroup_seven_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_red') instert_groups_to_main_group_2Gx7T()
end
  
    -- Red 1MGr x 2Gr [2SGr x 8Tr]
function mgr_rd08() insert_sgroup('sgroup_eight_red') insert_sgroup('sgroup_eight_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_red') insert_sgroup('sgroup_eight_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_red') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Red 1 Group
function gr_rd01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, trd.a2)
                   insert_group('group_one_red')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Red 2Gr [2SGr x 2Tr]
function gr_rd02() insert_sgroup('sgroup_two_red') insert_sgroup('sgroup_two_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_red') insert_sgroup('sgroup_two_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx2T()
end
    -- Red 2Gr [2SGr x 3Tr]
function gr_rd03() insert_sgroup('sgroup_three_red') insert_sgroup('sgroup_three_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_red') insert_sgroup('sgroup_three_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx3T()
end
    -- Red 2Gr [2SGr x 4Tr]
function gr_rd04() insert_sgroup('sgroup_four_red') insert_sgroup('sgroup_four_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_red') insert_sgroup('sgroup_four_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx4T()
end
    -- Red 2Gr [2SGr x 5Tr]
function gr_rd05() insert_sgroup('sgroup_five_red') insert_sgroup('sgroup_five_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_red') insert_sgroup('sgroup_five_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx5T()
end
    -- Red 2Gr [2SGr x 6Tr]
function gr_rd06() insert_sgroup('sgroup_six_red') insert_sgroup('sgroup_six_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_red') insert_sgroup('sgroup_six_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx6T()
end
    -- Red 2Gr [2SGr x 7Tr]
function gr_rd07() insert_sgroup('sgroup_seven_red') insert_sgroup('sgroup_seven_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_red') insert_sgroup('sgroup_seven_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx7T()
end
    -- Red 2Gr [2SGr x 8Tr]
function gr_rd08() insert_sgroup('sgroup_eight_red') insert_sgroup('sgroup_eight_red') insert_group('group_two_red') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_red') insert_sgroup('sgroup_eight_red') insert_group('group_one_red') instert_sgroups_to_group_2Gx8T()
end
    -- Red 4Gr [2SGr x 2Tr]
function gr_rd09() insert_sgroup('sgroup_two_red') insert_sgroup('sgroup_two_red') insert_group('group_four_red')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_red') insert_sgroup('sgroup_two_red') insert_group('group_three_red') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_red') insert_sgroup('sgroup_two_red') insert_group('group_two_red')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_red') insert_sgroup('sgroup_two_red') insert_group('group_one_red')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Red 4SGr x 2Tr
function sgr_rd01() insert_sgroup('sgroup_two_red') insert_sgroup('sgroup_two_red')
                    insert_sgroup('sgroup_two_red') insert_sgroup('sgroup_two_red')
end
    -- Red 4SGr x 3Tr
function sgr_rd02() insert_sgroup('sgroup_three_red') insert_sgroup('sgroup_three_red')
                    insert_sgroup('sgroup_three_red') insert_sgroup('sgroup_three_red')
end
    -- Red 4SGr x 4Tr
function sgr_rd03() insert_sgroup('sgroup_four_red') insert_sgroup('sgroup_four_red')
                    insert_sgroup('sgroup_four_red') insert_sgroup('sgroup_four_red')
end
    -- Red 4SGr x 5Tr
function sgr_rd04() insert_sgroup('sgroup_five_red') insert_sgroup('sgroup_five_red')
                    insert_sgroup('sgroup_five_red') insert_sgroup('sgroup_five_red')
end
    -- Red 4SGr x 6Tr
function sgr_rd05() insert_sgroup('sgroup_six_red') insert_sgroup('sgroup_six_red')
                    insert_sgroup('sgroup_six_red') insert_sgroup('sgroup_six_red')
end
    -- Red 4SGr x 7Tr
function sgr_rd06() insert_sgroup('sgroup_seven_red') insert_sgroup('sgroup_seven_red')
                    insert_sgroup('sgroup_seven_red') insert_sgroup('sgroup_seven_red')
end
    -- Red 4SGr x 8Tr
function sgr_rd07() insert_sgroup('sgroup_eight_red') insert_sgroup('sgroup_eight_red')
                    insert_sgroup('sgroup_eight_red') insert_sgroup('sgroup_eight_red')
end
    -- Red 2SGr x 6Tr
function sgr_rd08() insert_sgroup('sgroup_six_red') insert_sgroup('sgroup_six_red')
end
    -- Red 2SGr x 8Tr
function sgr_rd09() insert_sgroup('sgroup_eight_red') insert_sgroup('sgroup_eight_red')
end
    -- Red 1SGr x 8Tr
function sgr_rd10() insert_sgroup('sgroup_eight_red')
end

  
    -- Tracks (Not SubGroups) ----

    -- Red 1AuxTr
function tr_rda1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , trd.a1)
end

function tr_rdb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , trd.a2)
end
    -- Red 2Tr
function tr_rd02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , trd.two) insert_track_only(rnst , trd.one)
end
    -- Red 4Tr
function tr_rd03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , trd.four)  insert_track_only(rnst , trd.three) insert_track_only(rnst , trd.two) insert_track_only(rnst , trd.one)
end
    -- Red 6Tr
function tr_rd04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , trd.six)   insert_track_only(rnst , trd.five) insert_track_only(rnst , trd.four)
                   insert_track_only(rnst , trd.three) insert_track_only(rnst , trd.two)  insert_track_only(rnst , trd.one)
end
    -- Red 8Tr
function tr_rd05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , trd.eight) insert_track_only(rnst , trd.seven) insert_track_only(rnst , trd.six) insert_track_only(rnst , trd.five)
                   insert_track_only(rnst , trd.four)  insert_track_only(rnst , trd.three) insert_track_only(rnst , trd.two) insert_track_only(rnst , trd.one)
end
    -- Red 4Tr + 2AuxTr
function tr_rd06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , trd.a2) insert_track_only(rnst , trd.a1)
                   insert_track_only(rnst , trd.four)  insert_track_only(rnst , trd.three) insert_track_only(rnst , trd.two) insert_track_only(rnst , trd.one)
end
    -- Red 8Tr + 2AuxTr
function tr_rd07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , trd.a2) insert_track_only(rnst , trd.a1)
                   insert_track_only(rnst , trd.eight) insert_track_only(rnst , trd.seven) insert_track_only(rnst , trd.six) insert_track_only(rnst , trd.five)
                   insert_track_only(rnst , trd.four)  insert_track_only(rnst , trd.three) insert_track_only(rnst , trd.two) insert_track_only(rnst , trd.one)
end



    --[[ == SKY BLUE == ]]--
  
    -- Main Group ----
  
    -- Sky Blue 1 Main Group
function mgr_sk01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tsk.a2)
                    insert_main_group('main_group_sky')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Sky Blue 1MGr x 2Gr [2SGr x 2Tr]
function mgr_sk02() insert_sgroup('sgroup_two_sky') insert_sgroup('sgroup_two_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_sky') insert_sgroup('sgroup_two_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_sky') instert_groups_to_main_group_2Gx2T()
end
  
    -- Sky Blue 1MGr x 2Gr [2SGr x 3Tr]
function mgr_sk03() insert_sgroup('sgroup_three_sky') insert_sgroup('sgroup_three_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_sky') insert_sgroup('sgroup_three_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_sky') instert_groups_to_main_group_2Gx3T()
end
  
    -- Sky Blue 1MGr x 2Gr [2SGr x 4Tr]
function mgr_sk04() insert_sgroup('sgroup_four_sky') insert_sgroup('sgroup_four_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_sky') insert_sgroup('sgroup_four_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_sky') instert_groups_to_main_group_2Gx4T()
end
  
    -- Sky Blue 1MGr x 2Gr [2SGr x 5Tr]
function mgr_sk05() insert_sgroup('sgroup_five_sky') insert_sgroup('sgroup_five_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_sky') insert_sgroup('sgroup_five_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_sky') instert_groups_to_main_group_2Gx5T()
end
  
    -- Sky Blue 1MGr x 2Gr [2SGr x 6Tr]
function mgr_sk06() insert_sgroup('sgroup_six_sky') insert_sgroup('sgroup_six_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_sky') insert_sgroup('sgroup_six_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_sky') instert_groups_to_main_group_2Gx6T()
end
  
    -- Sky Blue 1MGr x 2Gr [2SGr x 7Tr]
function mgr_sk07() insert_sgroup('sgroup_seven_sky') insert_sgroup('sgroup_seven_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_sky') insert_sgroup('sgroup_seven_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_sky') instert_groups_to_main_group_2Gx7T()
end
  
    -- Sky Blue 1MGr x 2Gr [2SGr x 8Tr]
function mgr_sk08() insert_sgroup('sgroup_eight_sky') insert_sgroup('sgroup_eight_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_sky') insert_sgroup('sgroup_eight_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_sky') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Sky Blue 1 Group
function gr_sk01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tsk.a2)
                   insert_group('group_one_sky')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Sky Blue 2Gr [2SGr x 2Tr]
function gr_sk02() insert_sgroup('sgroup_two_sky') insert_sgroup('sgroup_two_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_sky') insert_sgroup('sgroup_two_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx2T()
end
    -- Sky Blue 2Gr [2SGr x 3Tr]
function gr_sk03() insert_sgroup('sgroup_three_sky') insert_sgroup('sgroup_three_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_sky') insert_sgroup('sgroup_three_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx3T()
end
    -- Sky Blue 2Gr [2SGr x 4Tr]
function gr_sk04() insert_sgroup('sgroup_four_sky') insert_sgroup('sgroup_four_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_sky') insert_sgroup('sgroup_four_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx4T()
end
    -- Sky Blue 2Gr [2SGr x 5Tr]
function gr_sk05() insert_sgroup('sgroup_five_sky') insert_sgroup('sgroup_five_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_sky') insert_sgroup('sgroup_five_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx5T()
end
    -- Sky Blue 2Gr [2SGr x 6Tr]
function gr_sk06() insert_sgroup('sgroup_six_sky') insert_sgroup('sgroup_six_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_sky') insert_sgroup('sgroup_six_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx6T()
end
    -- Sky Blue 2Gr [2SGr x 7Tr]
function gr_sk07() insert_sgroup('sgroup_seven_sky') insert_sgroup('sgroup_seven_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_sky') insert_sgroup('sgroup_seven_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx7T()
end
    -- Sky Blue 2Gr [2SGr x 8Tr]
function gr_sk08() insert_sgroup('sgroup_eight_sky') insert_sgroup('sgroup_eight_sky') insert_group('group_two_sky') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_sky') insert_sgroup('sgroup_eight_sky') insert_group('group_one_sky') instert_sgroups_to_group_2Gx8T()
end
    -- Sky Blue 4Gr [2SGr x 2Tr]
function gr_sk09() insert_sgroup('sgroup_two_sky') insert_sgroup('sgroup_two_sky') insert_group('group_four_sky')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_sky') insert_sgroup('sgroup_two_sky') insert_group('group_three_sky') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_sky') insert_sgroup('sgroup_two_sky') insert_group('group_two_sky')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_sky') insert_sgroup('sgroup_two_sky') insert_group('group_one_sky')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Sky Blue 4SGr x 2Tr
function sgr_sk01() insert_sgroup('sgroup_two_sky') insert_sgroup('sgroup_two_sky')
                    insert_sgroup('sgroup_two_sky') insert_sgroup('sgroup_two_sky')
end
    -- Sky Blue 4SGr x 3Tr
function sgr_sk02() insert_sgroup('sgroup_three_sky') insert_sgroup('sgroup_three_sky')
                    insert_sgroup('sgroup_three_sky') insert_sgroup('sgroup_three_sky')
end
    -- Sky Blue 4SGr x 4Tr
function sgr_sk03() insert_sgroup('sgroup_four_sky') insert_sgroup('sgroup_four_sky')
                    insert_sgroup('sgroup_four_sky') insert_sgroup('sgroup_four_sky')
end
    -- Sky Blue 4SGr x 5Tr
function sgr_sk04() insert_sgroup('sgroup_five_sky') insert_sgroup('sgroup_five_sky')
                    insert_sgroup('sgroup_five_sky') insert_sgroup('sgroup_five_sky')
end
    -- Sky Blue 4SGr x 6Tr
function sgr_sk05() insert_sgroup('sgroup_six_sky') insert_sgroup('sgroup_six_sky')
                    insert_sgroup('sgroup_six_sky') insert_sgroup('sgroup_six_sky')
end
    -- Sky Blue 4SGr x 7Tr
function sgr_sk06() insert_sgroup('sgroup_seven_sky') insert_sgroup('sgroup_seven_sky')
                    insert_sgroup('sgroup_seven_sky') insert_sgroup('sgroup_seven_sky')
end
    -- Sky Blue 4SGr x 8Tr
function sgr_sk07() insert_sgroup('sgroup_eight_sky') insert_sgroup('sgroup_eight_sky')
                    insert_sgroup('sgroup_eight_sky') insert_sgroup('sgroup_eight_sky')
end
    -- Sky Blue 2SGr x 6Tr
function sgr_sk08() insert_sgroup('sgroup_six_sky') insert_sgroup('sgroup_six_sky')
end
    -- Sky Blue 2SGr x 8Tr
function sgr_sk09() insert_sgroup('sgroup_eight_sky') insert_sgroup('sgroup_eight_sky')
end
    -- Sky Blue 1SGr x 8Tr
function sgr_sk10() insert_sgroup('sgroup_eight_sky')
end

  
    -- Tracks (Not SubGroups) ----

    -- Sky Blue 1AuxTr
function tr_ska1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tsk.a1)
end

function tr_skb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tsk.a2)
end
    -- Sky Blue 2Tr
function tr_sk02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tsk.two) insert_track_only(rnst , tsk.one)
end
    -- Sky Blue 4Tr
function tr_sk03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tsk.four)  insert_track_only(rnst , tsk.three) insert_track_only(rnst , tsk.two) insert_track_only(rnst , tsk.one)
end
    -- Sky Blue 6Tr
function tr_sk04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tsk.six)   insert_track_only(rnst , tsk.five) insert_track_only(rnst , tsk.four)
                   insert_track_only(rnst , tsk.three) insert_track_only(rnst , tsk.two)  insert_track_only(rnst , tsk.one)
end
    -- Sky Blue 8Tr
function tr_sk05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tsk.eight) insert_track_only(rnst , tsk.seven) insert_track_only(rnst , tsk.six) insert_track_only(rnst , tsk.five)
                   insert_track_only(rnst , tsk.four)  insert_track_only(rnst , tsk.three) insert_track_only(rnst , tsk.two) insert_track_only(rnst , tsk.one)
end
    -- Sky Blue 4Tr + 2AuxTr
function tr_sk06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tsk.a2) insert_track_only(rnst , tsk.a1)
                   insert_track_only(rnst , tsk.four)  insert_track_only(rnst , tsk.three) insert_track_only(rnst , tsk.two) insert_track_only(rnst , tsk.one)
end
    -- Sky Blue 8Tr + 2AuxTr
function tr_sk07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tsk.a2) insert_track_only(rnst , tsk.a1)
                   insert_track_only(rnst , tsk.eight) insert_track_only(rnst , tsk.seven) insert_track_only(rnst , tsk.six) insert_track_only(rnst , tsk.five)
                   insert_track_only(rnst , tsk.four)  insert_track_only(rnst , tsk.three) insert_track_only(rnst , tsk.two) insert_track_only(rnst , tsk.one)
end



    --[[ == VIOLET == ]]--
  
    -- Main Group ----
  
    -- Violet 1 Main Group
function mgr_vl01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tvl.a2)
                    insert_main_group('main_group_violet')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Violet 1MGr x 2Gr [2SGr x 2Tr]
function mgr_vl02() insert_sgroup('sgroup_two_violet') insert_sgroup('sgroup_two_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_violet') insert_sgroup('sgroup_two_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_violet') instert_groups_to_main_group_2Gx2T()
end
  
    -- Violet 1MGr x 2Gr [2SGr x 3Tr]
function mgr_vl03() insert_sgroup('sgroup_three_violet') insert_sgroup('sgroup_three_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_violet') insert_sgroup('sgroup_three_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_violet') instert_groups_to_main_group_2Gx3T()
end
  
    -- Violet 1MGr x 2Gr [2SGr x 4Tr]
function mgr_vl04() insert_sgroup('sgroup_four_violet') insert_sgroup('sgroup_four_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_violet') insert_sgroup('sgroup_four_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_violet') instert_groups_to_main_group_2Gx4T()
end
  
    -- Violet 1MGr x 2Gr [2SGr x 5Tr]
function mgr_vl05() insert_sgroup('sgroup_five_violet') insert_sgroup('sgroup_five_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_violet') insert_sgroup('sgroup_five_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_violet') instert_groups_to_main_group_2Gx5T()
end
  
    -- Violet 1MGr x 2Gr [2SGr x 6Tr]
function mgr_vl06() insert_sgroup('sgroup_six_violet') insert_sgroup('sgroup_six_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_violet') insert_sgroup('sgroup_six_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_violet') instert_groups_to_main_group_2Gx6T()
end
  
    -- Violet 1MGr x 2Gr [2SGr x 7Tr]
function mgr_vl07() insert_sgroup('sgroup_seven_violet') insert_sgroup('sgroup_seven_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_violet') insert_sgroup('sgroup_seven_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_violet') instert_groups_to_main_group_2Gx7T()
end
  
    -- Violet 1MGr x 2Gr [2SGr x 8Tr]
function mgr_vl08() insert_sgroup('sgroup_eight_violet') insert_sgroup('sgroup_eight_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_violet') insert_sgroup('sgroup_eight_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_violet') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Violet 1 Group
function gr_vl01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tvl.a2)
                   insert_group('group_one_violet')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Violet 2Gr [2SGr x 2Tr]
function gr_vl02() insert_sgroup('sgroup_two_violet') insert_sgroup('sgroup_two_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_violet') insert_sgroup('sgroup_two_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx2T()
end
    -- Violet 2Gr [2SGr x 3Tr]
function gr_vl03() insert_sgroup('sgroup_three_violet') insert_sgroup('sgroup_three_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_violet') insert_sgroup('sgroup_three_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx3T()
end
    -- Violet 2Gr [2SGr x 4Tr]
function gr_vl04() insert_sgroup('sgroup_four_violet') insert_sgroup('sgroup_four_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_violet') insert_sgroup('sgroup_four_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx4T()
end
    -- Violet 2Gr [2SGr x 5Tr]
function gr_vl05() insert_sgroup('sgroup_five_violet') insert_sgroup('sgroup_five_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_violet') insert_sgroup('sgroup_five_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx5T()
end
    -- Violet 2Gr [2SGr x 6Tr]
function gr_vl06() insert_sgroup('sgroup_six_violet') insert_sgroup('sgroup_six_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_violet') insert_sgroup('sgroup_six_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx6T()
end
    -- Violet 2Gr [2SGr x 7Tr]
function gr_vl07() insert_sgroup('sgroup_seven_violet') insert_sgroup('sgroup_seven_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_violet') insert_sgroup('sgroup_seven_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx7T()
end
    -- Violet 2Gr [2SGr x 8Tr]
function gr_vl08() insert_sgroup('sgroup_eight_violet') insert_sgroup('sgroup_eight_violet') insert_group('group_two_violet') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_violet') insert_sgroup('sgroup_eight_violet') insert_group('group_one_violet') instert_sgroups_to_group_2Gx8T()
end
    -- Violet 4Gr [2SGr x 2Tr]
function gr_vl09() insert_sgroup('sgroup_two_violet') insert_sgroup('sgroup_two_violet') insert_group('group_four_violet')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_violet') insert_sgroup('sgroup_two_violet') insert_group('group_three_violet') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_violet') insert_sgroup('sgroup_two_violet') insert_group('group_two_violet')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_violet') insert_sgroup('sgroup_two_violet') insert_group('group_one_violet')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Violet 4SGr x 2Tr
function sgr_vl01() insert_sgroup('sgroup_two_violet') insert_sgroup('sgroup_two_violet')
                    insert_sgroup('sgroup_two_violet') insert_sgroup('sgroup_two_violet')
end
    -- Violet 4SGr x 3Tr
function sgr_vl02() insert_sgroup('sgroup_three_violet') insert_sgroup('sgroup_three_violet')
                    insert_sgroup('sgroup_three_violet') insert_sgroup('sgroup_three_violet')
end
    -- Violet 4SGr x 4Tr
function sgr_vl03() insert_sgroup('sgroup_four_violet') insert_sgroup('sgroup_four_violet')
                    insert_sgroup('sgroup_four_violet') insert_sgroup('sgroup_four_violet')
end
    -- Violet 4SGr x 5Tr
function sgr_vl04() insert_sgroup('sgroup_five_violet') insert_sgroup('sgroup_five_violet')
                    insert_sgroup('sgroup_five_violet') insert_sgroup('sgroup_five_violet')
end
    -- Violet 4SGr x 6Tr
function sgr_vl05() insert_sgroup('sgroup_six_violet') insert_sgroup('sgroup_six_violet')
                    insert_sgroup('sgroup_six_violet') insert_sgroup('sgroup_six_violet')
end
    -- Violet 4SGr x 7Tr
function sgr_vl06() insert_sgroup('sgroup_seven_violet') insert_sgroup('sgroup_seven_violet')
                    insert_sgroup('sgroup_seven_violet') insert_sgroup('sgroup_seven_violet')
end
    -- Violet 4SGr x 8Tr
function sgr_vl07() insert_sgroup('sgroup_eight_violet') insert_sgroup('sgroup_eight_violet')
                    insert_sgroup('sgroup_eight_violet') insert_sgroup('sgroup_eight_violet')
end
    -- Violet 2SGr x 6Tr
function sgr_vl08() insert_sgroup('sgroup_six_violet') insert_sgroup('sgroup_six_violet')
end
    -- Violet 2SGr x 8Tr
function sgr_vl09() insert_sgroup('sgroup_eight_violet') insert_sgroup('sgroup_eight_violet')
end
    -- Violet 1SGr x 8Tr
function sgr_vl10() insert_sgroup('sgroup_eight_violet')
end

  
    -- Tracks (Not SubGroups) ----

    -- Violet 1AuxTr
function tr_vla1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tvl.a1)
end

function tr_vlb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tvl.a2)
end
    -- Violet 2Tr
function tr_vl02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tvl.two) insert_track_only(rnst , tvl.one)
end
    -- Violet 4Tr
function tr_vl03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tvl.four)  insert_track_only(rnst , tvl.three) insert_track_only(rnst , tvl.two) insert_track_only(rnst , tvl.one)
end
    -- Violet 6Tr
function tr_vl04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tvl.six)   insert_track_only(rnst , tvl.five) insert_track_only(rnst , tvl.four)
                   insert_track_only(rnst , tvl.three) insert_track_only(rnst , tvl.two)  insert_track_only(rnst , tvl.one)
end
    -- Violet 8Tr
function tr_vl05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tvl.eight) insert_track_only(rnst , tvl.seven) insert_track_only(rnst , tvl.six) insert_track_only(rnst , tvl.five)
                   insert_track_only(rnst , tvl.four)  insert_track_only(rnst , tvl.three) insert_track_only(rnst , tvl.two) insert_track_only(rnst , tvl.one)
end
    -- Violet 4Tr + 2AuxTr
function tr_vl06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tvl.a2) insert_track_only(rnst , tvl.a1)
                   insert_track_only(rnst , tvl.four)  insert_track_only(rnst , tvl.three) insert_track_only(rnst , tvl.two) insert_track_only(rnst , tvl.one)
end
    -- Violet 8Tr + 2AuxTr
function tr_vl07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tvl.a2) insert_track_only(rnst , tvl.a1)
                   insert_track_only(rnst , tvl.eight) insert_track_only(rnst , tvl.seven) insert_track_only(rnst , tvl.six) insert_track_only(rnst , tvl.five)
                   insert_track_only(rnst , tvl.four)  insert_track_only(rnst , tvl.three) insert_track_only(rnst , tvl.two) insert_track_only(rnst , tvl.one)
end



    --[[ == WHITE == ]]--
  
    -- Main Group ----
  
    -- White 1 Main Group
function mgr_wh01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, twh.a2)
                    insert_main_group('main_group_white')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- White 1MGr x 2Gr [2SGr x 2Tr]
function mgr_wh02() insert_sgroup('sgroup_two_white') insert_sgroup('sgroup_two_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_white') insert_sgroup('sgroup_two_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_white') instert_groups_to_main_group_2Gx2T()
end
  
    -- White 1MGr x 2Gr [2SGr x 3Tr]
function mgr_wh03() insert_sgroup('sgroup_three_white') insert_sgroup('sgroup_three_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_white') insert_sgroup('sgroup_three_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_white') instert_groups_to_main_group_2Gx3T()
end
  
    -- White 1MGr x 2Gr [2SGr x 4Tr]
function mgr_wh04() insert_sgroup('sgroup_four_white') insert_sgroup('sgroup_four_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_white') insert_sgroup('sgroup_four_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_white') instert_groups_to_main_group_2Gx4T()
end
  
    -- White 1MGr x 2Gr [2SGr x 5Tr]
function mgr_wh05() insert_sgroup('sgroup_five_white') insert_sgroup('sgroup_five_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_white') insert_sgroup('sgroup_five_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_white') instert_groups_to_main_group_2Gx5T()
end
  
    -- White 1MGr x 2Gr [2SGr x 6Tr]
function mgr_wh06() insert_sgroup('sgroup_six_white') insert_sgroup('sgroup_six_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_white') insert_sgroup('sgroup_six_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_white') instert_groups_to_main_group_2Gx6T()
end
  
    -- White 1MGr x 2Gr [2SGr x 7Tr]
function mgr_wh07() insert_sgroup('sgroup_seven_white') insert_sgroup('sgroup_seven_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_white') insert_sgroup('sgroup_seven_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_white') instert_groups_to_main_group_2Gx7T()
end
  
    -- White 1MGr x 2Gr [2SGr x 8Tr]
function mgr_wh08() insert_sgroup('sgroup_eight_white') insert_sgroup('sgroup_eight_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_white') insert_sgroup('sgroup_eight_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_white') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- White 1 Group
function gr_wh01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, twh.a2)
                   insert_group('group_one_white')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- White 2Gr [2SGr x 2Tr]
function gr_wh02() insert_sgroup('sgroup_two_white') insert_sgroup('sgroup_two_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_white') insert_sgroup('sgroup_two_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx2T()
end
    -- White 2Gr [2SGr x 3Tr]
function gr_wh03() insert_sgroup('sgroup_three_white') insert_sgroup('sgroup_three_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_white') insert_sgroup('sgroup_three_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx3T()
end
    -- White 2Gr [2SGr x 4Tr]
function gr_wh04() insert_sgroup('sgroup_four_white') insert_sgroup('sgroup_four_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_white') insert_sgroup('sgroup_four_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx4T()
end
    -- White 2Gr [2SGr x 5Tr]
function gr_wh05() insert_sgroup('sgroup_five_white') insert_sgroup('sgroup_five_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_white') insert_sgroup('sgroup_five_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx5T()
end
    -- White 2Gr [2SGr x 6Tr]
function gr_wh06() insert_sgroup('sgroup_six_white') insert_sgroup('sgroup_six_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_white') insert_sgroup('sgroup_six_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx6T()
end
    -- White 2Gr [2SGr x 7Tr]
function gr_wh07() insert_sgroup('sgroup_seven_white') insert_sgroup('sgroup_seven_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_white') insert_sgroup('sgroup_seven_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx7T()
end
    -- White 2Gr [2SGr x 8Tr]
function gr_wh08() insert_sgroup('sgroup_eight_white') insert_sgroup('sgroup_eight_white') insert_group('group_two_white') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_white') insert_sgroup('sgroup_eight_white') insert_group('group_one_white') instert_sgroups_to_group_2Gx8T()
end
    -- White 4Gr [2SGr x 2Tr]
function gr_wh09() insert_sgroup('sgroup_two_white') insert_sgroup('sgroup_two_white') insert_group('group_four_white')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_white') insert_sgroup('sgroup_two_white') insert_group('group_three_white') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_white') insert_sgroup('sgroup_two_white') insert_group('group_two_white')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_white') insert_sgroup('sgroup_two_white') insert_group('group_one_white')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- White 4SGr x 2Tr
function sgr_wh01() insert_sgroup('sgroup_two_white') insert_sgroup('sgroup_two_white')
                    insert_sgroup('sgroup_two_white') insert_sgroup('sgroup_two_white')
end
    -- White 4SGr x 3Tr
function sgr_wh02() insert_sgroup('sgroup_three_white') insert_sgroup('sgroup_three_white')
                    insert_sgroup('sgroup_three_white') insert_sgroup('sgroup_three_white')
end
    -- White 4SGr x 4Tr
function sgr_wh03() insert_sgroup('sgroup_four_white') insert_sgroup('sgroup_four_white')
                    insert_sgroup('sgroup_four_white') insert_sgroup('sgroup_four_white')
end
    -- White 4SGr x 5Tr
function sgr_wh04() insert_sgroup('sgroup_five_white') insert_sgroup('sgroup_five_white')
                    insert_sgroup('sgroup_five_white') insert_sgroup('sgroup_five_white')
end
    -- White 4SGr x 6Tr
function sgr_wh05() insert_sgroup('sgroup_six_white') insert_sgroup('sgroup_six_white')
                    insert_sgroup('sgroup_six_white') insert_sgroup('sgroup_six_white')
end
    -- White 4SGr x 7Tr
function sgr_wh06() insert_sgroup('sgroup_seven_white') insert_sgroup('sgroup_seven_white')
                    insert_sgroup('sgroup_seven_white') insert_sgroup('sgroup_seven_white')
end
    -- White 4SGr x 8Tr
function sgr_wh07() insert_sgroup('sgroup_eight_white') insert_sgroup('sgroup_eight_white')
                    insert_sgroup('sgroup_eight_white') insert_sgroup('sgroup_eight_white')
end
    -- White 2SGr x 6Tr
function sgr_wh08() insert_sgroup('sgroup_six_white') insert_sgroup('sgroup_six_white')
end
    -- White 2SGr x 8Tr
function sgr_wh09() insert_sgroup('sgroup_eight_white') insert_sgroup('sgroup_eight_white')
end
    -- White 1SGr x 8Tr
function sgr_wh10() insert_sgroup('sgroup_eight_white')
end

  
    -- Tracks (Not SubGroups) ----

    -- White 1AuxTr
function tr_wha1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , twh.a1)
end

function tr_whb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , twh.a2)
end
    -- White 2Tr
function tr_wh02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , twh.two) insert_track_only(rnst , twh.one)
end
    -- White 4Tr
function tr_wh03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , twh.four)  insert_track_only(rnst , twh.three) insert_track_only(rnst , twh.two) insert_track_only(rnst , twh.one)
end
    -- White 6Tr
function tr_wh04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , twh.six)   insert_track_only(rnst , twh.five) insert_track_only(rnst , twh.four)
                   insert_track_only(rnst , twh.three) insert_track_only(rnst , twh.two)  insert_track_only(rnst , twh.one)
end
    -- White 8Tr
function tr_wh05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , twh.eight) insert_track_only(rnst , twh.seven) insert_track_only(rnst , twh.six) insert_track_only(rnst , twh.five)
                   insert_track_only(rnst , twh.four)  insert_track_only(rnst , twh.three) insert_track_only(rnst , twh.two) insert_track_only(rnst , twh.one)
end
    -- White 4Tr + 2AuxTr
function tr_wh06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , twh.a2) insert_track_only(rnst , twh.a1)
                   insert_track_only(rnst , twh.four)  insert_track_only(rnst , twh.three) insert_track_only(rnst , twh.two) insert_track_only(rnst , twh.one)
end
    -- White 8Tr + 2AuxTr
function tr_wh07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , twh.a2) insert_track_only(rnst , twh.a1)
                   insert_track_only(rnst , twh.eight) insert_track_only(rnst , twh.seven) insert_track_only(rnst , twh.six) insert_track_only(rnst , twh.five)
                   insert_track_only(rnst , twh.four)  insert_track_only(rnst , twh.three) insert_track_only(rnst , twh.two) insert_track_only(rnst , twh.one)
end



    --[[ == YELLOW == ]]--
  
    -- Main Group ----
  
    -- Yellow 1 Main Group
function mgr_yl01() local song = renoise.song()
                    insert_track_only(song.selected_track_index + 1, tyl.a2)
                    insert_main_group('main_group_yellow')
                    song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                    song:select_next_track()
end
    -- Yellow 1MGr x 2Gr [2SGr x 2Tr]
function mgr_yl02() insert_sgroup('sgroup_two_yellow') insert_sgroup('sgroup_two_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx2T()
                    insert_sgroup('sgroup_two_yellow') insert_sgroup('sgroup_two_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx2T()
                    insert_main_group('main_group_yellow') instert_groups_to_main_group_2Gx2T()
end
  
    -- Yellow 1MGr x 2Gr [2SGr x 3Tr]
function mgr_yl03() insert_sgroup('sgroup_three_yellow') insert_sgroup('sgroup_three_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx3T()
                    insert_sgroup('sgroup_three_yellow') insert_sgroup('sgroup_three_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx3T()
                    insert_main_group('main_group_yellow') instert_groups_to_main_group_2Gx3T()
end
  
    -- Yellow 1MGr x 2Gr [2SGr x 4Tr]
function mgr_yl04() insert_sgroup('sgroup_four_yellow') insert_sgroup('sgroup_four_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx4T()
                    insert_sgroup('sgroup_four_yellow') insert_sgroup('sgroup_four_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx4T()
                    insert_main_group('main_group_yellow') instert_groups_to_main_group_2Gx4T()
end
  
    -- Yellow 1MGr x 2Gr [2SGr x 5Tr]
function mgr_yl05() insert_sgroup('sgroup_five_yellow') insert_sgroup('sgroup_five_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx5T()
                    insert_sgroup('sgroup_five_yellow') insert_sgroup('sgroup_five_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx5T()
                    insert_main_group('main_group_yellow') instert_groups_to_main_group_2Gx5T()
end
  
    -- Yellow 1MGr x 2Gr [2SGr x 6Tr]
function mgr_yl06() insert_sgroup('sgroup_six_yellow') insert_sgroup('sgroup_six_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx6T()
                    insert_sgroup('sgroup_six_yellow') insert_sgroup('sgroup_six_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx6T()
                    insert_main_group('main_group_yellow') instert_groups_to_main_group_2Gx6T()
end
  
    -- Yellow 1MGr x 2Gr [2SGr x 7Tr]
function mgr_yl07() insert_sgroup('sgroup_seven_yellow') insert_sgroup('sgroup_seven_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx7T()
                    insert_sgroup('sgroup_seven_yellow') insert_sgroup('sgroup_seven_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx7T()
                    insert_main_group('main_group_yellow') instert_groups_to_main_group_2Gx7T()
end
  
    -- Yellow 1MGr x 2Gr [2SGr x 8Tr]
function mgr_yl08() insert_sgroup('sgroup_eight_yellow') insert_sgroup('sgroup_eight_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx8T()
                    insert_sgroup('sgroup_eight_yellow') insert_sgroup('sgroup_eight_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx8T()
                    insert_main_group('main_group_yellow') instert_groups_to_main_group_2Gx8T()
end
 
    -- Groups (Not Main Group) ----

    -- Yellow 1 Group
function gr_yl01() local song = renoise.song()
                   insert_track_only(song.selected_track_index + 1, tyl.a2)
                   insert_group('group_one_yellow')
                   song:add_track_to_group(song.selected_track_index + 2 , song.selected_track_index + 1)
                   song:select_next_track()
end
    -- Yellow 2Gr [2SGr x 2Tr]
function gr_yl02() insert_sgroup('sgroup_two_yellow') insert_sgroup('sgroup_two_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_yellow') insert_sgroup('sgroup_two_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx2T()
end
    -- Yellow 2Gr [2SGr x 3Tr]
function gr_yl03() insert_sgroup('sgroup_three_yellow') insert_sgroup('sgroup_three_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx3T()
                   insert_sgroup('sgroup_three_yellow') insert_sgroup('sgroup_three_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx3T()
end
    -- Yellow 2Gr [2SGr x 4Tr]
function gr_yl04() insert_sgroup('sgroup_four_yellow') insert_sgroup('sgroup_four_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx4T()
                   insert_sgroup('sgroup_four_yellow') insert_sgroup('sgroup_four_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx4T()
end
    -- Yellow 2Gr [2SGr x 5Tr]
function gr_yl05() insert_sgroup('sgroup_five_yellow') insert_sgroup('sgroup_five_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx5T()
                   insert_sgroup('sgroup_five_yellow') insert_sgroup('sgroup_five_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx5T()
end
    -- Yellow 2Gr [2SGr x 6Tr]
function gr_yl06() insert_sgroup('sgroup_six_yellow') insert_sgroup('sgroup_six_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx6T()
                   insert_sgroup('sgroup_six_yellow') insert_sgroup('sgroup_six_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx6T()
end
    -- Yellow 2Gr [2SGr x 7Tr]
function gr_yl07() insert_sgroup('sgroup_seven_yellow') insert_sgroup('sgroup_seven_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx7T()
                   insert_sgroup('sgroup_seven_yellow') insert_sgroup('sgroup_seven_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx7T()
end
    -- Yellow 2Gr [2SGr x 8Tr]
function gr_yl08() insert_sgroup('sgroup_eight_yellow') insert_sgroup('sgroup_eight_yellow') insert_group('group_two_yellow') instert_sgroups_to_group_2Gx8T()
                   insert_sgroup('sgroup_eight_yellow') insert_sgroup('sgroup_eight_yellow') insert_group('group_one_yellow') instert_sgroups_to_group_2Gx8T()
end
    -- Yellow 4Gr [2SGr x 2Tr]
function gr_yl09() insert_sgroup('sgroup_two_yellow') insert_sgroup('sgroup_two_yellow') insert_group('group_four_yellow')  instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_yellow') insert_sgroup('sgroup_two_yellow') insert_group('group_three_yellow') instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_yellow') insert_sgroup('sgroup_two_yellow') insert_group('group_two_yellow')   instert_sgroups_to_group_2Gx2T()
                   insert_sgroup('sgroup_two_yellow') insert_sgroup('sgroup_two_yellow') insert_group('group_one_yellow')   instert_sgroups_to_group_2Gx2T()
end
 
    -- SubGroups (Not Groups) ----
  
    -- Yellow 4SGr x 2Tr
function sgr_yl01() insert_sgroup('sgroup_two_yellow') insert_sgroup('sgroup_two_yellow')
                    insert_sgroup('sgroup_two_yellow') insert_sgroup('sgroup_two_yellow')
end
    -- Yellow 4SGr x 3Tr
function sgr_yl02() insert_sgroup('sgroup_three_yellow') insert_sgroup('sgroup_three_yellow')
                    insert_sgroup('sgroup_three_yellow') insert_sgroup('sgroup_three_yellow')
end
    -- Yellow 4SGr x 4Tr
function sgr_yl03() insert_sgroup('sgroup_four_yellow') insert_sgroup('sgroup_four_yellow')
                    insert_sgroup('sgroup_four_yellow') insert_sgroup('sgroup_four_yellow')
end
    -- Yellow 4SGr x 5Tr
function sgr_yl04() insert_sgroup('sgroup_five_yellow') insert_sgroup('sgroup_five_yellow')
                    insert_sgroup('sgroup_five_yellow') insert_sgroup('sgroup_five_yellow')
end
    -- Yellow 4SGr x 6Tr
function sgr_yl05() insert_sgroup('sgroup_six_yellow') insert_sgroup('sgroup_six_yellow')
                    insert_sgroup('sgroup_six_yellow') insert_sgroup('sgroup_six_yellow')
end
    -- Yellow 4SGr x 7Tr
function sgr_yl06() insert_sgroup('sgroup_seven_yellow') insert_sgroup('sgroup_seven_yellow')
                    insert_sgroup('sgroup_seven_yellow') insert_sgroup('sgroup_seven_yellow')
end
    -- Yellow 4SGr x 8Tr
function sgr_yl07() insert_sgroup('sgroup_eight_yellow') insert_sgroup('sgroup_eight_yellow')
                    insert_sgroup('sgroup_eight_yellow') insert_sgroup('sgroup_eight_yellow')
end
    -- Yellow 2SGr x 6Tr
function sgr_yl08() insert_sgroup('sgroup_six_yellow') insert_sgroup('sgroup_six_yellow')
end
    -- Yellow 2SGr x 8Tr
function sgr_yl09() insert_sgroup('sgroup_eight_yellow') insert_sgroup('sgroup_eight_yellow')
end
    -- Yellow 1SGr x 8Tr
function sgr_yl10() insert_sgroup('sgroup_eight_yellow')
end

  
    -- Tracks (Not SubGroups) ----

    -- Yellow 1AuxTr
function tr_yla1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tyl.a1)
end

function tr_ylb1() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tyl.a2)
end
    -- Yellow 2Tr
function tr_yl02() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tyl.two) insert_track_only(rnst , tyl.one)
end
    -- Yellow 4Tr
function tr_yl03() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tyl.four)  insert_track_only(rnst , tyl.three) insert_track_only(rnst , tyl.two) insert_track_only(rnst , tyl.one)
end
    -- Yellow 6Tr
function tr_yl04() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tyl.six)   insert_track_only(rnst , tyl.five) insert_track_only(rnst , tyl.four)
                   insert_track_only(rnst , tyl.three) insert_track_only(rnst , tyl.two)  insert_track_only(rnst , tyl.one)
end
    -- Yellow 8Tr
function tr_yl05() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tyl.eight) insert_track_only(rnst , tyl.seven) insert_track_only(rnst , tyl.six) insert_track_only(rnst , tyl.five)
                   insert_track_only(rnst , tyl.four)  insert_track_only(rnst , tyl.three) insert_track_only(rnst , tyl.two) insert_track_only(rnst , tyl.one)
end
    -- Yellow 4Tr + 2AuxTr
function tr_yl06() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tyl.a2) insert_track_only(rnst , tyl.a1)
                   insert_track_only(rnst , tyl.four)  insert_track_only(rnst , tyl.three) insert_track_only(rnst , tyl.two) insert_track_only(rnst , tyl.one)
end
    -- Yellow 8Tr + 2AuxTr
function tr_yl07() local rnst = renoise.song().selected_track_index + 1
                   insert_track_only(rnst , tyl.a2) insert_track_only(rnst , tyl.a1)
                   insert_track_only(rnst , tyl.eight) insert_track_only(rnst , tyl.seven) insert_track_only(rnst , tyl.six) insert_track_only(rnst , tyl.five)
                   insert_track_only(rnst , tyl.four)  insert_track_only(rnst , tyl.three) insert_track_only(rnst , tyl.two) insert_track_only(rnst , tyl.one)
end




    --[[ == COMBINED == ]]--
  
    -- Main Groups --
  
    -- Comb. 2MGr x 2Gr [2SGr x 2Tr]
function mgr_com01() insert_sgroup("sgroup_two_white") insert_sgroup("sgroup_two_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_aqua") insert_sgroup("sgroup_two_brown") insert_group("group_three_violet") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx2T()
                     insert_sgroup("sgroup_two_orange") insert_sgroup("sgroup_two_pale") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_sky") insert_sgroup("sgroup_two_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx2T()
end
    -- Comb. 2MGr x 2Gr [2SGr x 2Tr] x2
function mgr_com02() insert_sgroup("sgroup_two_white") insert_sgroup("sgroup_two_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_aqua") insert_sgroup("sgroup_two_brown") insert_group("group_three_violet") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx2T()
                     insert_sgroup("sgroup_two_orange") insert_sgroup("sgroup_two_pale") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_sky") insert_sgroup("sgroup_two_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_white") insert_sgroup("sgroup_two_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_aqua") insert_sgroup("sgroup_two_brown") insert_group("group_three_violet") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx2T()
                     insert_sgroup("sgroup_two_orange") insert_sgroup("sgroup_two_pale") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_sky") insert_sgroup("sgroup_two_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx2T()
end
    -- Comb. 2MGr x 2Gr [2SGr x 4Tr]
function mgr_com03() insert_sgroup("sgroup_four_white") insert_sgroup("sgroup_four_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_aqua") insert_sgroup("sgroup_four_brown") insert_group("group_three_violet") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx4T()
                     insert_sgroup("sgroup_four_orange") insert_sgroup("sgroup_four_pale") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_sky") insert_sgroup("sgroup_four_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx4T()
end
    -- Comb. 2MGr x 2Gr [2SGr x 4Tr] x2
function mgr_com04() insert_sgroup("sgroup_four_white") insert_sgroup("sgroup_four_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_aqua") insert_sgroup("sgroup_four_brown") insert_group("group_three_violet") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx4T()
                     insert_sgroup("sgroup_four_orange") insert_sgroup("sgroup_four_pale") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_sky") insert_sgroup("sgroup_four_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_white") insert_sgroup("sgroup_four_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_aqua") insert_sgroup("sgroup_four_brown") insert_group("group_three_violet") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx4T()
                     insert_sgroup("sgroup_four_orange") insert_sgroup("sgroup_four_pale") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_sky") insert_sgroup("sgroup_four_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx4T()
end
    -- Comb. 2MGr x 2Gr [2SGr x 6Tr]
function mgr_com05() insert_sgroup("sgroup_six_white") insert_sgroup("sgroup_six_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx6T()
                     insert_sgroup("sgroup_six_aqua") insert_sgroup("sgroup_six_brown") insert_group("group_three_violet") instert_sgroups_to_group_2Gx6T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx6T()
                     insert_sgroup("sgroup_six_orange") insert_sgroup("sgroup_six_pale") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx6T()
                     insert_sgroup("sgroup_six_sky") insert_sgroup("sgroup_six_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx6T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx6T()
end
    -- Comb. 2MGr x 2Gr [2SGr x 6Tr] x2 ...Heavy!!!
function mgr_com06() insert_sgroup("sgroup_six_white") insert_sgroup("sgroup_six_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx6T()
                     insert_sgroup("sgroup_six_aqua") insert_sgroup("sgroup_six_brown") insert_group("group_three_violet") instert_sgroups_to_group_2Gx6T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx6T()
                     insert_sgroup("sgroup_six_orange") insert_sgroup("sgroup_six_pale") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx6T()
                     insert_sgroup("sgroup_six_sky") insert_sgroup("sgroup_six_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx6T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx6T()

                     insert_sgroup("sgroup_six_white") insert_sgroup("sgroup_six_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx6T()
                     insert_sgroup("sgroup_six_aqua") insert_sgroup("sgroup_six_brown") insert_group("group_three_violet") instert_sgroups_to_group_2Gx6T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx6T()
                     insert_sgroup("sgroup_six_orange") insert_sgroup("sgroup_six_pale") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx6T()
                     insert_sgroup("sgroup_six_sky") insert_sgroup("sgroup_six_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx6T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx6T()
end
    -- Comb. 2MGr x 2Gr [2SGr x 8Tr]
function mgr_com07() insert_sgroup("sgroup_eight_white") insert_sgroup("sgroup_eight_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx8T()
                     insert_sgroup("sgroup_eight_aqua") insert_sgroup("sgroup_eight_brown") insert_group("group_three_violet") instert_sgroups_to_group_2Gx8T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx8T()
                     insert_sgroup("sgroup_eight_orange") insert_sgroup("sgroup_eight_pale") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx8T()
                     insert_sgroup("sgroup_eight_sky") insert_sgroup("sgroup_eight_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx8T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx8T()
end
    -- Comb. A1.-8MGr x 2Gr [2SGr x 2Tr]
function mgr_com08() insert_sgroup("sgroup_two_white") insert_sgroup("sgroup_two_white") insert_group("group_two_white") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_white") insert_sgroup("sgroup_two_white") insert_group("group_one_white") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_white") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_violet") insert_sgroup("sgroup_two_violet") insert_group("group_two_violet") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_violet") insert_sgroup("sgroup_two_violet") insert_group("group_one_violet") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_violet") instert_groups_to_main_group_2Gx2T()
  
                     insert_sgroup("sgroup_two_orange") insert_sgroup("sgroup_two_orange") insert_group("group_two_orange") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_orange") insert_sgroup("sgroup_two_orange") insert_group("group_one_orange") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_orange") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_pink") insert_sgroup("sgroup_two_pink") insert_group("group_two_pink") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_pink") insert_sgroup("sgroup_two_pink") insert_group("group_one_pink") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_yellow") insert_sgroup("sgroup_two_yellow") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_yellow") insert_sgroup("sgroup_two_yellow") insert_group("group_one_yellow") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_yellow") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_blue") insert_sgroup("sgroup_two_blue") insert_group("group_two_blue") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_blue") insert_sgroup("sgroup_two_blue") insert_group("group_one_blue") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx2T()
  
                     insert_sgroup("sgroup_two_green") insert_sgroup("sgroup_two_green") insert_group("group_two_green") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_green") insert_sgroup("sgroup_two_green") insert_group("group_one_green") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_green") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_red") insert_sgroup("sgroup_two_red") insert_group("group_two_red") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_red") insert_sgroup("sgroup_two_red") insert_group("group_one_red") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_red") instert_groups_to_main_group_2Gx2T()
end
    -- Comb. A2.-8MGr x 2Gr [2SGr x 4Tr] ...Heavy!!!
function mgr_com09() insert_sgroup("sgroup_four_white") insert_sgroup("sgroup_four_white") insert_group("group_two_white") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_white") insert_sgroup("sgroup_four_white") insert_group("group_one_white") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_white") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_violet") insert_sgroup("sgroup_four_violet") insert_group("group_two_violet") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_violet") insert_sgroup("sgroup_four_violet") insert_group("group_one_violet") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_violet") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_orange") insert_sgroup("sgroup_four_orange") insert_group("group_two_orange") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_orange") insert_sgroup("sgroup_four_orange") insert_group("group_one_orange") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_orange") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_pink") insert_sgroup("sgroup_four_pink") insert_group("group_two_pink") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_pink") insert_sgroup("sgroup_four_pink") insert_group("group_one_pink") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_pink") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_yellow") insert_sgroup("sgroup_four_yellow") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_yellow") insert_sgroup("sgroup_four_yellow") insert_group("group_one_yellow") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_yellow") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_blue") insert_sgroup("sgroup_four_blue") insert_group("group_two_blue") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_blue") insert_sgroup("sgroup_four_blue") insert_group("group_one_blue") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_blue") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_green") insert_sgroup("sgroup_four_green") insert_group("group_two_green") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_green") insert_sgroup("sgroup_four_green") insert_group("group_one_green") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_green") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_red") insert_sgroup("sgroup_four_red") insert_group("group_two_red") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_red") insert_sgroup("sgroup_four_red") insert_group("group_one_red") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_red") instert_groups_to_main_group_2Gx4T()
end
    -- Comb. B1.-8MGr x 2Gr [2SGr x 2Tr]
function mgr_com10() insert_sgroup("sgroup_two_brown") insert_sgroup("sgroup_two_brown") insert_group("group_two_brown") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_brown") insert_sgroup("sgroup_two_brown") insert_group("group_one_brown") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_brown") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_pale") insert_sgroup("sgroup_two_pale") insert_group("group_two_pale") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_pale") insert_sgroup("sgroup_two_pale") insert_group("group_one_pale") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_pale") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_aqua") insert_sgroup("sgroup_two_aqua") insert_group("group_two_aqua") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_aqua") insert_sgroup("sgroup_two_aqua") insert_group("group_one_aqua") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_aqua") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_black") insert_sgroup("sgroup_two_black") insert_group("group_two_black") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_black") insert_sgroup("sgroup_two_black") insert_group("group_one_black") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_black") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_pistachio") insert_sgroup("sgroup_two_pistachio") insert_group("group_two_pistachio") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_pistachio") insert_sgroup("sgroup_two_pistachio") insert_group("group_one_pistachio") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_pistachio") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_gray") insert_sgroup("sgroup_two_gray") insert_group("group_two_gray") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_gray") insert_sgroup("sgroup_two_gray") insert_group("group_one_gray") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_gray") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_gold") insert_sgroup("sgroup_two_gold") insert_group("group_two_gold") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_gold") insert_sgroup("sgroup_two_gold") insert_group("group_one_gold") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_gold") instert_groups_to_main_group_2Gx2T()

                     insert_sgroup("sgroup_two_sky") insert_sgroup("sgroup_two_sky") insert_group("group_two_sky") instert_sgroups_to_group_2Gx2T()
                     insert_sgroup("sgroup_two_sky") insert_sgroup("sgroup_two_sky") insert_group("group_one_sky") instert_sgroups_to_group_2Gx2T()
                     insert_main_group("main_group_sky") instert_groups_to_main_group_2Gx2T()
end
    -- Comb. B2.-8MGr x 2Gr [2SGr x 4Tr] ...Heavy!!!
function mgr_com11() insert_sgroup("sgroup_four_brown") insert_sgroup("sgroup_four_brown") insert_group("group_two_brown") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_brown") insert_sgroup("sgroup_four_brown") insert_group("group_one_brown") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_brown") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_pale") insert_sgroup("sgroup_four_pale") insert_group("group_two_pale") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_pale") insert_sgroup("sgroup_four_pale") insert_group("group_one_pale") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_pale") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_aqua") insert_sgroup("sgroup_four_aqua") insert_group("group_two_aqua") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_aqua") insert_sgroup("sgroup_four_aqua") insert_group("group_one_aqua") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_aqua") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_black") insert_sgroup("sgroup_four_black") insert_group("group_two_black") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_black") insert_sgroup("sgroup_four_black") insert_group("group_one_black") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_black") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_pistachio") insert_sgroup("sgroup_four_pistachio") insert_group("group_two_pistachio") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_pistachio") insert_sgroup("sgroup_four_pistachio") insert_group("group_one_pistachio") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_pistachio") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_gray") insert_sgroup("sgroup_four_gray") insert_group("group_two_gray") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_gray") insert_sgroup("sgroup_four_gray") insert_group("group_one_gray") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_gray") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_gold") insert_sgroup("sgroup_four_gold") insert_group("group_two_gold") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_gold") insert_sgroup("sgroup_four_gold") insert_group("group_one_gold") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_gold") instert_groups_to_main_group_2Gx4T()

                     insert_sgroup("sgroup_four_sky") insert_sgroup("sgroup_four_sky") insert_group("group_two_sky") instert_sgroups_to_group_2Gx4T()
                     insert_sgroup("sgroup_four_sky") insert_sgroup("sgroup_four_sky") insert_group("group_one_sky") instert_sgroups_to_group_2Gx4T()
                     insert_main_group("main_group_sky") instert_groups_to_main_group_2Gx4T()
end
  
  
    -- Groups --
  
    -- Comb. 5Gr [2SGr x 2Tr]
function gr_com01() insert_sgroup("sgroup_two_orange") insert_sgroup("sgroup_two_pale") insert_group("group_five_violet") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_white") insert_sgroup("sgroup_two_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_aqua") insert_sgroup("sgroup_two_brown") insert_group("group_three_pink") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_sky") insert_sgroup("sgroup_two_gray") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_blue") insert_sgroup("sgroup_two_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx2T()
end
    -- Comb. 5Gr [2SGr x 2Tr] x2
function gr_com02() insert_sgroup("sgroup_two_orange") insert_sgroup("sgroup_two_pale") insert_group("group_five_violet") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_white") insert_sgroup("sgroup_two_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_aqua") insert_sgroup("sgroup_two_brown") insert_group("group_three_pink") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_sky") insert_sgroup("sgroup_two_gray") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_blue") insert_sgroup("sgroup_two_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx2T()

                    insert_sgroup("sgroup_two_orange") insert_sgroup("sgroup_two_pale") insert_group("group_five_violet") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_white") insert_sgroup("sgroup_two_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_aqua") insert_sgroup("sgroup_two_brown") insert_group("group_three_pink") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_sky") insert_sgroup("sgroup_two_gray") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx2T()
                    insert_sgroup("sgroup_two_blue") insert_sgroup("sgroup_two_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx2T()
end
    -- Comb. 5Gr [2SGr x 4Tr]
function gr_com03() insert_sgroup("sgroup_four_orange") insert_sgroup("sgroup_four_pale") insert_group("group_five_violet") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_white") insert_sgroup("sgroup_four_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_aqua") insert_sgroup("sgroup_four_brown") insert_group("group_three_pink") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_sky") insert_sgroup("sgroup_four_gray") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_blue") insert_sgroup("sgroup_four_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx4T()
end
    -- Comb. 5Gr [2SGr x 4Tr] x2
function gr_com04() insert_sgroup("sgroup_four_orange") insert_sgroup("sgroup_four_pale") insert_group("group_five_violet") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_white") insert_sgroup("sgroup_four_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_aqua") insert_sgroup("sgroup_four_brown") insert_group("group_three_pink") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_sky") insert_sgroup("sgroup_four_gray") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_blue") insert_sgroup("sgroup_four_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx4T()

                    insert_sgroup("sgroup_four_orange") insert_sgroup("sgroup_four_pale") insert_group("group_five_violet") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_white") insert_sgroup("sgroup_four_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_aqua") insert_sgroup("sgroup_four_brown") insert_group("group_three_pink") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_sky") insert_sgroup("sgroup_four_gray") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx4T()
                    insert_sgroup("sgroup_four_blue") insert_sgroup("sgroup_four_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx4T()
end
    -- Comb. 5Gr [2SGr x 6Tr]
function gr_com05() insert_sgroup("sgroup_six_orange") insert_sgroup("sgroup_six_pale") insert_group("group_five_violet") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_white") insert_sgroup("sgroup_six_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_aqua") insert_sgroup("sgroup_six_brown") insert_group("group_three_pink") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_sky") insert_sgroup("sgroup_six_gray") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_blue") insert_sgroup("sgroup_six_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx6T()
end
    -- Comb. 5Gr [2SGr x 6Tr] x2 ...Heavy!!!
function gr_com06() insert_sgroup("sgroup_six_orange") insert_sgroup("sgroup_six_pale") insert_group("group_five_violet") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_white") insert_sgroup("sgroup_six_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_aqua") insert_sgroup("sgroup_six_brown") insert_group("group_three_pink") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_sky") insert_sgroup("sgroup_six_gray") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_blue") insert_sgroup("sgroup_six_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx6T()

                    insert_sgroup("sgroup_six_orange") insert_sgroup("sgroup_six_pale") insert_group("group_five_violet") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_white") insert_sgroup("sgroup_six_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_aqua") insert_sgroup("sgroup_six_brown") insert_group("group_three_pink") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_sky") insert_sgroup("sgroup_six_gray") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx6T()
                    insert_sgroup("sgroup_six_blue") insert_sgroup("sgroup_six_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx6T()
end
    -- Comb. 5Gr [2SGr x 8Tr]
function gr_com07() insert_sgroup("sgroup_eight_orange") insert_sgroup("sgroup_eight_pale") insert_group("group_five_violet") instert_sgroups_to_group_2Gx8T()
                    insert_sgroup("sgroup_eight_white") insert_sgroup("sgroup_eight_gold") insert_group("group_four_pistachio") instert_sgroups_to_group_2Gx8T()
                    insert_sgroup("sgroup_eight_aqua") insert_sgroup("sgroup_eight_brown") insert_group("group_three_pink") instert_sgroups_to_group_2Gx8T()
                    insert_sgroup("sgroup_eight_sky") insert_sgroup("sgroup_eight_gray") insert_group("group_two_yellow") instert_sgroups_to_group_2Gx8T()
                    insert_sgroup("sgroup_eight_blue") insert_sgroup("sgroup_eight_green") insert_group("group_one_red") instert_sgroups_to_group_2Gx8T()
end
  
  
    -- SubGroups (Not Groups) --
  
    -- Comb. 16SGr x 2Tr
function sgr_com01() insert_sgroup("sgroup_two_pale") insert_sgroup("sgroup_two_sky") insert_sgroup("sgroup_two_black") insert_sgroup("sgroup_two_pistachio")
                     insert_sgroup("sgroup_two_gray") insert_sgroup("sgroup_two_gold") insert_sgroup("sgroup_two_white") insert_sgroup("sgroup_two_aqua")
                     insert_sgroup("sgroup_two_brown") insert_sgroup("sgroup_two_violet") insert_sgroup("sgroup_two_orange") insert_sgroup("sgroup_two_pink")
                     insert_sgroup("sgroup_two_yellow") insert_sgroup("sgroup_two_blue") insert_sgroup("sgroup_two_green") insert_sgroup("sgroup_two_red")
end
    -- Comb. 16SGr x 4Tr
function sgr_com02() insert_sgroup("sgroup_four_pale") insert_sgroup("sgroup_four_sky") insert_sgroup("sgroup_four_black") insert_sgroup("sgroup_four_pistachio")
                     insert_sgroup("sgroup_four_gray") insert_sgroup("sgroup_four_gold") insert_sgroup("sgroup_four_white") insert_sgroup("sgroup_four_aqua")
                     insert_sgroup("sgroup_four_brown") insert_sgroup("sgroup_four_violet") insert_sgroup("sgroup_four_orange") insert_sgroup("sgroup_four_pink")
                     insert_sgroup("sgroup_four_yellow") insert_sgroup("sgroup_four_blue") insert_sgroup("sgroup_four_green") insert_sgroup("sgroup_four_red")
end
    -- Comb. 16SGr x 6Tr
function sgr_com03() insert_sgroup("sgroup_six_pale") insert_sgroup("sgroup_six_sky") insert_sgroup("sgroup_six_black") insert_sgroup("sgroup_six_pistachio")
                     insert_sgroup("sgroup_six_gray") insert_sgroup("sgroup_six_gold") insert_sgroup("sgroup_six_white") insert_sgroup("sgroup_six_aqua")
                     insert_sgroup("sgroup_six_brown") insert_sgroup("sgroup_six_violet") insert_sgroup("sgroup_six_orange") insert_sgroup("sgroup_six_pink")
                     insert_sgroup("sgroup_six_yellow") insert_sgroup("sgroup_six_blue") insert_sgroup("sgroup_six_green") insert_sgroup("sgroup_six_red")
end
    -- Comb. 16SGr x 8Tr
function sgr_com04() insert_sgroup("sgroup_eight_pale") insert_sgroup("sgroup_eight_sky") insert_sgroup("sgroup_eight_black") insert_sgroup("sgroup_eight_pistachio")
                     insert_sgroup("sgroup_eight_gray") insert_sgroup("sgroup_eight_gold") insert_sgroup("sgroup_eight_white") insert_sgroup("sgroup_eight_aqua")
                     insert_sgroup("sgroup_eight_brown") insert_sgroup("sgroup_eight_violet") insert_sgroup("sgroup_eight_orange") insert_sgroup("sgroup_eight_pink")
                     insert_sgroup("sgroup_eight_yellow") insert_sgroup("sgroup_eight_blue") insert_sgroup("sgroup_eight_green") insert_sgroup("sgroup_eight_red")
end


    -- Tracks (Not SubGroups) --
  
    -- Comb. 16x 2Tr
function tr_com01() local rnst = renoise.song().selected_track_index + 1
                    local ito = insert_track_only
                    ito(rnst , tpl.one) ito(rnst , tsk.two) ito(rnst , tsk.one) ito(rnst , tgl.two) ito(rnst , tgl.one) ito(rnst , twh.two) ito(rnst , twh.one) ito(rnst , tps.two)
                    ito(rnst , tps.one) ito(rnst , tgy.two) ito(rnst , tgy.one) ito(rnst , taq.two) ito(rnst , taq.one) ito(rnst , tbk.two) ito(rnst , tbk.one) ito(rnst , tbr.two)
                    ito(rnst , tbr.one) ito(rnst , tvl.two) ito(rnst , tvl.one) ito(rnst , tor.two) ito(rnst , tor.one) ito(rnst , tpn.two) ito(rnst , tpn.one) ito(rnst , tyl.two)
                    ito(rnst , tyl.one) ito(rnst , tbl.two) ito(rnst , tbl.one) ito(rnst , tgr.two) ito(rnst , tgr.one) ito(rnst , trd.two) ito(rnst , trd.one) ito(rnst , tpl.two)
end
    -- Comb. 16x 4Tr
function tr_com02() local rnst = renoise.song().selected_track_index + 1
                    local ito = insert_track_only
                    ito(rnst , tpl.four) ito(rnst , tpl.three) ito(rnst , tpl.two) ito(rnst , tpl.one) ito(rnst , tsk.four) ito(rnst , tsk.three) ito(rnst , tsk.two) ito(rnst , tsk.one)
                    ito(rnst , tgl.four) ito(rnst , tgl.three) ito(rnst , tgl.two) ito(rnst , tgl.one) ito(rnst , twh.four) ito(rnst , twh.three) ito(rnst , twh.two) ito(rnst , twh.one)
                    ito(rnst , tps.four) ito(rnst , tps.three) ito(rnst , tps.two) ito(rnst , tps.one) ito(rnst , tgy.four) ito(rnst , tgy.three) ito(rnst , tgy.two) ito(rnst , tgy.one)
                    ito(rnst , taq.four) ito(rnst , taq.three) ito(rnst , taq.two) ito(rnst , taq.one) ito(rnst , tbk.four) ito(rnst , tbk.three) ito(rnst , tbk.two) ito(rnst , tbk.one)
                    ito(rnst , tbr.four) ito(rnst , tbr.three) ito(rnst , tbr.two) ito(rnst , tbr.one) ito(rnst , tvl.four) ito(rnst , tvl.three) ito(rnst , tvl.two) ito(rnst , tvl.one)
                    ito(rnst , tor.four) ito(rnst , tor.three) ito(rnst , tor.two) ito(rnst , tor.one) ito(rnst , tpn.four) ito(rnst , tpn.three) ito(rnst , tpn.two) ito(rnst , tpn.one)
                    ito(rnst , tyl.four) ito(rnst , tyl.three) ito(rnst , tyl.two) ito(rnst , tyl.one) ito(rnst , tbl.four) ito(rnst , tbl.three) ito(rnst , tbl.two) ito(rnst , tbl.one)
                    ito(rnst , tgr.four) ito(rnst , tgr.three) ito(rnst , tgr.two) ito(rnst , tgr.one) ito(rnst , trd.four) ito(rnst , trd.three) ito(rnst , trd.two) ito(rnst , trd.one)
end
    -- Comb. 16x 6Tr
function tr_com03() local rnst = renoise.song().selected_track_index + 1
                    local ito = insert_track_only
                    ito(rnst , tpl.six) ito(rnst , tpl.five) ito(rnst , tpl.four) ito(rnst , tpl.three) ito(rnst , tpl.two) ito(rnst , tpl.one)
                    ito(rnst , tsk.six) ito(rnst , tsk.five) ito(rnst , tsk.four) ito(rnst , tsk.three) ito(rnst , tsk.two) ito(rnst , tsk.one)
                    ito(rnst , tgl.six) ito(rnst , tgl.five) ito(rnst , tgl.four) ito(rnst , tgl.three) ito(rnst , tgl.two) ito(rnst , tgl.one)
                    ito(rnst , twh.six) ito(rnst , twh.five) ito(rnst , twh.four) ito(rnst , twh.three) ito(rnst , twh.two) ito(rnst , twh.one)
                    ito(rnst , tps.six) ito(rnst , tps.five) ito(rnst , tps.four) ito(rnst , tps.three) ito(rnst , tps.two) ito(rnst , tps.one)
                    ito(rnst , tgy.six) ito(rnst , tgy.five) ito(rnst , tgy.four) ito(rnst , tgy.three) ito(rnst , tgy.two) ito(rnst , tgy.one)
                    ito(rnst , taq.six) ito(rnst , taq.five) ito(rnst , taq.four) ito(rnst , taq.three) ito(rnst , taq.two) ito(rnst , taq.one)
                    ito(rnst , tbk.six) ito(rnst , tbk.five) ito(rnst , tbk.four) ito(rnst , tbk.three) ito(rnst , tbk.two) ito(rnst , tbk.one)
                    ito(rnst , tbr.six) ito(rnst , tbr.five) ito(rnst , tbr.four) ito(rnst , tbr.three) ito(rnst , tbr.two) ito(rnst , tbr.one)
                    ito(rnst , tvl.six) ito(rnst , tvl.five) ito(rnst , tvl.four) ito(rnst , tvl.three) ito(rnst , tvl.two) ito(rnst , tvl.one)
                    ito(rnst , tor.six) ito(rnst , tor.five) ito(rnst , tor.four) ito(rnst , tor.three) ito(rnst , tor.two) ito(rnst , tor.one)
                    ito(rnst , tpn.six) ito(rnst , tpn.five) ito(rnst , tpn.four) ito(rnst , tpn.three) ito(rnst , tpn.two) ito(rnst , tpn.one)
                    ito(rnst , tyl.six) ito(rnst , tyl.five) ito(rnst , tyl.four) ito(rnst , tyl.three) ito(rnst , tyl.two) ito(rnst , tyl.one)
                    ito(rnst , tbl.six) ito(rnst , tbl.five) ito(rnst , tbl.four) ito(rnst , tbl.three) ito(rnst , tbl.two) ito(rnst , tbl.one)
                    ito(rnst , tgr.six) ito(rnst , tgr.five) ito(rnst , tgr.four) ito(rnst , tgr.three) ito(rnst , tgr.two) ito(rnst , tgr.one)
                    ito(rnst , trd.six) ito(rnst , trd.five) ito(rnst , trd.four) ito(rnst , trd.three) ito(rnst , trd.two) ito(rnst , trd.one)
end
    -- Comb. 16x 8Tr
function tr_com04() local rnst = renoise.song().selected_track_index + 1
                    local ito = insert_track_only
                    ito(rnst , tpl.eight) ito(rnst , tpl.seven) ito(rnst , tpl.six) ito(rnst , tpl.five) ito(rnst , tpl.four) ito(rnst , tpl.three) ito(rnst , tpl.two) ito(rnst , tpl.one)
                    ito(rnst , tsk.eight) ito(rnst , tsk.seven) ito(rnst , tsk.six) ito(rnst , tsk.five) ito(rnst , tsk.four) ito(rnst , tsk.three) ito(rnst , tsk.two) ito(rnst , tsk.one)
                    ito(rnst , tgl.eight) ito(rnst , tgl.seven) ito(rnst , tgl.six) ito(rnst , tgl.five) ito(rnst , tgl.four) ito(rnst , tgl.three) ito(rnst , tgl.two) ito(rnst , tgl.one)
                    ito(rnst , twh.eight) ito(rnst , twh.seven) ito(rnst , twh.six) ito(rnst , twh.five) ito(rnst , twh.four) ito(rnst , twh.three) ito(rnst , twh.two) ito(rnst , twh.one)
                    ito(rnst , tps.eight) ito(rnst , tps.seven) ito(rnst , tps.six) ito(rnst , tps.five) ito(rnst , tps.four) ito(rnst , tps.three) ito(rnst , tps.two) ito(rnst , tps.one)
                    ito(rnst , tgy.eight) ito(rnst , tgy.seven) ito(rnst , tgy.six) ito(rnst , tgy.five) ito(rnst , tgy.four) ito(rnst , tgy.three) ito(rnst , tgy.two) ito(rnst , tgy.one)
                    ito(rnst , taq.eight) ito(rnst , taq.seven) ito(rnst , taq.six) ito(rnst , taq.five) ito(rnst , taq.four) ito(rnst , taq.three) ito(rnst , taq.two) ito(rnst , taq.one)
                    ito(rnst , tbk.eight) ito(rnst , tbk.seven) ito(rnst , tbk.six) ito(rnst , tbk.five) ito(rnst , tbk.four) ito(rnst , tbk.three) ito(rnst , tbk.two) ito(rnst , tbk.one)
                    ito(rnst , tbr.eight) ito(rnst , tbr.seven) ito(rnst , tbr.six) ito(rnst , tbr.five) ito(rnst , tbr.four) ito(rnst , tbr.three) ito(rnst , tbr.two) ito(rnst , tbr.one)
                    ito(rnst , tvl.eight) ito(rnst , tvl.seven) ito(rnst , tvl.six) ito(rnst , tvl.five) ito(rnst , tvl.four) ito(rnst , tvl.three) ito(rnst , tvl.two) ito(rnst , tvl.one)
                    ito(rnst , tor.eight) ito(rnst , tor.seven) ito(rnst , tor.six) ito(rnst , tor.five) ito(rnst , tor.four) ito(rnst , tor.three) ito(rnst , tor.two) ito(rnst , tor.one)
                    ito(rnst , tpn.eight) ito(rnst , tpn.seven) ito(rnst , tpn.six) ito(rnst , tpn.five) ito(rnst , tpn.four) ito(rnst , tpn.three) ito(rnst , tpn.two) ito(rnst , tpn.one)
                    ito(rnst , tyl.eight) ito(rnst , tyl.seven) ito(rnst , tyl.six) ito(rnst , tyl.five) ito(rnst , tyl.four) ito(rnst , tyl.three) ito(rnst , tyl.two) ito(rnst , tyl.one)
                    ito(rnst , tbl.eight) ito(rnst , tbl.seven) ito(rnst , tbl.six) ito(rnst , tbl.five) ito(rnst , tbl.four) ito(rnst , tbl.three) ito(rnst , tbl.two) ito(rnst , tbl.one)
                    ito(rnst , tgr.eight) ito(rnst , tgr.seven) ito(rnst , tgr.six) ito(rnst , tgr.five) ito(rnst , tgr.four) ito(rnst , tgr.three) ito(rnst , tgr.two) ito(rnst , tgr.one)
                    ito(rnst , trd.eight) ito(rnst , trd.seven) ito(rnst , trd.six) ito(rnst , trd.five) ito(rnst , trd.four) ito(rnst , trd.three) ito(rnst , trd.two) ito(rnst , trd.one)
end




--== GUI =====================================

  -- ========================================= Main Groups =========================================

function all_colors()

  local vb = renoise.ViewBuilder()
  local menu_x4 = vb:switch   { items = { 'A: Main Groups' , 'B: Groups' , 'C: SubGroups' , 'D: Tracks' , 'E: Combined' } , width = 500 , height = 20 , value = 1 }

  local view = 
  vb:vertical_aligner {
    margin = 10 ,
    vb:horizontal_aligner {
      margin = 5 ,
      mode = 'center' ,
      menu_x4 
    }
  }

  local res = renoise.app():show_custom_prompt ( 'Preselect a Option...' , view , { 'Select', 'Cancel' } );
     if res == 'Select' then
        if menu_x4.value == 1 then main_groups_colors() end -- 1 Main Grousp
        if menu_x4.value == 2 then groups_colors()      end -- 2 Groups
        if menu_x4.value == 3 then subgroups_colors()   end -- 3 SubGroups
        if menu_x4.value == 4 then tracks_colors()      end -- 4 Track
        if menu_x4.value == 5 then combined_colors()    end -- 5 Combined
     end

end

function combined_colors()

  local vb = renoise.ViewBuilder()
  local menu_x4 = vb:switch   { items = { 'E1: Main Groups' , 'E2: Groups' , 'E3: SubGroups' , 'E4: Tracks' } , width = 400 , height = 20 , value = 1 }

  local view = 
  vb:vertical_aligner {
    margin = 10 ,
    vb:horizontal_aligner {
      margin = 5 ,
      mode = 'center' ,
      menu_x4 
    }
  }

  local res = renoise.app():show_custom_prompt ( 'Preselect a Option for Combined Colors...' , view , { 'Select', 'Undo', 'Cancel' } );
     if res == 'Select' then
        if menu_x4.value == 1 then main_groups_combined() end -- 1 Main Grousp
        if menu_x4.value == 2 then groups_combined()      end -- 2 Groups
        if menu_x4.value == 3 then subgroups_combined()   end -- 3 SubGroups
        if menu_x4.value == 4 then tracks_combined()      end -- 4 Track
     end
     if res == 'Undo' then all_colors()
     end

end



function main_groups_colors()
  local vb = renoise.ViewBuilder()
  
    --local xxx_xx = vb:checkbox { }
    --local yyy_yy = vb:valuebox { min = 0 , max = 8 , value = 0 }
  local but_aq = vb:button   { active = false , width = 42 , height = 30 , color = { 0x1A,0x9A,0x8D } , tooltip = 'Aqua Color' }      --  1 Aqua aq
  local but_bk = vb:button   { active = false , width = 41 , height = 30 , color = { 0x24,0x24,0x24 } , tooltip = 'Black Color' }     --  2 Black bk
  local but_bl = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0x44,0xFF } , tooltip = 'Blue Color' }      --  3 Blue bl
  local but_br = vb:button   { active = false , width = 41 , height = 30 , color = { 0x99,0x4D,0x00 } , tooltip = 'Brown Color' }     --  4 Brown br
  local but_gl = vb:button   { active = false , width = 41 , height = 30 , color = { 0xEF,0xA5,0x13 } , tooltip = 'Gold Color' }      --  5 Gold gl
  local but_gy = vb:button   { active = false , width = 41 , height = 30 , color = { 0x70,0x70,0x70 } , tooltip = 'Gray Color' }      --  6 Gray gy
  local but_gr = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0x99,0x19 } , tooltip = 'Green Color' }     --  7 Green gr
  local but_or = vb:button   { active = false , width = 41 , height = 30 , color = { 0xEE,0x70,0x00 } , tooltip = 'Orange Color' }    --  8 Orange or
  local but_pl = vb:button   { active = false , width = 41 , height = 30 , color = { 0xE4,0xB1,0xC9 } , tooltip = 'Pale Pink Color' } --  9 Pale Pink pl
  local but_pn = vb:button   { active = false , width = 41 , height = 30 , color = { 0xE0,0x00,0x90 } , tooltip = 'Pink Color' }      -- 10 Pink pn
  local but_ps = vb:button   { active = false , width = 41 , height = 30 , color = { 0x70,0xEF,0x85 } , tooltip = 'Pistachio Color' } -- 11 Pistachio ps
  local but_rd = vb:button   { active = false , width = 41 , height = 30 , color = { 0xCC,0x00,0x00 } , tooltip = 'Red Color' }       -- 12 Red rd
  local but_sk = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0xDD,0xEE } , tooltip = 'Sky Blue Color' }  -- 13 Sky Blue sk
  local but_vl = vb:button   { active = false , width = 41 , height = 30 , color = { 0x81,0x00,0xEB } , tooltip = 'Violet Color' }    -- 14 Violet vl
  local but_wh = vb:button   { active = false , width = 41 , height = 30 , color = { 0xF1,0xF1,0xF1 } , tooltip = 'White Color' }     -- 15 White wh
  local but_yl = vb:button   { active = false , width = 43 , height = 30 , color = { 0xD1,0xD1,0x00 } , tooltip = 'Yellow Color' }    -- 16 Yellow yl

  local swi_cl = vb:switch   { items = { 'Aq' , 'Bk' , 'Bl' , 'Br' , 'Gl' , 'Gy' , 'Gr' , 'Or' , 'Pl' , 'Pn' , 'Ps' , 'Rd' , 'Sk' , 'Vl' , 'Wh' , 'Yl' } , width = 660 , height = 20 , value = 1 }
  local mgroup = vb:popup    { width = 354 , height = 24, value = 2, items = {
                                                                        '1 Main Group [1 Aux Track]' ,
                                                                        '1 Main Group x 2 Groups [2 SubGroups x 2 Tracks]' ,
                                                                        '1 Main Group x 2 Groups [2 SubGroups x 3 Tracks]' ,
                                                                        '1 Main Group x 2 Groups [2 SubGroups x 4 Tracks]' ,
                                                                        '1 Main Group x 2 Groups [2 SubGroups x 5 Tracks]' ,
                                                                        '1 Main Group x 2 Groups [2 SubGroups x 6 Tracks]' ,
                                                                        '1 Main Group x 2 Groups [2 SubGroups x 7 Tracks]' ,
                                                                        '1 Main Group x 2 Groups [2 SubGroups x 8 Tracks]' ,
                                                                      }
                             }
  local view =
  vb:vertical_aligner {
    margin = 10 ,
    spacing = 0 ,
    vb:horizontal_aligner {
    margin = 5 ,
    --mode = 'center',  
    vb:text{text = '1.- Select Main Color :' , font = 'bold' } ,
    } ,
    vb:horizontal_aligner {
      swi_cl ,
    } ,
    vb:horizontal_aligner {
      but_aq , but_bk , but_bl , but_br , but_gl , but_gy , but_gr , but_or , but_pl , but_pn , but_ps , but_rd , but_sk , but_vl , but_wh , but_yl ,
    } ,
    vb:horizontal_aligner {
      margin = 20
    },
    vb:horizontal_aligner {
      margin = 5 ,
        vb:text{ text = '2.- Select Main Group :' , font = 'bold' } ,
    } ,
    vb:vertical_aligner {
      mgroup ,
    }
  }

  local res = renoise.app():show_custom_prompt ( 'A: Insert Main Groups per Colors' , view , { 'Insert MGr' , 'Undo' , 'Cancel' } );

    if res == 'Insert MGr' then
        -- Aqua aq
        if swi_cl.value ==  1 and mgroup.value == 1 then mgr_aq01() end -- 1 Main Group
        if swi_cl.value ==  1 and mgroup.value == 2 then mgr_aq02() end -- 1 Main Group x 2 Groups [2 SubGroups x 2 Tracks]
        if swi_cl.value ==  1 and mgroup.value == 3 then mgr_aq03() end -- 1 Main Group x 2 Groups [2 SubGroups x 3 Tracks]
        if swi_cl.value ==  1 and mgroup.value == 4 then mgr_aq04() end -- 1 Main Group x 2 Groups [2 SubGroups x 4 Tracks]
        if swi_cl.value ==  1 and mgroup.value == 5 then mgr_aq05() end -- 1 Main Group x 2 Groups [2 SubGroups x 5 Tracks]
        if swi_cl.value ==  1 and mgroup.value == 6 then mgr_aq06() end -- 1 Main Group x 2 Groups [2 SubGroups x 6 Tracks]
        if swi_cl.value ==  1 and mgroup.value == 7 then mgr_aq07() end -- 1 Main Group x 2 Groups [2 SubGroups x 7 Tracks]
        if swi_cl.value ==  1 and mgroup.value == 8 then mgr_aq08() end -- 1 Main Group x 2 Groups [2 SubGroups x 8 Tracks]
        -- Black bk
        if swi_cl.value ==  2 and mgroup.value == 1 then mgr_bk01() end
        if swi_cl.value ==  2 and mgroup.value == 2 then mgr_bk02() end
        if swi_cl.value ==  2 and mgroup.value == 3 then mgr_bk03() end
        if swi_cl.value ==  2 and mgroup.value == 4 then mgr_bk04() end
        if swi_cl.value ==  2 and mgroup.value == 5 then mgr_bk05() end
        if swi_cl.value ==  2 and mgroup.value == 6 then mgr_bk06() end
        if swi_cl.value ==  2 and mgroup.value == 7 then mgr_bk07() end
        if swi_cl.value ==  2 and mgroup.value == 8 then mgr_bk08() end
        -- Blue bl
        if swi_cl.value ==  3 and mgroup.value == 1 then mgr_bl01() end
        if swi_cl.value ==  3 and mgroup.value == 2 then mgr_bl02() end
        if swi_cl.value ==  3 and mgroup.value == 3 then mgr_bl03() end
        if swi_cl.value ==  3 and mgroup.value == 4 then mgr_bl04() end
        if swi_cl.value ==  3 and mgroup.value == 5 then mgr_bl05() end
        if swi_cl.value ==  3 and mgroup.value == 6 then mgr_bl06() end
        if swi_cl.value ==  3 and mgroup.value == 7 then mgr_bl07() end
        if swi_cl.value ==  3 and mgroup.value == 8 then mgr_bl08() end
        -- Brown br
        if swi_cl.value ==  4 and mgroup.value == 1 then mgr_br01() end
        if swi_cl.value ==  4 and mgroup.value == 2 then mgr_br02() end
        if swi_cl.value ==  4 and mgroup.value == 3 then mgr_br03() end
        if swi_cl.value ==  4 and mgroup.value == 4 then mgr_br04() end
        if swi_cl.value ==  4 and mgroup.value == 5 then mgr_br05() end
        if swi_cl.value ==  4 and mgroup.value == 6 then mgr_br06() end
        if swi_cl.value ==  4 and mgroup.value == 7 then mgr_br07() end
        if swi_cl.value ==  4 and mgroup.value == 8 then mgr_br08() end
        -- Gold gl
        if swi_cl.value ==  5 and mgroup.value == 1 then mgr_gl01() end
        if swi_cl.value ==  5 and mgroup.value == 2 then mgr_gl02() end
        if swi_cl.value ==  5 and mgroup.value == 3 then mgr_gl03() end
        if swi_cl.value ==  5 and mgroup.value == 4 then mgr_gl04() end
        if swi_cl.value ==  5 and mgroup.value == 5 then mgr_gl05() end
        if swi_cl.value ==  5 and mgroup.value == 6 then mgr_gl06() end
        if swi_cl.value ==  5 and mgroup.value == 7 then mgr_gl07() end
        if swi_cl.value ==  5 and mgroup.value == 8 then mgr_gl08() end
        -- Gray gy
        if swi_cl.value ==  6 and mgroup.value == 1 then mgr_gy01() end
        if swi_cl.value ==  6 and mgroup.value == 2 then mgr_gy02() end
        if swi_cl.value ==  6 and mgroup.value == 3 then mgr_gy03() end
        if swi_cl.value ==  6 and mgroup.value == 4 then mgr_gy04() end
        if swi_cl.value ==  6 and mgroup.value == 5 then mgr_gy05() end
        if swi_cl.value ==  6 and mgroup.value == 6 then mgr_gy06() end
        if swi_cl.value ==  6 and mgroup.value == 7 then mgr_gy07() end
        if swi_cl.value ==  6 and mgroup.value == 8 then mgr_gy08() end
        -- Green gr
        if swi_cl.value ==  7 and mgroup.value == 1 then mgr_gr01() end
        if swi_cl.value ==  7 and mgroup.value == 2 then mgr_gr02() end
        if swi_cl.value ==  7 and mgroup.value == 3 then mgr_gr03() end
        if swi_cl.value ==  7 and mgroup.value == 4 then mgr_gr04() end
        if swi_cl.value ==  7 and mgroup.value == 5 then mgr_gr05() end
        if swi_cl.value ==  7 and mgroup.value == 6 then mgr_gr06() end
        if swi_cl.value ==  7 and mgroup.value == 7 then mgr_gr07() end
        if swi_cl.value ==  7 and mgroup.value == 8 then mgr_gr08() end
        -- Orange or
        if swi_cl.value ==  8 and mgroup.value == 1 then mgr_or01() end
        if swi_cl.value ==  8 and mgroup.value == 2 then mgr_or02() end
        if swi_cl.value ==  8 and mgroup.value == 3 then mgr_or03() end
        if swi_cl.value ==  8 and mgroup.value == 4 then mgr_or04() end
        if swi_cl.value ==  8 and mgroup.value == 5 then mgr_or05() end
        if swi_cl.value ==  8 and mgroup.value == 6 then mgr_or06() end
        if swi_cl.value ==  8 and mgroup.value == 7 then mgr_or07() end
        if swi_cl.value ==  8 and mgroup.value == 8 then mgr_or08() end
        -- Pale Pink pl
        if swi_cl.value ==  9 and mgroup.value == 1 then mgr_pl01() end
        if swi_cl.value ==  9 and mgroup.value == 2 then mgr_pl02() end
        if swi_cl.value ==  9 and mgroup.value == 3 then mgr_pl03() end
        if swi_cl.value ==  9 and mgroup.value == 4 then mgr_pl04() end
        if swi_cl.value ==  9 and mgroup.value == 5 then mgr_pl05() end
        if swi_cl.value ==  9 and mgroup.value == 6 then mgr_pl06() end
        if swi_cl.value ==  9 and mgroup.value == 7 then mgr_pl07() end
        if swi_cl.value ==  9 and mgroup.value == 8 then mgr_pl08() end
        -- Pink pn
        if swi_cl.value == 10 and mgroup.value == 1 then mgr_pn01() end
        if swi_cl.value == 10 and mgroup.value == 2 then mgr_pn02() end
        if swi_cl.value == 10 and mgroup.value == 3 then mgr_pn03() end
        if swi_cl.value == 10 and mgroup.value == 4 then mgr_pn04() end
        if swi_cl.value == 10 and mgroup.value == 5 then mgr_pn05() end
        if swi_cl.value == 10 and mgroup.value == 6 then mgr_pn06() end
        if swi_cl.value == 10 and mgroup.value == 7 then mgr_pn07() end
        if swi_cl.value == 10 and mgroup.value == 8 then mgr_pn08() end
        -- Pistachio ps
        if swi_cl.value == 11 and mgroup.value == 1 then mgr_ps01() end
        if swi_cl.value == 11 and mgroup.value == 2 then mgr_ps02() end
        if swi_cl.value == 11 and mgroup.value == 3 then mgr_ps03() end
        if swi_cl.value == 11 and mgroup.value == 4 then mgr_ps04() end
        if swi_cl.value == 11 and mgroup.value == 5 then mgr_ps05() end
        if swi_cl.value == 11 and mgroup.value == 6 then mgr_ps06() end
        if swi_cl.value == 11 and mgroup.value == 7 then mgr_ps07() end
        if swi_cl.value == 11 and mgroup.value == 8 then mgr_ps08() end
        -- Red rd
        if swi_cl.value == 12 and mgroup.value == 1 then mgr_rd01() end
        if swi_cl.value == 12 and mgroup.value == 2 then mgr_rd02() end
        if swi_cl.value == 12 and mgroup.value == 3 then mgr_rd03() end
        if swi_cl.value == 12 and mgroup.value == 4 then mgr_rd04() end
        if swi_cl.value == 12 and mgroup.value == 5 then mgr_rd05() end
        if swi_cl.value == 12 and mgroup.value == 6 then mgr_rd06() end
        if swi_cl.value == 12 and mgroup.value == 7 then mgr_rd07() end
        if swi_cl.value == 12 and mgroup.value == 8 then mgr_rd08() end
        -- Sky Blue sk
        if swi_cl.value == 13 and mgroup.value == 1 then mgr_sk01() end
        if swi_cl.value == 13 and mgroup.value == 2 then mgr_sk02() end
        if swi_cl.value == 13 and mgroup.value == 3 then mgr_sk03() end
        if swi_cl.value == 13 and mgroup.value == 4 then mgr_sk04() end
        if swi_cl.value == 13 and mgroup.value == 5 then mgr_sk05() end
        if swi_cl.value == 13 and mgroup.value == 6 then mgr_sk06() end
        if swi_cl.value == 13 and mgroup.value == 7 then mgr_sk07() end
        if swi_cl.value == 13 and mgroup.value == 8 then mgr_sk08() end
        -- Violet vl
        if swi_cl.value == 14 and mgroup.value == 1 then mgr_vl01() end
        if swi_cl.value == 14 and mgroup.value == 2 then mgr_vl02() end
        if swi_cl.value == 14 and mgroup.value == 3 then mgr_vl03() end
        if swi_cl.value == 14 and mgroup.value == 4 then mgr_vl04() end
        if swi_cl.value == 14 and mgroup.value == 5 then mgr_vl05() end
        if swi_cl.value == 14 and mgroup.value == 6 then mgr_vl06() end
        if swi_cl.value == 14 and mgroup.value == 7 then mgr_vl07() end
        if swi_cl.value == 14 and mgroup.value == 8 then mgr_vl08() end
        -- White wh
        if swi_cl.value == 15 and mgroup.value == 1 then mgr_wh01() end
        if swi_cl.value == 15 and mgroup.value == 2 then mgr_wh02() end
        if swi_cl.value == 15 and mgroup.value == 3 then mgr_wh03() end
        if swi_cl.value == 15 and mgroup.value == 4 then mgr_wh04() end
        if swi_cl.value == 15 and mgroup.value == 5 then mgr_wh05() end
        if swi_cl.value == 15 and mgroup.value == 6 then mgr_wh06() end
        if swi_cl.value == 15 and mgroup.value == 7 then mgr_wh07() end
        if swi_cl.value == 15 and mgroup.value == 8 then mgr_wh08() end
        -- Yellow yl
        if swi_cl.value == 16 and mgroup.value == 1 then mgr_yl01() end
        if swi_cl.value == 16 and mgroup.value == 2 then mgr_yl02() end
        if swi_cl.value == 16 and mgroup.value == 3 then mgr_yl03() end
        if swi_cl.value == 16 and mgroup.value == 4 then mgr_yl04() end
        if swi_cl.value == 16 and mgroup.value == 5 then mgr_yl05() end
        if swi_cl.value == 16 and mgroup.value == 6 then mgr_yl06() end
        if swi_cl.value == 16 and mgroup.value == 7 then mgr_yl07() end
        if swi_cl.value == 16 and mgroup.value == 8 then mgr_yl08() end
        -- ANY an
        if swi_cl.value == 17 and mgroup.value == 1 then mgr_an01() end
        if swi_cl.value == 17 and mgroup.value == 2 then mgr_an02() end
        if swi_cl.value == 17 and mgroup.value == 3 then mgr_an03() end
        if swi_cl.value == 17 and mgroup.value == 4 then mgr_an04() end
        if swi_cl.value == 17 and mgroup.value == 5 then mgr_an05() end
        if swi_cl.value == 17 and mgroup.value == 6 then mgr_an06() end
        if swi_cl.value == 17 and mgroup.value == 7 then mgr_an07() end
        if swi_cl.value == 17 and mgroup.value == 8 then mgr_an08() end
    end

    if res == 'Undo' then all_colors()
    end

end




  -- ========================================= Groups =========================================

function groups_colors()
  local vb = renoise.ViewBuilder()

  local but_aq = vb:button   { active = false , width = 42 , height = 30 , color = { 0x1A,0x9A,0x8D } , tooltip = 'Aqua Color' }      --01 Aqua aq
  local but_bk = vb:button   { active = false , width = 41 , height = 30 , color = { 0x24,0x24,0x24 } , tooltip = 'Black Color' }     --02 Black bk
  local but_bl = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0x44,0xFF } , tooltip = 'Blue Color' }      --03 Blue bl
  local but_br = vb:button   { active = false , width = 41 , height = 30 , color = { 0x99,0x4D,0x00 } , tooltip = 'Brown Color' }     --04 Brown br
  local but_gl = vb:button   { active = false , width = 41 , height = 30 , color = { 0xEF,0xA5,0x13 } , tooltip = 'Gold Color' }      --05 Gold gl
  local but_gy = vb:button   { active = false , width = 41 , height = 30 , color = { 0x70,0x70,0x70 } , tooltip = 'Gray Color' }      --06 Gray gy
  local but_gr = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0x99,0x19 } , tooltip = 'Green Color' }     --07 Green gr
  local but_or = vb:button   { active = false , width = 41 , height = 30 , color = { 0xEE,0x70,0x00 } , tooltip = 'Orange Color' }    --08 Orange or
  local but_pl = vb:button   { active = false , width = 41 , height = 30 , color = { 0xE4,0xB1,0xC9 } , tooltip = 'Pale Pink Color' } --09 Pale Pink pl
  local but_pn = vb:button   { active = false , width = 41 , height = 30 , color = { 0xE0,0x00,0x90 } , tooltip = 'Pink Color' }      --10 Pink pn
  local but_ps = vb:button   { active = false , width = 41 , height = 30 , color = { 0x70,0xEF,0x85 } , tooltip = 'Pistachio Color' } --11 Pistachio ps
  local but_rd = vb:button   { active = false , width = 41 , height = 30 , color = { 0xCC,0x00,0x00 } , tooltip = 'Red Color' }       --12 Red rd
  local but_sk = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0xDD,0xEE } , tooltip = 'Sky Blue Color' }  --13 Sky Blue sk
  local but_vl = vb:button   { active = false , width = 41 , height = 30 , color = { 0x81,0x00,0xEB } , tooltip = 'Violet Color' }    --14 Violet vl
  local but_wh = vb:button   { active = false , width = 41 , height = 30 , color = { 0xF1,0xF1,0xF1 } , tooltip = 'White Color' }     --15 White wh
  local but_yl = vb:button   { active = false , width = 43 , height = 30 , color = { 0xD1,0xD1,0x00 } , tooltip = 'Yellow Color' }    --16 Yellow yl

  local swi_cl = vb:switch   { items = { 'Aq' , 'Bk' , 'Bl' , 'Br' , 'Gl' , 'Gy' , 'Gr' , 'Or' , 'Pl' , 'Pn' , 'Ps' , 'Rd' , 'Sk' , 'Vl' , 'Wh' , 'Yl' } , width = 660 , height = 20 , value = 1 }
  local group  = vb:popup    { width = 354 , height = 24 , value = 2, items = {
                                                                        '1 Group [1 Aux Track]' ,
                                                                        '2 Groups [2 SubGroups x 2 Tracks]' ,
                                                                        '2 Groups [2 SubGroups x 3 Tracks]' ,
                                                                        '2 Groups [2 SubGroups x 4 Tracks]' ,
                                                                        '2 Groups [2 SubGroups x 5 Tracks]' ,
                                                                        '2 Groups [2 SubGroups x 6 Tracks]' ,
                                                                        '2 Groups [2 SubGroups x 7 Tracks]' ,
                                                                        '2 Groups [2 SubGroups x 8 Tracks]' ,
                                                                        '2 Groups [4 SubGroups x 2 Tracks]' ,
                                                                      }
                             }
  local view =
  vb:vertical_aligner {
    margin = 10 ,
    spacing = 0 ,

    vb:horizontal_aligner {
    margin = 5 ,
    vb:text{text = '1.- Select Main Color :' , font = 'bold' } ,
    } ,
    vb:horizontal_aligner {
      swi_cl ,
    } ,
    vb:horizontal_aligner {
      but_aq , but_bk , but_bl , but_br , but_gl , but_gy , but_gr , but_or , but_pl , but_pn , but_ps , but_rd , but_sk , but_vl , but_wh , but_yl ,
    } ,
    vb:horizontal_aligner {
      margin = 20
    },
    vb:horizontal_aligner {
      margin = 5 ,
        vb:text{ text = '2.- Select Groups :' , font = 'bold' } ,
    } ,
    vb:vertical_aligner {      
      group ,
    }
  }

  local res = renoise.app():show_custom_prompt ( 'B: Insert Groups per Colors' , view , { 'Insert Gr' , 'Undo' , 'Cancel' } );

    if res == 'Insert Gr' then
        -- Aqua aq
        if swi_cl.value ==  1 and group.value == 1 then gr_aq01() end -- 1 Group
        if swi_cl.value ==  1 and group.value == 2 then gr_aq02() end -- 2 Groups [2 SubGroups x 2 Tracks]
        if swi_cl.value ==  1 and group.value == 3 then gr_aq03() end -- 2 Groups [2 SubGroups x 3 Tracks]
        if swi_cl.value ==  1 and group.value == 4 then gr_aq04() end -- 2 Groups [2 SubGroups x 4 Tracks]
        if swi_cl.value ==  1 and group.value == 5 then gr_aq05() end -- 2 Groups [2 SubGroups x 5 Tracks]
        if swi_cl.value ==  1 and group.value == 6 then gr_aq06() end -- 2 Groups [2 SubGroups x 6 Tracks]
        if swi_cl.value ==  1 and group.value == 7 then gr_aq07() end -- 2 Groups [2 SubGroups x 7 Tracks]
        if swi_cl.value ==  1 and group.value == 8 then gr_aq08() end -- 2 Groups [2 SubGroups x 8 Tracks]
        if swi_cl.value ==  1 and group.value == 9 then gr_aq09() end -- 2 Groups [4 SubGroups x 2 Tracks]
        -- Black bk  
        if swi_cl.value ==  2 and group.value == 1 then gr_bk01() end
        if swi_cl.value ==  2 and group.value == 2 then gr_bk02() end
        if swi_cl.value ==  2 and group.value == 3 then gr_bk03() end
        if swi_cl.value ==  2 and group.value == 4 then gr_bk04() end
        if swi_cl.value ==  2 and group.value == 5 then gr_bk05() end
        if swi_cl.value ==  2 and group.value == 6 then gr_bk06() end
        if swi_cl.value ==  2 and group.value == 7 then gr_bk07() end
        if swi_cl.value ==  2 and group.value == 8 then gr_bk08() end
        if swi_cl.value ==  2 and group.value == 9 then gr_bk09() end
        -- Blue bl
        if swi_cl.value ==  3 and group.value == 1 then gr_bl01() end
        if swi_cl.value ==  3 and group.value == 2 then gr_bl02() end
        if swi_cl.value ==  3 and group.value == 3 then gr_bl03() end
        if swi_cl.value ==  3 and group.value == 4 then gr_bl04() end
        if swi_cl.value ==  3 and group.value == 5 then gr_bl05() end
        if swi_cl.value ==  3 and group.value == 6 then gr_bl06() end
        if swi_cl.value ==  3 and group.value == 7 then gr_bl07() end
        if swi_cl.value ==  3 and group.value == 8 then gr_bl08() end
        if swi_cl.value ==  3 and group.value == 9 then gr_bl09() end
        -- Brown br
        if swi_cl.value ==  4 and group.value == 1 then gr_br01() end
        if swi_cl.value ==  4 and group.value == 2 then gr_br02() end
        if swi_cl.value ==  4 and group.value == 3 then gr_br03() end
        if swi_cl.value ==  4 and group.value == 4 then gr_br04() end
        if swi_cl.value ==  4 and group.value == 5 then gr_br05() end
        if swi_cl.value ==  4 and group.value == 6 then gr_br06() end
        if swi_cl.value ==  4 and group.value == 7 then gr_br07() end
        if swi_cl.value ==  4 and group.value == 8 then gr_br08() end
        if swi_cl.value ==  4 and group.value == 9 then gr_br09() end
        -- Gold gl
        if swi_cl.value ==  5 and group.value == 1 then gr_gl01() end
        if swi_cl.value ==  5 and group.value == 2 then gr_gl02() end
        if swi_cl.value ==  5 and group.value == 3 then gr_gl03() end
        if swi_cl.value ==  5 and group.value == 4 then gr_gl04() end
        if swi_cl.value ==  5 and group.value == 5 then gr_gl05() end
        if swi_cl.value ==  5 and group.value == 6 then gr_gl06() end
        if swi_cl.value ==  5 and group.value == 7 then gr_gl07() end
        if swi_cl.value ==  5 and group.value == 8 then gr_gl08() end
        if swi_cl.value ==  5 and group.value == 9 then gr_gl09() end
        -- Gray gy
        if swi_cl.value ==  6 and group.value == 1 then gr_gy01() end
        if swi_cl.value ==  6 and group.value == 2 then gr_gy02() end
        if swi_cl.value ==  6 and group.value == 3 then gr_gy03() end
        if swi_cl.value ==  6 and group.value == 4 then gr_gy04() end
        if swi_cl.value ==  6 and group.value == 5 then gr_gy05() end
        if swi_cl.value ==  6 and group.value == 6 then gr_gy06() end
        if swi_cl.value ==  6 and group.value == 7 then gr_gy07() end
        if swi_cl.value ==  6 and group.value == 8 then gr_gy08() end
        if swi_cl.value ==  6 and group.value == 9 then gr_gy09() end
        -- Green gr
        if swi_cl.value ==  7 and group.value == 1 then gr_gr01() end
        if swi_cl.value ==  7 and group.value == 2 then gr_gr02() end
        if swi_cl.value ==  7 and group.value == 3 then gr_gr03() end
        if swi_cl.value ==  7 and group.value == 4 then gr_gr04() end
        if swi_cl.value ==  7 and group.value == 5 then gr_gr05() end
        if swi_cl.value ==  7 and group.value == 6 then gr_gr06() end
        if swi_cl.value ==  7 and group.value == 7 then gr_gr07() end
        if swi_cl.value ==  7 and group.value == 8 then gr_gr08() end
        if swi_cl.value ==  7 and group.value == 9 then gr_gr09() end
        -- Orange or
        if swi_cl.value ==  8 and group.value == 1 then gr_or01() end
        if swi_cl.value ==  8 and group.value == 2 then gr_or02() end
        if swi_cl.value ==  8 and group.value == 3 then gr_or03() end
        if swi_cl.value ==  8 and group.value == 4 then gr_or04() end
        if swi_cl.value ==  8 and group.value == 5 then gr_or05() end
        if swi_cl.value ==  8 and group.value == 6 then gr_or06() end
        if swi_cl.value ==  8 and group.value == 7 then gr_or07() end
        if swi_cl.value ==  8 and group.value == 8 then gr_or08() end
        if swi_cl.value ==  8 and group.value == 9 then gr_or09() end
        -- Pale Pink pl
        if swi_cl.value ==  9 and group.value == 1 then gr_pl01() end
        if swi_cl.value ==  9 and group.value == 2 then gr_pl02() end
        if swi_cl.value ==  9 and group.value == 3 then gr_pl03() end
        if swi_cl.value ==  9 and group.value == 4 then gr_pl04() end
        if swi_cl.value ==  9 and group.value == 5 then gr_pl05() end
        if swi_cl.value ==  9 and group.value == 6 then gr_pl06() end
        if swi_cl.value ==  9 and group.value == 7 then gr_pl07() end
        if swi_cl.value ==  9 and group.value == 8 then gr_pl08() end
        if swi_cl.value ==  9 and group.value == 9 then gr_pl09() end
        -- Pink pn
        if swi_cl.value == 10 and group.value == 1 then gr_pn01() end
        if swi_cl.value == 10 and group.value == 2 then gr_pn02() end
        if swi_cl.value == 10 and group.value == 3 then gr_pn03() end
        if swi_cl.value == 10 and group.value == 4 then gr_pn04() end
        if swi_cl.value == 10 and group.value == 5 then gr_pn05() end
        if swi_cl.value == 10 and group.value == 6 then gr_pn06() end
        if swi_cl.value == 10 and group.value == 7 then gr_pn07() end
        if swi_cl.value == 10 and group.value == 8 then gr_pn08() end
        if swi_cl.value == 10 and group.value == 9 then gr_pn09() end
        -- Pistachio ps
        if swi_cl.value == 11 and group.value == 1 then gr_ps01() end
        if swi_cl.value == 11 and group.value == 2 then gr_ps02() end
        if swi_cl.value == 11 and group.value == 3 then gr_ps03() end
        if swi_cl.value == 11 and group.value == 4 then gr_ps04() end
        if swi_cl.value == 11 and group.value == 5 then gr_ps05() end
        if swi_cl.value == 11 and group.value == 6 then gr_ps06() end
        if swi_cl.value == 11 and group.value == 7 then gr_ps07() end
        if swi_cl.value == 11 and group.value == 8 then gr_ps08() end
        if swi_cl.value == 11 and group.value == 9 then gr_ps09() end
        -- Red rd
        if swi_cl.value == 12 and group.value == 1 then gr_rd01() end
        if swi_cl.value == 12 and group.value == 2 then gr_rd02() end
        if swi_cl.value == 12 and group.value == 3 then gr_rd03() end
        if swi_cl.value == 12 and group.value == 4 then gr_rd04() end
        if swi_cl.value == 12 and group.value == 5 then gr_rd05() end
        if swi_cl.value == 12 and group.value == 6 then gr_rd06() end
        if swi_cl.value == 12 and group.value == 7 then gr_rd07() end
        if swi_cl.value == 12 and group.value == 8 then gr_rd08() end
        if swi_cl.value == 12 and group.value == 9 then gr_rd09() end
        -- Sky Blue sk
        if swi_cl.value == 13 and group.value == 1 then gr_sk01() end
        if swi_cl.value == 13 and group.value == 2 then gr_sk02() end
        if swi_cl.value == 13 and group.value == 3 then gr_sk03() end
        if swi_cl.value == 13 and group.value == 4 then gr_sk04() end
        if swi_cl.value == 13 and group.value == 5 then gr_sk05() end
        if swi_cl.value == 13 and group.value == 6 then gr_sk06() end
        if swi_cl.value == 13 and group.value == 7 then gr_sk07() end
        if swi_cl.value == 13 and group.value == 8 then gr_sk08() end
        if swi_cl.value == 13 and group.value == 9 then gr_sk09() end
        -- Violet vl
        if swi_cl.value == 14 and group.value == 1 then gr_vl01() end
        if swi_cl.value == 14 and group.value == 2 then gr_vl02() end
        if swi_cl.value == 14 and group.value == 3 then gr_vl03() end
        if swi_cl.value == 14 and group.value == 4 then gr_vl04() end
        if swi_cl.value == 14 and group.value == 5 then gr_vl05() end
        if swi_cl.value == 14 and group.value == 6 then gr_vl06() end
        if swi_cl.value == 14 and group.value == 7 then gr_vl07() end
        if swi_cl.value == 14 and group.value == 8 then gr_vl08() end
        if swi_cl.value == 14 and group.value == 9 then gr_vl09() end
        -- White wh
        if swi_cl.value == 15 and group.value == 1 then gr_wh01() end
        if swi_cl.value == 15 and group.value == 2 then gr_wh02() end
        if swi_cl.value == 15 and group.value == 3 then gr_wh03() end
        if swi_cl.value == 15 and group.value == 4 then gr_wh04() end
        if swi_cl.value == 15 and group.value == 5 then gr_wh05() end
        if swi_cl.value == 15 and group.value == 6 then gr_wh06() end
        if swi_cl.value == 15 and group.value == 7 then gr_wh07() end
        if swi_cl.value == 15 and group.value == 8 then gr_wh08() end
        if swi_cl.value == 15 and group.value == 9 then gr_wh09() end
        -- Yellow yl
        if swi_cl.value == 16 and group.value == 1 then gr_yl01() end
        if swi_cl.value == 16 and group.value == 2 then gr_yl02() end
        if swi_cl.value == 16 and group.value == 3 then gr_yl03() end
        if swi_cl.value == 16 and group.value == 4 then gr_yl04() end
        if swi_cl.value == 16 and group.value == 5 then gr_yl05() end
        if swi_cl.value == 16 and group.value == 6 then gr_yl06() end
        if swi_cl.value == 16 and group.value == 7 then gr_yl07() end
        if swi_cl.value == 16 and group.value == 8 then gr_yl08() end
        if swi_cl.value == 16 and group.value == 9 then gr_yl09() end
        -- ANY an
        if swi_cl.value == 17 and group.value == 1 then gr_an01() end
        if swi_cl.value == 17 and group.value == 2 then gr_an02() end
        if swi_cl.value == 17 and group.value == 3 then gr_an03() end
        if swi_cl.value == 17 and group.value == 4 then gr_an04() end
        if swi_cl.value == 17 and group.value == 5 then gr_an05() end
        if swi_cl.value == 17 and group.value == 6 then gr_an06() end
        if swi_cl.value == 17 and group.value == 7 then gr_an07() end
        if swi_cl.value == 17 and group.value == 8 then gr_an08() end
        if swi_cl.value == 17 and group.value == 9 then gr_an09() end
    end

    if res == 'Undo' then all_colors()
    end

end




  -- ========================================= SubGroups =========================================

function subgroups_colors()
  local vb = renoise.ViewBuilder()

  local but_aq = vb:button   { active = false , width = 42 , height = 30 , color = { 0x1A,0x9A,0x8D } , tooltip = 'Aqua Color' }      --01 Aqua aq
  local but_bk = vb:button   { active = false , width = 41 , height = 30 , color = { 0x24,0x24,0x24 } , tooltip = 'Black Color' }     --02 Black bk
  local but_bl = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0x44,0xFF } , tooltip = 'Blue Color' }      --03 Blue bl
  local but_br = vb:button   { active = false , width = 41 , height = 30 , color = { 0x99,0x4D,0x00 } , tooltip = 'Brown Color' }     --04 Brown br
  local but_gl = vb:button   { active = false , width = 41 , height = 30 , color = { 0xEF,0xA5,0x13 } , tooltip = 'Gold Color' }      --05 Gold gl
  local but_gy = vb:button   { active = false , width = 41 , height = 30 , color = { 0x70,0x70,0x70 } , tooltip = 'Gray Color' }      --06 Gray gy
  local but_gr = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0x99,0x19 } , tooltip = 'Green Color' }     --07 Green gr
  local but_or = vb:button   { active = false , width = 41 , height = 30 , color = { 0xEE,0x70,0x00 } , tooltip = 'Orange Color' }    --08 Orange or
  local but_pl = vb:button   { active = false , width = 41 , height = 30 , color = { 0xE4,0xB1,0xC9 } , tooltip = 'Pale Pink Color' } --09 Pale Pink pl
  local but_pn = vb:button   { active = false , width = 41 , height = 30 , color = { 0xE0,0x00,0x90 } , tooltip = 'Pink Color' }      --10 Pink pn
  local but_ps = vb:button   { active = false , width = 41 , height = 30 , color = { 0x70,0xEF,0x85 } , tooltip = 'Pistachio Color' } --11 Pistachio ps
  local but_rd = vb:button   { active = false , width = 41 , height = 30 , color = { 0xCC,0x00,0x00 } , tooltip = 'Red Color' }       --12 Red rd
  local but_sk = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0xDD,0xEE } , tooltip = 'Sky Blue Color' }  --13 Sky Blue sk
  local but_vl = vb:button   { active = false , width = 41 , height = 30 , color = { 0x81,0x00,0xEB } , tooltip = 'Violet Color' }    --14 Violet vl
  local but_wh = vb:button   { active = false , width = 41 , height = 30 , color = { 0xF1,0xF1,0xF1 } , tooltip = 'White Color' }     --15 White wh
  local but_yl = vb:button   { active = false , width = 43 , height = 30 , color = { 0xD1,0xD1,0x00 } , tooltip = 'Yellow Color' }    --16 Yellow yl

  local swi_cl = vb:switch   { items = { 'Aq' , 'Bk' , 'Bl' , 'Br' , 'Gl' , 'Gy' , 'Gr' , 'Or' , 'Pl' , 'pn' , 'Ps' , 'Rd' , 'Sk' , 'Vl' , 'Wh' , 'Yl' } , width = 660 , height = 20 , value = 1 }
  local sgroup = vb:popup    { width = 354 , height = 24 , value = 1, items = {
                                                                        '[4 SubGroups x 2 Tracks]' ,
                                                                        '[4 SubGroups x 3 Tracks]' ,
                                                                        '[4 SubGroups x 4 Tracks]' ,
                                                                        '[4 SubGroups x 5 Tracks]' ,
                                                                        '[4 SubGroups x 6 Tracks]' ,
                                                                        '[4 SubGroups x 7 Tracks]' ,
                                                                        '[4 SubGroups x 8 Tracks]' ,
                                                                        '[2 SubGroups x 6 Tracks]' ,
                                                                        '[2 SubGroups x 8 Tracks]'
                                                                      }
                             }
  local view =
  vb:vertical_aligner {
    margin = 10 ,
    spacing = 0 ,

    vb:horizontal_aligner {
    margin = 5 ,
    vb:text{text = '1.- Select Main Color :' , font = 'bold' } ,
    } ,
    vb:horizontal_aligner {
      swi_cl ,
    } ,
    vb:horizontal_aligner {
      but_aq , but_bk , but_bl , but_br , but_gl , but_gy , but_gr , but_or , but_pl , but_pn , but_ps , but_rd , but_sk , but_vl , but_wh , but_yl ,
    } ,
    vb:horizontal_aligner {
      margin = 20
    },
    vb:horizontal_aligner {
      margin = 5 ,
        vb:text{ text = '2.- Select SubGroups :' , font = 'bold' } ,
    } ,
    vb:vertical_aligner {      
      sgroup ,
    }
  }

  local res = renoise.app():show_custom_prompt  ( 'C: Insert SubGroups per Colors' , view , { 'Insert SGr' , 'Undo' , 'Cancel' } );
    if res == 'Insert SGr' then
        -- Aqua aq
        if swi_cl.value ==  1 and sgroup.value == 1 then sgr_aq01() end -- [4 SubGroups x 2 Tracks]
        if swi_cl.value ==  1 and sgroup.value == 2 then sgr_aq02() end -- [4 SubGroups x 3 Tracks]
        if swi_cl.value ==  1 and sgroup.value == 3 then sgr_aq03() end -- [4 SubGroups x 4 Tracks]
        if swi_cl.value ==  1 and sgroup.value == 4 then sgr_aq04() end -- [4 SubGroups x 5 Tracks]
        if swi_cl.value ==  1 and sgroup.value == 5 then sgr_aq05() end -- [4 SubGroups x 6 Tracks]
        if swi_cl.value ==  1 and sgroup.value == 6 then sgr_aq06() end -- [4 SubGroups x 7 Tracks]
        if swi_cl.value ==  1 and sgroup.value == 7 then sgr_aq07() end -- [4 SubGroups x 8 Tracks]
        if swi_cl.value ==  1 and sgroup.value == 8 then sgr_aq08() end -- [2 SubGroups x 6 Tracks]
        if swi_cl.value ==  1 and sgroup.value == 9 then sgr_aq09() end -- [2 SubGroups x 8 Tracks]
        if swi_cl.value ==  1 and sgroup.value ==10 then sgr_aq10() end -- [1 SubGroups x 8 Tracks]
        -- Black bk
        if swi_cl.value ==  2 and sgroup.value == 1 then sgr_bk01() end
        if swi_cl.value ==  2 and sgroup.value == 2 then sgr_bk02() end
        if swi_cl.value ==  2 and sgroup.value == 3 then sgr_bk03() end
        if swi_cl.value ==  2 and smroup.value == 4 then sgr_bk04() end
        if swi_cl.value ==  2 and sgroup.value == 5 then sgr_bk05() end
        if swi_cl.value ==  2 and sgroup.value == 6 then sgr_bk06() end
        if swi_cl.value ==  2 and sgroup.value == 7 then sgr_bk07() end
        if swi_cl.value ==  2 and sgroup.value == 8 then sgr_bk08() end
        if swi_cl.value ==  2 and sgroup.value == 9 then sgr_bk09() end
        if swi_cl.value ==  2 and sgroup.value ==10 then sgr_bk10() end
        -- Blue bl
        if swi_cl.value ==  3 and sgroup.value == 1 then sgr_bl01() end
        if swi_cl.value ==  3 and sgroup.value == 2 then sgr_bl02() end
        if swi_cl.value ==  3 and sgroup.value == 3 then sgr_bl03() end
        if swi_cl.value ==  3 and sgroup.value == 4 then sgr_bl04() end
        if swi_cl.value ==  3 and sgroup.value == 5 then sgr_bl05() end
        if swi_cl.value ==  3 and sgroup.value == 6 then sgr_bl06() end
        if swi_cl.value ==  3 and sgroup.value == 7 then sgr_bl07() end
        if swi_cl.value ==  3 and sgroup.value == 8 then sgr_bl08() end
        if swi_cl.value ==  3 and sgroup.value == 9 then sgr_bl09() end
        if swi_cl.value ==  3 and sgroup.value ==10 then sgr_bl10() end
        -- Brown br
        if swi_cl.value ==  4 and sgroup.value == 1 then sgr_br01() end
        if swi_cl.value ==  4 and sgroup.value == 2 then sgr_br02() end
        if swi_cl.value ==  4 and sgroup.value == 3 then sgr_br03() end
        if swi_cl.value ==  4 and sgroup.value == 4 then sgr_br04() end
        if swi_cl.value ==  4 and sgroup.value == 5 then sgr_br05() end
        if swi_cl.value ==  4 and sgroup.value == 6 then sgr_br06() end
        if swi_cl.value ==  4 and sgroup.value == 7 then sgr_br07() end
        if swi_cl.value ==  4 and sgroup.value == 8 then sgr_br08() end
        if swi_cl.value ==  4 and sgroup.value == 9 then sgr_br09() end
        if swi_cl.value ==  4 and sgroup.value ==10 then sgr_br10() end
        -- Gold gl
        if swi_cl.value ==  5 and sgroup.value == 1 then sgr_gl01() end
        if swi_cl.value ==  5 and sgroup.value == 2 then sgr_gl02() end
        if swi_cl.value ==  5 and sgroup.value == 3 then sgr_gl03() end
        if swi_cl.value ==  5 and sgroup.value == 4 then sgr_gl04() end
        if swi_cl.value ==  5 and sgroup.value == 5 then sgr_gl05() end
        if swi_cl.value ==  5 and sgroup.value == 6 then sgr_gl06() end
        if swi_cl.value ==  5 and sgroup.value == 7 then sgr_gl07() end
        if swi_cl.value ==  5 and sgroup.value == 8 then sgr_gl08() end
        if swi_cl.value ==  5 and sgroup.value == 9 then sgr_gl09() end
        if swi_cl.value ==  5 and sgroup.value ==10 then sgr_gl10() end
        -- Gray gy
        if swi_cl.value ==  6 and sgroup.value == 1 then sgr_gy01() end
        if swi_cl.value ==  6 and sgroup.value == 2 then sgr_gy02() end
        if swi_cl.value ==  6 and sgroup.value == 3 then sgr_gy03() end
        if swi_cl.value ==  6 and sgroup.value == 4 then sgr_gy04() end
        if swi_cl.value ==  6 and sgroup.value == 5 then sgr_gy05() end
        if swi_cl.value ==  6 and sgroup.value == 6 then sgr_gy06() end
        if swi_cl.value ==  6 and sgroup.value == 7 then sgr_gy07() end
        if swi_cl.value ==  6 and sgroup.value == 8 then sgr_gy08() end
        if swi_cl.value ==  6 and sgroup.value == 9 then sgr_gy09() end
        if swi_cl.value ==  6 and sgroup.value ==10 then sgr_gy10() end
        -- Green gr
        if swi_cl.value ==  7 and sgroup.value == 1 then sgr_gr01() end
        if swi_cl.value ==  7 and sgroup.value == 2 then sgr_gr02() end
        if swi_cl.value ==  7 and sgroup.value == 3 then sgr_gr03() end
        if swi_cl.value ==  7 and sgroup.value == 4 then sgr_gr04() end
        if swi_cl.value ==  7 and sgroup.value == 5 then sgr_gr05() end
        if swi_cl.value ==  7 and sgroup.value == 6 then sgr_gr06() end
        if swi_cl.value ==  7 and sgroup.value == 7 then sgr_gr07() end
        if swi_cl.value ==  7 and sgroup.value == 8 then sgr_gr08() end
        if swi_cl.value ==  7 and sgroup.value == 9 then sgr_gr09() end
        if swi_cl.value ==  7 and sgroup.value ==10 then sgr_gr10() end
        -- Orange or
        if swi_cl.value ==  8 and sgroup.value == 1 then sgr_or01() end
        if swi_cl.value ==  8 and sgroup.value == 2 then sgr_or02() end
        if swi_cl.value ==  8 and sgroup.value == 3 then sgr_or03() end
        if swi_cl.value ==  8 and sgroup.value == 4 then sgr_or04() end
        if swi_cl.value ==  8 and sgroup.value == 5 then sgr_or05() end
        if swi_cl.value ==  8 and sgroup.value == 6 then sgr_or06() end
        if swi_cl.value ==  8 and sgroup.value == 7 then sgr_or07() end
        if swi_cl.value ==  8 and sgroup.value == 8 then sgr_or08() end
        if swi_cl.value ==  8 and sgroup.value == 9 then sgr_or09() end
        if swi_cl.value ==  8 and sgroup.value ==10 then sgr_or10() end
        -- Pale Pink pl
        if swi_cl.value ==  9 and sgroup.value == 1 then sgr_pl01() end
        if swi_cl.value ==  9 and sgroup.value == 2 then sgr_pl02() end
        if swi_cl.value ==  9 and sgroup.value == 3 then sgr_pl03() end
        if swi_cl.value ==  9 and sgroup.value == 4 then sgr_pl04() end
        if swi_cl.value ==  9 and sgroup.value == 5 then sgr_pl05() end
        if swi_cl.value ==  9 and sgroup.value == 6 then sgr_pl06() end
        if swi_cl.value ==  9 and sgroup.value == 7 then sgr_pl07() end
        if swi_cl.value ==  9 and sgroup.value == 8 then sgr_pl08() end
        if swi_cl.value ==  9 and sgroup.value == 9 then sgr_pl09() end
        if swi_cl.value ==  9 and sgroup.value ==10 then sgr_pl10() end
        -- Pink pn
        if swi_cl.value == 10 and sgroup.value == 1 then sgr_pn01() end
        if swi_cl.value == 10 and sgroup.value == 2 then sgr_pn02() end
        if swi_cl.value == 10 and sgroup.value == 3 then sgr_pn03() end
        if swi_cl.value == 10 and sgroup.value == 4 then sgr_pn04() end
        if swi_cl.value == 10 and sgroup.value == 5 then sgr_pn05() end
        if swi_cl.value == 10 and sgroup.value == 6 then sgr_pn06() end
        if swi_cl.value == 10 and sgroup.value == 7 then sgr_pn07() end
        if swi_cl.value == 10 and sgroup.value == 8 then sgr_pn08() end
        if swi_cl.value == 10 and sgroup.value == 9 then sgr_pn09() end
        if swi_cl.value == 10 and sgroup.value ==10 then sgr_pn10() end
        -- Pistachio ps
        if swi_cl.value == 11 and sgroup.value == 1 then sgr_ps01() end
        if swi_cl.value == 11 and sgroup.value == 2 then sgr_ps02() end
        if swi_cl.value == 11 and sgroup.value == 3 then sgr_ps03() end
        if swi_cl.value == 11 and sgroup.value == 4 then sgr_ps04() end
        if swi_cl.value == 11 and sgroup.value == 5 then sgr_ps05() end
        if swi_cl.value == 11 and sgroup.value == 6 then sgr_ps06() end
        if swi_cl.value == 11 and sgroup.value == 7 then sgr_ps07() end
        if swi_cl.value == 11 and sgroup.value == 8 then sgr_ps08() end
        if swi_cl.value == 11 and sgroup.value == 9 then sgr_ps09() end
        if swi_cl.value == 11 and sgroup.value ==10 then sgr_ps10() end
        -- Red rd
        if swi_cl.value == 12 and sgroup.value == 1 then sgr_rd01() end
        if swi_cl.value == 12 and sgroup.value == 2 then sgr_rd02() end
        if swi_cl.value == 12 and sgroup.value == 3 then sgr_rd03() end
        if swi_cl.value == 12 and sgroup.value == 4 then sgr_rd04() end
        if swi_cl.value == 12 and sgroup.value == 5 then sgr_rd05() end
        if swi_cl.value == 12 and sgroup.value == 6 then sgr_rd06() end
        if swi_cl.value == 12 and sgroup.value == 7 then sgr_rd07() end
        if swi_cl.value == 12 and sgroup.value == 8 then sgr_rd08() end
        if swi_cl.value == 12 and sgroup.value == 9 then sgr_rd09() end
        if swi_cl.value == 12 and sgroup.value ==10 then sgr_rd10() end
        -- Sky Blue sk
        if swi_cl.value == 13 and sgroup.value == 1 then sgr_sk01() end
        if swi_cl.value == 13 and sgroup.value == 2 then sgr_sk02() end
        if swi_cl.value == 13 and sgroup.value == 3 then sgr_sk03() end
        if swi_cl.value == 13 and sgroup.value == 4 then sgr_sk04() end
        if swi_cl.value == 13 and sgroup.value == 5 then sgr_sk05() end
        if swi_cl.value == 13 and sgroup.value == 6 then sgr_sk06() end
        if swi_cl.value == 13 and sgroup.value == 7 then sgr_sk07() end
        if swi_cl.value == 13 and sgroup.value == 8 then sgr_sk08() end
        if swi_cl.value == 13 and sgroup.value == 9 then sgr_sk09() end
        if swi_cl.value == 13 and sgroup.value ==10 then sgr_sk10() end
        -- Violet vl
        if swi_cl.value == 14 and sgroup.value == 1 then sgr_vl01() end
        if swi_cl.value == 14 and sgroup.value == 2 then sgr_vl02() end
        if swi_cl.value == 14 and sgroup.value == 3 then sgr_vl03() end
        if swi_cl.value == 14 and sgroup.value == 4 then sgr_vl04() end
        if swi_cl.value == 14 and sgroup.value == 5 then sgr_vl05() end
        if swi_cl.value == 14 and sgroup.value == 6 then sgr_vl06() end
        if swi_cl.value == 14 and sgroup.value == 7 then sgr_vl07() end
        if swi_cl.value == 14 and sgroup.value == 8 then sgr_vl08() end
        if swi_cl.value == 14 and sgroup.value == 9 then sgr_vl09() end
        if swi_cl.value == 14 and sgroup.value ==10 then sgr_vl10() end
        -- White wh
        if swi_cl.value == 15 and sgroup.value == 1 then sgr_wh01() end
        if swi_cl.value == 15 and sgroup.value == 2 then sgr_wh02() end
        if swi_cl.value == 15 and sgroup.value == 3 then sgr_wh03() end
        if swi_cl.value == 15 and sgroup.value == 4 then sgr_wh04() end
        if swi_cl.value == 15 and sgroup.value == 5 then sgr_wh05() end
        if swi_cl.value == 15 and sgroup.value == 6 then sgr_wh06() end
        if swi_cl.value == 15 and sgroup.value == 7 then sgr_wh07() end
        if swi_cl.value == 15 and sgroup.value == 8 then sgr_wh08() end
        if swi_cl.value == 15 and sgroup.value == 9 then sgr_wh09() end
        if swi_cl.value == 15 and sgroup.value ==10 then sgr_wh10() end
        -- Yellow yl
        if swi_cl.value == 16 and sgroup.value == 1 then sgr_yl01() end
        if swi_cl.value == 16 and sgroup.value == 2 then sgr_yl02() end
        if swi_cl.value == 16 and sgroup.value == 3 then sgr_yl03() end
        if swi_cl.value == 16 and sgroup.value == 4 then sgr_yl04() end
        if swi_cl.value == 16 and sgroup.value == 5 then sgr_yl05() end
        if swi_cl.value == 16 and sgroup.value == 6 then sgr_yl06() end
        if swi_cl.value == 16 and sgroup.value == 7 then sgr_yl07() end
        if swi_cl.value == 16 and sgroup.value == 8 then sgr_yl08() end
        if swi_cl.value == 16 and sgroup.value == 9 then sgr_yl09() end
        if swi_cl.value == 16 and sgroup.value ==10 then sgr_yl10() end
        -- ANY an
        if swi_cl.value == 17 and sgroup.value == 1 then sgr_an01() end
        if swi_cl.value == 17 and sgroup.value == 2 then sgr_an02() end
        if swi_cl.value == 17 and sgroup.value == 3 then sgr_an03() end
        if swi_cl.value == 17 and sgroup.value == 4 then sgr_an04() end
        if swi_cl.value == 17 and sgroup.value == 5 then sgr_an05() end
        if swi_cl.value == 17 and sgroup.value == 6 then sgr_an06() end
        if swi_cl.value == 17 and sgroup.value == 7 then sgr_an07() end
        if swi_cl.value == 17 and sgroup.value == 8 then sgr_an08() end
        if swi_cl.value == 17 and sgroup.value == 9 then sgr_an09() end
        if swi_cl.value == 17 and sgroup.value ==10 then sgr_an10() end
    end

    if res == 'Undo' then all_colors()
    end

end




  -- ========================================= Tracks =========================================

function tracks_colors()
  local vb = renoise.ViewBuilder()

  local but_aq = vb:button   { active = false , width = 42 , height = 30 , color = { 0x1A,0x9A,0x8D } , tooltip = 'Aqua Color' }      --01 Aqua aq
  local but_bk = vb:button   { active = false , width = 41 , height = 30 , color = { 0x24,0x24,0x24 } , tooltip = 'Black Color' }     --02 Black bk
  local but_bl = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0x44,0xFF } , tooltip = 'Blue Color' }      --03 Blue bl
  local but_br = vb:button   { active = false , width = 41 , height = 30 , color = { 0x99,0x4D,0x00 } , tooltip = 'Brown Color' }     --04 Brown br
  local but_gl = vb:button   { active = false , width = 41 , height = 30 , color = { 0xEF,0xA5,0x13 } , tooltip = 'Gold Color' }      --05 Gold gl
  local but_gy = vb:button   { active = false , width = 41 , height = 30 , color = { 0x70,0x70,0x70 } , tooltip = 'Gray Color' }      --06 Gray gy
  local but_gr = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0x99,0x19 } , tooltip = 'Green Color' }     --07 Green gr
  local but_or = vb:button   { active = false , width = 41 , height = 30 , color = { 0xEE,0x70,0x00 } , tooltip = 'Orange Color' }    --08 Orange or
  local but_pl = vb:button   { active = false , width = 41 , height = 30 , color = { 0xE4,0xB1,0xC9 } , tooltip = 'Pale Pink Color' } --09 Pale Pink pl
  local but_pn = vb:button   { active = false , width = 41 , height = 30 , color = { 0xE0,0x00,0x90 } , tooltip = 'Pink Color' }      --10 Pink pn
  local but_ps = vb:button   { active = false , width = 41 , height = 30 , color = { 0x70,0xEF,0x85 } , tooltip = 'Pistachio Color' } --11 Pistachio ps
  local but_rd = vb:button   { active = false , width = 41 , height = 30 , color = { 0xCC,0x00,0x00 } , tooltip = 'Red Color' }       --12 Red rd
  local but_sk = vb:button   { active = false , width = 41 , height = 30 , color = { 0x00,0xDD,0xEE } , tooltip = 'Sky Blue Color' }  --13 Sky Blue sk
  local but_vl = vb:button   { active = false , width = 41 , height = 30 , color = { 0x81,0x00,0xEB } , tooltip = 'Violet Color' }    --14 Violet vl
  local but_wh = vb:button   { active = false , width = 41 , height = 30 , color = { 0xF1,0xF1,0xF1 } , tooltip = 'White Color' }     --15 White wh
  local but_yl = vb:button   { active = false , width = 43 , height = 30 , color = { 0xD1,0xD1,0x00 } , tooltip = 'Yellow Color' }    --16 Yellow yl

  local swi_cl = vb:switch   { items = { 'Aq' , 'Bk' , 'Bl' , 'Br' , 'Gl' , 'Gy' , 'Gr' , 'Or' , 'Pl' , 'Pn' , 'Ps' , 'Rd' , 'Sk' , 'Vl' , 'Wh' , 'Yl' } , width = 660 , height = 20 , value = 1 }
  local track  = vb:popup    { width = 354 , height = 24 , value = 3, items = {
                                                                        '1 Aux Track A (light)' ,
                                                                        '1 Aux Track B (dark)' ,
                                                                        '2 Tracks' ,
                                                                        '4 Tracks' ,
                                                                        '6 Tracks' ,
                                                                        '8 Tracks' ,
                                                                        '4 Tracks + 2 Aux Tracks' ,
                                                                        '8 Tracks + 2 Aux Tracks'
                                                                      }
                             }
  local view =
  vb:vertical_aligner {
    margin = 10 ,
    spacing = 0 ,

    vb:horizontal_aligner {
    margin = 5 ,
    vb:text{text = '1.- Select Main Color :' , font = 'bold' } ,
    } ,
    vb:horizontal_aligner {
      swi_cl ,
    } ,
    vb:horizontal_aligner {
      but_aq , but_bk , but_bl , but_br , but_gl , but_gy , but_gr , but_or , but_pl , but_pn , but_ps , but_rd , but_sk , but_vl , but_wh , but_yl ,
    } ,
    vb:horizontal_aligner {
      margin = 20
    },
    vb:horizontal_aligner {
      margin = 5 ,
        vb:text{ text = '2.- Select Tracks :' , font = 'bold' } ,
    } ,
    vb:vertical_aligner {      
      track ,
    }
  }

  local res = renoise.app():show_custom_prompt ( 'D: Insert Tracks per Colors' , view , { 'Insert Tr' , 'Undo' , 'Cancel' } );
    if res == 'Insert Tr' then
        -- Aqua aq
        if swi_cl.value ==  1 and track.value == 1 then tr_aqa1() end -- 1 Aux Track A
        if swi_cl.value ==  1 and track.value == 2 then tr_aqb1() end -- 1 Aux Track B
        if swi_cl.value ==  1 and track.value == 3 then tr_aq02() end -- 2 Tracks
        if swi_cl.value ==  1 and track.value == 4 then tr_aq03() end -- 4 Tracks
        if swi_cl.value ==  1 and track.value == 5 then tr_aq04() end -- 6 Tracks
        if swi_cl.value ==  1 and track.value == 6 then tr_aq05() end -- 8 Tracks
        if swi_cl.value ==  1 and track.value == 7 then tr_aq06() end -- 4 Tracks + 2 Aux Tracks
        if swi_cl.value ==  1 and track.value == 8 then tr_aq07() end -- 8 Tracks + 2 Aux Tracks
        -- Black bk
        if swi_cl.value ==  2 and track.value == 1 then tr_bka1() end
        if swi_cl.value ==  2 and track.value == 2 then tr_bkb1() end
        if swi_cl.value ==  2 and track.value == 3 then tr_bk02() end
        if swi_cl.value ==  2 and track.value == 4 then tr_bk03() end
        if swi_cl.value ==  2 and track.value == 5 then tr_bk04() end
        if swi_cl.value ==  2 and track.value == 6 then tr_bk05() end
        if swi_cl.value ==  2 and track.value == 7 then tr_bk06() end
        if swi_cl.value ==  2 and track.value == 8 then tr_bk07() end
        -- Blue bl
        if swi_cl.value ==  3 and track.value == 1 then tr_bla1() end
        if swi_cl.value ==  3 and track.value == 2 then tr_blb1() end
        if swi_cl.value ==  3 and track.value == 3 then tr_bl02() end
        if swi_cl.value ==  3 and track.value == 4 then tr_bl03() end
        if swi_cl.value ==  3 and track.value == 5 then tr_bl04() end
        if swi_cl.value ==  3 and track.value == 6 then tr_bl05() end
        if swi_cl.value ==  3 and track.value == 7 then tr_bl06() end
        if swi_cl.value ==  3 and track.value == 8 then tr_bl07() end
        -- Brown br
        if swi_cl.value ==  4 and track.value == 1 then tr_bra1() end
        if swi_cl.value ==  4 and track.value == 2 then tr_brb1() end
        if swi_cl.value ==  4 and track.value == 3 then tr_br02() end
        if swi_cl.value ==  4 and track.value == 4 then tr_br03() end
        if swi_cl.value ==  4 and track.value == 5 then tr_br04() end
        if swi_cl.value ==  4 and track.value == 6 then tr_br05() end
        if swi_cl.value ==  4 and track.value == 7 then tr_br06() end
        if swi_cl.value ==  4 and track.value == 8 then tr_br07() end
        -- Gold gl
        if swi_cl.value ==  5 and track.value == 1 then tr_gla1() end
        if swi_cl.value ==  5 and track.value == 2 then tr_glb1() end
        if swi_cl.value ==  5 and track.value == 3 then tr_gl02() end
        if swi_cl.value ==  5 and track.value == 4 then tr_gl03() end
        if swi_cl.value ==  5 and track.value == 5 then tr_gl04() end
        if swi_cl.value ==  5 and track.value == 6 then tr_gl05() end
        if swi_cl.value ==  5 and track.value == 7 then tr_gl06() end
        if swi_cl.value ==  5 and track.value == 8 then tr_gl07() end
        -- Gray gy
        if swi_cl.value ==  6 and track.value == 1 then tr_gya1() end
        if swi_cl.value ==  6 and track.value == 2 then tr_gyb1() end
        if swi_cl.value ==  6 and track.value == 3 then tr_gy02() end
        if swi_cl.value ==  6 and track.value == 4 then tr_gy03() end
        if swi_cl.value ==  6 and track.value == 5 then tr_gy04() end
        if swi_cl.value ==  6 and track.value == 6 then tr_gy05() end
        if swi_cl.value ==  6 and track.value == 7 then tr_gy06() end
        if swi_cl.value ==  6 and track.value == 8 then tr_gy07() end
        -- Green gr
        if swi_cl.value ==  7 and track.value == 1 then tr_gra1() end
        if swi_cl.value ==  7 and track.value == 2 then tr_grb1() end
        if swi_cl.value ==  7 and track.value == 3 then tr_gr02() end
        if swi_cl.value ==  7 and track.value == 4 then tr_gr03() end
        if swi_cl.value ==  7 and track.value == 5 then tr_gr04() end
        if swi_cl.value ==  7 and track.value == 6 then tr_gr05() end
        if swi_cl.value ==  7 and track.value == 7 then tr_gr06() end
        if swi_cl.value ==  7 and track.value == 8 then tr_gr07() end
        -- Orange or
        if swi_cl.value ==  8 and track.value == 1 then tr_ora1() end
        if swi_cl.value ==  8 and track.value == 2 then tr_orb1() end
        if swi_cl.value ==  8 and track.value == 3 then tr_or02() end
        if swi_cl.value ==  8 and track.value == 4 then tr_or03() end
        if swi_cl.value ==  8 and track.value == 5 then tr_or04() end
        if swi_cl.value ==  8 and track.value == 6 then tr_or05() end
        if swi_cl.value ==  8 and track.value == 7 then tr_or06() end
        if swi_cl.value ==  8 and track.value == 8 then tr_or07() end
        -- Pale Pink pl
        if swi_cl.value ==  9 and track.value == 1 then tr_pla1() end
        if swi_cl.value ==  9 and track.value == 2 then tr_plb1() end
        if swi_cl.value ==  9 and track.value == 3 then tr_pl02() end
        if swi_cl.value ==  9 and track.value == 4 then tr_pl03() end
        if swi_cl.value ==  9 and track.value == 5 then tr_pl04() end
        if swi_cl.value ==  9 and track.value == 6 then tr_pl05() end
        if swi_cl.value ==  9 and track.value == 7 then tr_pl06() end
        if swi_cl.value ==  9 and track.value == 8 then tr_pl07() end
        -- Pink pn
        if swi_cl.value == 10 and track.value == 1 then tr_pna1() end
        if swi_cl.value == 10 and track.value == 2 then tr_pnb1() end
        if swi_cl.value == 10 and track.value == 3 then tr_pn02() end
        if swi_cl.value == 10 and track.value == 4 then tr_pn03() end
        if swi_cl.value == 10 and track.value == 5 then tr_pn04() end
        if swi_cl.value == 10 and track.value == 6 then tr_pn05() end
        if swi_cl.value == 10 and track.value == 7 then tr_pn06() end
        if swi_cl.value == 10 and track.value == 8 then tr_pn07() end
        -- Pistachio ps
        if swi_cl.value == 11 and track.value == 1 then tr_psa1() end
        if swi_cl.value == 11 and track.value == 2 then tr_psb1() end
        if swi_cl.value == 11 and track.value == 3 then tr_ps02() end
        if swi_cl.value == 11 and track.value == 4 then tr_ps03() end
        if swi_cl.value == 11 and track.value == 5 then tr_ps04() end
        if swi_cl.value == 11 and track.value == 6 then tr_ps05() end
        if swi_cl.value == 11 and track.value == 7 then tr_ps06() end
        if swi_cl.value == 11 and track.value == 8 then tr_ps07() end
        -- Red rd
        if swi_cl.value == 12 and track.value == 1 then tr_rda1() end
        if swi_cl.value == 12 and track.value == 2 then tr_rdb1() end
        if swi_cl.value == 12 and track.value == 3 then tr_rd02() end
        if swi_cl.value == 12 and track.value == 4 then tr_rd03() end
        if swi_cl.value == 12 and track.value == 5 then tr_rd04() end
        if swi_cl.value == 12 and track.value == 6 then tr_rd05() end
        if swi_cl.value == 12 and track.value == 7 then tr_rd06() end
        if swi_cl.value == 12 and track.value == 8 then tr_rd07() end
        -- Sky Blue sk
        if swi_cl.value == 13 and track.value == 1 then tr_ska1() end
        if swi_cl.value == 13 and track.value == 2 then tr_skb1() end
        if swi_cl.value == 13 and track.value == 3 then tr_sk02() end
        if swi_cl.value == 13 and track.value == 4 then tr_sk03() end
        if swi_cl.value == 13 and track.value == 5 then tr_sk04() end
        if swi_cl.value == 13 and track.value == 6 then tr_sk05() end
        if swi_cl.value == 13 and track.value == 7 then tr_sk06() end
        if swi_cl.value == 13 and track.value == 8 then tr_sk07() end
        -- Violet vl
        if swi_cl.value == 14 and track.value == 1 then tr_vla1() end
        if swi_cl.value == 14 and track.value == 2 then tr_vlb1() end
        if swi_cl.value == 14 and track.value == 3 then tr_vl02() end
        if swi_cl.value == 14 and track.value == 4 then tr_vl03() end
        if swi_cl.value == 14 and track.value == 5 then tr_vl04() end
        if swi_cl.value == 14 and track.value == 6 then tr_vl05() end
        if swi_cl.value == 14 and track.value == 7 then tr_vl06() end
        if swi_cl.value == 14 and track.value == 8 then tr_vl07() end
        -- White wh
        if swi_cl.value == 15 and track.value == 1 then tr_wha1() end
        if swi_cl.value == 15 and track.value == 2 then tr_whb1() end
        if swi_cl.value == 15 and track.value == 3 then tr_wh02() end
        if swi_cl.value == 15 and track.value == 4 then tr_wh03() end
        if swi_cl.value == 15 and track.value == 5 then tr_wh04() end
        if swi_cl.value == 15 and track.value == 6 then tr_wh05() end
        if swi_cl.value == 15 and track.value == 7 then tr_wh06() end
        if swi_cl.value == 15 and track.value == 8 then tr_wh07() end
        -- Yellow yl
        if swi_cl.value == 16 and track.value == 1 then tr_yla1() end
        if swi_cl.value == 16 and track.value == 2 then tr_ylb1() end
        if swi_cl.value == 16 and track.value == 3 then tr_yl02() end
        if swi_cl.value == 16 and track.value == 4 then tr_yl03() end
        if swi_cl.value == 16 and track.value == 5 then tr_yl04() end
        if swi_cl.value == 16 and track.value == 6 then tr_yl05() end
        if swi_cl.value == 16 and track.value == 7 then tr_yl06() end
        if swi_cl.value == 16 and track.value == 8 then tr_yl07() end
        -- ANY an
        if swi_cl.value == 17 and track.value == 1 then tr_ana1() end
        if swi_cl.value == 17 and track.value == 2 then tr_anb1() end
        if swi_cl.value == 17 and track.value == 3 then tr_an02() end
        if swi_cl.value == 17 and track.value == 4 then tr_an03() end
        if swi_cl.value == 17 and track.value == 5 then tr_an04() end
        if swi_cl.value == 17 and track.value == 6 then tr_an05() end
        if swi_cl.value == 17 and track.value == 7 then tr_an06() end
        if swi_cl.value == 17 and track.value == 8 then tr_an07() end
    end

    if res == 'Undo' then all_colors()
    end

end



  -- ========================================= Combined =========================================

function main_groups_combined()
  local vb = renoise.ViewBuilder()
  
    --local xxx_xx = vb:checkbox { }
    --local yyy_yy = vb:valuebox { min = 0 , max = 8 , value = 0 }
  local but_aq = vb:button   { active = false , width = 10 , height = 30 , color = { 0x1A,0x9A,0x8D } , tooltip = 'Aqua Color' }      --  1 Aqua aq
  local but_bk = vb:button   { active = false , width = 10 , height = 30 , color = { 0x24,0x24,0x24 } , tooltip = 'Black Color' }     --  2 Black bk
  local but_bl = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0x44,0xFF } , tooltip = 'Blue Color' }      --  3 Blue bl
  local but_br = vb:button   { active = false , width = 10 , height = 30 , color = { 0x99,0x4D,0x00 } , tooltip = 'Brown Color' }     --  4 Brown br
  local but_gl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xEF,0xA5,0x13 } , tooltip = 'Gold Color' }      --  5 Gold gl
  local but_gy = vb:button   { active = false , width = 10 , height = 30 , color = { 0x70,0x70,0x70 } , tooltip = 'Gray Color' }      --  6 Gray gy
  local but_gr = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0x99,0x19 } , tooltip = 'Green Color' }     --  7 Green gr
  local but_or = vb:button   { active = false , width = 10 , height = 30 , color = { 0xEE,0x70,0x00 } , tooltip = 'Orange Color' }    --  8 Orange or
  local but_pl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xE4,0xB1,0xC9 } , tooltip = 'Pale Pink Color' } --  9 Pale Pink pl
  local but_pn = vb:button   { active = false , width = 10 , height = 30 , color = { 0xE0,0x00,0x90 } , tooltip = 'Pink Color' }      -- 10 Pink pn
  local but_ps = vb:button   { active = false , width = 10 , height = 30 , color = { 0x70,0xEF,0x85 } , tooltip = 'Pistachio Color' } -- 11 Pistachio ps
  local but_rd = vb:button   { active = false , width = 10 , height = 30 , color = { 0xCC,0x00,0x00 } , tooltip = 'Red Color' }       -- 12 Red rd
  local but_sk = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0xDD,0xEE } , tooltip = 'Sky Blue Color' }  -- 13 Sky Blue sk
  local but_vl = vb:button   { active = false , width = 10 , height = 30 , color = { 0x81,0x00,0xEB } , tooltip = 'Violet Color' }    -- 14 Violet vl
  local but_wh = vb:button   { active = false , width = 10 , height = 30 , color = { 0xF1,0xF1,0xF1 } , tooltip = 'White Color' }     -- 15 White wh
  local but_yl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xD1,0xD1,0x00 } , tooltip = 'Yellow Color' }    -- 16 Yellow yl

  --local swi_cl = vb:switch   { items = { 'Aq' , 'Bk' , 'Bl' , 'Br' , 'Gl' , 'Gy' , 'Gr' , 'Or' , 'Pl' , 'Pn' , 'Ps' , 'Rd' , 'Sk' , 'Vl' , 'Wh' , 'Yl' } , width = 660 , height = 20 , value = 1 }
  local mgrcom = vb:popup { width = 440 , height = 24, value = 1, items = {
                                                                     'Combined 2 Main Groups x 2 Groups [2 SubGroups x 2 Tracks]' ,
                                                                     'Combined 2 Main Groups x 2 Groups [2 SubGroups x 2 Tracks] x2' ,
                                                                     'Combined 2 Main Groups x 2 Groups [2 SubGroups x 4 Tracks]' ,
                                                                     'Combined 2 Main Groups x 2 Groups [2 SubGroups x 4 Tracks] x2' ,
                                                                     'Combined 2 Main Groups x 2 Groups [2 SubGroups x 6 Tracks]' ,
                                                                     'Combined 2 Main Groups x 2 Groups [2 SubGroups x 6 Tracks] x2 ...Heavy!!!' ,
                                                                     'Combined 2 Main Groups x 2 Groups [2 SubGroups x 8 Tracks]' ,
                                                                     'Combined A1.- 8 Main Groups x 2 Groups [2 SubGroups x 2 Tracks]' ,
                                                                     'Combined A2.- 8 Main Groups x 2 Groups [2 SubGroups x 4 Tracks] ...Heavy!!!' ,
                                                                     'Combined B1.- 8 Main Groups x 2 Groups [2 SubGroups x 2 Tracks]' ,
                                                                     'Combined B2.- 8 Main Groups x 2 Groups [2 SubGroups x 4 Tracks] ...Heavy!!!' ,
                                                                  }
                          }
  local view =
  vb:vertical_aligner {
    margin = 10 ,
    spacing = 0 ,
    vb:horizontal_aligner {
    mode = 'center' ,
    spacing = 0 ,    
      but_aq , but_bk , but_bl , but_br , but_gl , but_gy , but_gr , but_or , but_pl , but_pn , but_ps , but_rd , but_sk , but_vl , but_wh , but_yl ,
    } ,
    vb:horizontal_aligner {
      margin = 20
    },
    vb:horizontal_aligner {
      margin = 5 ,
        vb:text{ text = '1.- Select Main Group :' , font = 'bold' } ,
    } ,
    vb:vertical_aligner {
      mgrcom ,
    }
  }

  local res = renoise.app():show_custom_prompt ( 'E1: Insert Main Groups per Combined Colors' , view , { 'Insert MGr' , 'Undo' , 'Cancel' } );
    if res == 'Insert MGr' then

         if mgrcom.value == 1 then mgr_com01() end
         if mgrcom.value == 2 then mgr_com02() end
         if mgrcom.value == 3 then mgr_com03() end
         if mgrcom.value == 4 then mgr_com04() end
         if mgrcom.value == 5 then mgr_com05() end
         if mgrcom.value == 6 then mgr_com06() end
         if mgrcom.value == 7 then mgr_com07() end
         if mgrcom.value == 8 then mgr_com08() end
         if mgrcom.value == 9 then mgr_com09() end
         if mgrcom.value == 10 then mgr_com10() end
         if mgrcom.value == 11 then mgr_com11() end
    end

    if res == 'Undo' then combined_colors()
    end

end



function groups_combined()
  local vb = renoise.ViewBuilder()
  
    --local xxx_xx = vb:checkbox { }
    --local yyy_yy = vb:valuebox { min = 0 , max = 8 , value = 0 }
  local but_aq = vb:button   { active = false , width = 10 , height = 30 , color = { 0x1A,0x9A,0x8D } , tooltip = 'Aqua Color' }      --  1 Aqua aq
  local but_bk = vb:button   { active = false , width = 10 , height = 30 , color = { 0x24,0x24,0x24 } , tooltip = 'Black Color' }     --  2 Black bk
  local but_bl = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0x44,0xFF } , tooltip = 'Blue Color' }      --  3 Blue bl
  local but_br = vb:button   { active = false , width = 10 , height = 30 , color = { 0x99,0x4D,0x00 } , tooltip = 'Brown Color' }     --  4 Brown br
  local but_gl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xEF,0xA5,0x13 } , tooltip = 'Gold Color' }      --  5 Gold gl
  local but_gy = vb:button   { active = false , width = 10 , height = 30 , color = { 0x70,0x70,0x70 } , tooltip = 'Gray Color' }      --  6 Gray gy
  local but_gr = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0x99,0x19 } , tooltip = 'Green Color' }     --  7 Green gr
  local but_or = vb:button   { active = false , width = 10 , height = 30 , color = { 0xEE,0x70,0x00 } , tooltip = 'Orange Color' }    --  8 Orange or
  local but_pl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xE4,0xB1,0xC9 } , tooltip = 'Pale Pink Color' } --  9 Pale Pink pl
  local but_pn = vb:button   { active = false , width = 10 , height = 30 , color = { 0xE0,0x00,0x90 } , tooltip = 'Pink Color' }      -- 10 Pink pn
  local but_ps = vb:button   { active = false , width = 10 , height = 30 , color = { 0x70,0xEF,0x85 } , tooltip = 'Pistachio Color' } -- 11 Pistachio ps
  local but_rd = vb:button   { active = false , width = 10 , height = 30 , color = { 0xCC,0x00,0x00 } , tooltip = 'Red Color' }       -- 12 Red rd
  local but_sk = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0xDD,0xEE } , tooltip = 'Sky Blue Color' }  -- 13 Sky Blue sk
  local but_vl = vb:button   { active = false , width = 10 , height = 30 , color = { 0x81,0x00,0xEB } , tooltip = 'Violet Color' }    -- 14 Violet vl
  local but_wh = vb:button   { active = false , width = 10 , height = 30 , color = { 0xF1,0xF1,0xF1 } , tooltip = 'White Color' }     -- 15 White wh
  local but_yl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xD1,0xD1,0x00 } , tooltip = 'Yellow Color' }    -- 16 Yellow yl

  --local swi_cl = vb:switch   { items = { 'Aq' , 'Bk' , 'Bl' , 'Br' , 'Gl' , 'Gy' , 'Gr' , 'Or' , 'Pl' , 'Pn' , 'Ps' , 'Rd' , 'Sk' , 'Vl' , 'Wh' , 'Yl' } , width = 660 , height = 20 , value = 1 }
  local grcom = vb:popup { width = 440 , height = 24, value = 1, items = {
                                                                     'Combined 5 Groups [2 SubGroups x 2 Tracks]' ,
                                                                     'Combined 5 Groups [2 SubGroups x 2 Tracks] x2' ,
                                                                     'Combined 5 Groups [2 SubGroups x 4 Tracks]' ,
                                                                     'Combined 5 Groups [2 SubGroups x 4 Tracks] x2' ,
                                                                     'Combined 5 Groups [2 SubGroups x 6 Tracks]' ,
                                                                     'Combined 5 Groups [2 SubGroups x 6 Tracks] x2 ...Heavy!!!' ,
                                                                     'Combined 5 Groups [2 SubGroups x 8 Tracks]' ,
                                                                 }
                         }
  local view =
  vb:vertical_aligner {
    margin = 10 ,
    spacing = 0 ,
    vb:horizontal_aligner {
    mode = 'center' ,
    spacing = 0 ,    
      but_aq , but_bk , but_bl , but_br , but_gl , but_gy , but_gr , but_or , but_pl , but_pn , but_ps , but_rd , but_sk , but_vl , but_wh , but_yl ,
    } ,
    vb:horizontal_aligner {
      margin = 20
    },
    vb:horizontal_aligner {
      margin = 5 ,
        vb:text{ text = '1.- Select Groups :' , font = 'bold' } ,
    } ,
    vb:vertical_aligner {
      grcom ,
    }
  }

  local res = renoise.app():show_custom_prompt ( 'E2: Insert Groups per Combined Colors' , view , { 'Insert Gr' , 'Undo' , 'Cancel' } );
    if res == 'Insert Gr' then

         if grcom.value == 1 then gr_com01() end
         if grcom.value == 2 then gr_com02() end
         if grcom.value == 3 then gr_com03() end
         if grcom.value == 4 then gr_com04() end
         if grcom.value == 5 then gr_com05() end
         if grcom.value == 6 then gr_com06() end
         if grcom.value == 7 then gr_com07() end
    end

    if res == 'Undo' then combined_colors()
    end

end



function subgroups_combined()
  local vb = renoise.ViewBuilder()
  
    --local xxx_xx = vb:checkbox { }
    --local yyy_yy = vb:valuebox { min = 0 , max = 8 , value = 0 }
  local but_aq = vb:button   { active = false , width = 10 , height = 30 , color = { 0x1A,0x9A,0x8D } , tooltip = 'Aqua Color' }      --  1 Aqua aq
  local but_bk = vb:button   { active = false , width = 10 , height = 30 , color = { 0x24,0x24,0x24 } , tooltip = 'Black Color' }     --  2 Black bk
  local but_bl = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0x44,0xFF } , tooltip = 'Blue Color' }      --  3 Blue bl
  local but_br = vb:button   { active = false , width = 10 , height = 30 , color = { 0x99,0x4D,0x00 } , tooltip = 'Brown Color' }     --  4 Brown br
  local but_gl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xEF,0xA5,0x13 } , tooltip = 'Gold Color' }      --  5 Gold gl
  local but_gy = vb:button   { active = false , width = 10 , height = 30 , color = { 0x70,0x70,0x70 } , tooltip = 'Gray Color' }      --  6 Gray gy
  local but_gr = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0x99,0x19 } , tooltip = 'Green Color' }     --  7 Green gr
  local but_or = vb:button   { active = false , width = 10 , height = 30 , color = { 0xEE,0x70,0x00 } , tooltip = 'Orange Color' }    --  8 Orange or
  local but_pl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xE4,0xB1,0xC9 } , tooltip = 'Pale Pink Color' } --  9 Pale Pink pl
  local but_pn = vb:button   { active = false , width = 10 , height = 30 , color = { 0xE0,0x00,0x90 } , tooltip = 'Pink Color' }      -- 10 Pink pn
  local but_ps = vb:button   { active = false , width = 10 , height = 30 , color = { 0x70,0xEF,0x85 } , tooltip = 'Pistachio Color' } -- 11 Pistachio ps
  local but_rd = vb:button   { active = false , width = 10 , height = 30 , color = { 0xCC,0x00,0x00 } , tooltip = 'Red Color' }       -- 12 Red rd
  local but_sk = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0xDD,0xEE } , tooltip = 'Sky Blue Color' }  -- 13 Sky Blue sk
  local but_vl = vb:button   { active = false , width = 10 , height = 30 , color = { 0x81,0x00,0xEB } , tooltip = 'Violet Color' }    -- 14 Violet vl
  local but_wh = vb:button   { active = false , width = 10 , height = 30 , color = { 0xF1,0xF1,0xF1 } , tooltip = 'White Color' }     -- 15 White wh
  local but_yl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xD1,0xD1,0x00 } , tooltip = 'Yellow Color' }    -- 16 Yellow yl

  --local swi_cl = vb:switch   { items = { 'Aq' , 'Bk' , 'Bl' , 'Br' , 'Gl' , 'Gy' , 'Gr' , 'Or' , 'Pl' , 'Pn' , 'Ps' , 'Rd' , 'Sk' , 'Vl' , 'Wh' , 'Yl' } , width = 660 , height = 20 , value = 1 }
  local sgrcom = vb:popup { width = 440 , height = 24, value = 1, items = {
                                                                     'Combined 16 SubGroups x 2 Tracks' ,
                                                                     'Combined 16 SubGroups x 4 Tracks' ,
                                                                     'Combined 16 SubGroups x 6 Tracks' ,
                                                                     'Combined 16 SubGroups x 8 Tracks' ,
                                                                  }
                          }
  local view =
  vb:vertical_aligner {
    margin = 10 ,
    spacing = 0 ,
    vb:horizontal_aligner {
    mode = 'center' ,
    spacing = 0 ,    
      but_aq , but_bk , but_bl , but_br , but_gl , but_gy , but_gr , but_or , but_pl , but_pn , but_ps , but_rd , but_sk , but_vl , but_wh , but_yl ,
    } ,
    vb:horizontal_aligner {
      margin = 20
    },
    vb:horizontal_aligner {
      margin = 5 ,
        vb:text{ text = '1.- Select SubGroups :' , font = 'bold' } ,
    } ,
    vb:vertical_aligner {
      sgrcom ,
    }
  }

  local res = renoise.app():show_custom_prompt ( 'E3: Insert SubGroups per Combined Colors' , view , { 'Insert SGr' , 'Undo' , 'Cancel' } );
    if res == 'Insert SGr' then

         if sgrcom.value == 1 then sgr_com01() end
         if sgrcom.value == 2 then sgr_com02() end
         if sgrcom.value == 3 then sgr_com03() end
         if sgrcom.value == 4 then sgr_com04() end
    end

    if res == 'Undo' then combined_colors()
    end

end



function tracks_combined()
  local vb = renoise.ViewBuilder()
  
    --local xxx_xx = vb:checkbox { }
    --local yyy_yy = vb:valuebox { min = 0 , max = 8 , value = 0 }
  local but_aq = vb:button   { active = false , width = 10 , height = 30 , color = { 0x1A,0x9A,0x8D } , tooltip = 'Aqua Color' }      --  1 Aqua aq
  local but_bk = vb:button   { active = false , width = 10 , height = 30 , color = { 0x24,0x24,0x24 } , tooltip = 'Black Color' }     --  2 Black bk
  local but_bl = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0x44,0xFF } , tooltip = 'Blue Color' }      --  3 Blue bl
  local but_br = vb:button   { active = false , width = 10 , height = 30 , color = { 0x99,0x4D,0x00 } , tooltip = 'Brown Color' }     --  4 Brown br
  local but_gl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xEF,0xA5,0x13 } , tooltip = 'Gold Color' }      --  5 Gold gl
  local but_gy = vb:button   { active = false , width = 10 , height = 30 , color = { 0x70,0x70,0x70 } , tooltip = 'Gray Color' }      --  6 Gray gy
  local but_gr = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0x99,0x19 } , tooltip = 'Green Color' }     --  7 Green gr
  local but_or = vb:button   { active = false , width = 10 , height = 30 , color = { 0xEE,0x70,0x00 } , tooltip = 'Orange Color' }    --  8 Orange or
  local but_pl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xE4,0xB1,0xC9 } , tooltip = 'Pale Pink Color' } --  9 Pale Pink pl
  local but_pn = vb:button   { active = false , width = 10 , height = 30 , color = { 0xE0,0x00,0x90 } , tooltip = 'Pink Color' }      -- 10 Pink pn
  local but_ps = vb:button   { active = false , width = 10 , height = 30 , color = { 0x70,0xEF,0x85 } , tooltip = 'Pistachio Color' } -- 11 Pistachio ps
  local but_rd = vb:button   { active = false , width = 10 , height = 30 , color = { 0xCC,0x00,0x00 } , tooltip = 'Red Color' }       -- 12 Red rd
  local but_sk = vb:button   { active = false , width = 10 , height = 30 , color = { 0x00,0xDD,0xEE } , tooltip = 'Sky Blue Color' }  -- 13 Sky Blue sk
  local but_vl = vb:button   { active = false , width = 10 , height = 30 , color = { 0x81,0x00,0xEB } , tooltip = 'Violet Color' }    -- 14 Violet vl
  local but_wh = vb:button   { active = false , width = 10 , height = 30 , color = { 0xF1,0xF1,0xF1 } , tooltip = 'White Color' }     -- 15 White wh
  local but_yl = vb:button   { active = false , width = 10 , height = 30 , color = { 0xD1,0xD1,0x00 } , tooltip = 'Yellow Color' }    -- 16 Yellow yl

  --local swi_cl = vb:switch   { items = { 'Aq' , 'Bk' , 'Bl' , 'Br' , 'Gl' , 'Gy' , 'Gr' , 'Or' , 'Pl' , 'Pn' , 'Ps' , 'Rd' , 'Sk' , 'Vl' , 'Wh' , 'Yl' } , width = 660 , height = 20 , value = 1 }
  local trcom = vb:popup { width = 440 , height = 24, value = 1, items = {
                                                                     'Combined 16x 2 Tracks' ,
                                                                     'Combined 16x 4 Tracks' ,
                                                                     'Combined 16x 6 Tracks' ,
                                                                     'Combined 16x 8 Tracks' ,
                                                                 }
                         }
  local view =
  vb:vertical_aligner {
    margin = 10 ,
    spacing = 0 ,
    vb:horizontal_aligner {
    mode = 'center' ,
    spacing = 0 ,    
      but_aq , but_bk , but_bl , but_br , but_gl , but_gy , but_gr , but_or , but_pl , but_pn , but_ps , but_rd , but_sk , but_vl , but_wh , but_yl ,
    } ,
    vb:horizontal_aligner {
      margin = 20
    },
    vb:horizontal_aligner {
      margin = 5 ,
        vb:text{ text = '1.- Select Tracks :' , font = 'bold' } ,
    } ,
    vb:vertical_aligner {
      trcom ,
    }
  }

  local res = renoise.app():show_custom_prompt ( 'E4: Insert Tracks per Combined Colors' , view , { 'Insert Tr' , 'Undo' , 'Cancel' } );
    if res == 'Insert Tr' then

         if trcom.value == 1 then tr_com01() end
         if trcom.value == 2 then tr_com02() end
         if trcom.value == 3 then tr_com03() end
         if trcom.value == 4 then tr_com04() end
    end

    if res == 'Undo' then combined_colors()
    end

end




--== MENU =====================================

function rebuild_menu()
  local song, menu_entry = renoise.song(), 'Pattern Editor:Insert Groups & Tracks per Colors...'

  if renoise.tool():has_menu_entry(menu_entry) then renoise.tool():remove_menu_entry(menu_entry) end

  if (song.selected_track.type == renoise.Track.TRACK_TYPE_SEQUENCER) or (song.selected_track.type == renoise.Track.TRACK_TYPE_GROUP) then renoise.tool():add_menu_entry {
    name = menu_entry,
    invoke = function() all_colors() end
  }
  end
end

function start()
  renoise.song().selected_track_observable:add_notifier(rebuild_menu)
  rebuild_menu()
end

renoise.tool().app_new_document_observable:add_notifier(start)
